// WOCFOSP2.PRG -> EXPLORACIONES / TRATAMIENTOS ESPECIALES AFG / FIBRAS
#include "FiveWin.ch"
#include "Image.ch"

#define K_ESC   27
#define BTN_WIDTH  50   //45   //18
#define BTN_HEIGHT 18
#define TAB  ' - ' 
#define CRCR chr( 13 )
#define K_F5 (-34)
#define K_F7 (-36)
#define FW_NORMAL  400      
#define FW_BOLD    700

static oWnd, oClp

		// Variables propias imprescindibles en todos los fuentes
static mNombre  := ''
static mHistoria:= ''
static mPrimero := 0
static multimo  := 0
static mFechaNaci
static mfechaulti
static Date
static a10      := ''
static oBrush   := ''
//atic FileHelp := '' 
static SetAyuda := 0
static lMotivo  := .f., lAnsi := .f.
static oMenu
static nNivelacc:= 4
static nUsuario := 1
static cTitular         //:= "DR JUAN PLANELLES LAZAGA"
static contaajeno := ''
static cEleccion:= ''
static lVer := .f.
static lChek := .t.
static ColorDlg 
static ColorTxt
static cTitulo
static nExpl
static aValores
static Especial
static cBase
static cTitEsp
static nXpR := 0.862, nXpC := 1.34  // Correccion Says
static nXtR := 0.67  , nXtC := 1.16 // Correccion botones

//*******************************************************************
function Special2( nExp, cTit, Dat, mNom, mHis, oWn, CDlg, Ctxt, ;
						      mUlt, nAction, lVe )   
//*******************************************************************
Local aTit := {}, cVia
memvar cInd

DEFAULT lVe := .f.	// parametro de averiguar si hay archivados
lVer := lVe
//DEFAULT Especial := 0

Date      := Dat
mNombre   := mNom
mHistoria := mHis
oWnd      := oWn
ColorDlg  := CDlg
ColorTxt  := CTxt
mUltimo   := mUlt
cTitulo   := cTit
nExpl     := nExp 	//+ 10
aValores  := {}
Especial  := nAction

DO CASE

	CASE Especial == 2
		cBase := 'ANGIO'
		cInd  := 'ANGIO'
		cTitEsp := 'Angio de retina'

	CASE Especial == 3
		cBase := 'FIBRAS' 
		cInd  := 'FIBRAS'
		cTitEsp := 'Fibras ( Haz arciforme )'

	CASE Especial == 4
		cBase := 'PAFOTO'
		cInd  := 'PAFOTO'
		cTitEsp := 'Fotografia de Polo Anterior'

	CASE Especial == 5
		cBase := 'FOFOTO'  
		cInd  := 'FOFOTO'
		cTitEsp := 'Retinografias'
	
	CASE Especial == 6
		cBase := 'PALASER'
		cInd  := 'PALASER'
		cTitEsp := 'Laser de Polo Anterior'
		
	CASE Especial > 10
		cBase := 'DATOS' + PadL( AllTrim( Str( nExpl, 2 ) ), 02, '0' )
		cInd  := cBase
		aTit := Titulos( {} )
		cTitEsp := 'Datos Externos: ' + AllTrim( aTit[ nExpl ] )	// -10 ]

ENDCASE

if ( lVer )
	if File( cBase + ".DBF" ) .and. File( cBase + ".NTX" )
		usa_base( cBase, .f., "&cInd", 5, .t. )
		DbSeek( mHistoria )
		if (cBase)->Historia == mHistoria
		 ( cBase )->( DbCloseArea() )
		  Return IIF( SUBSTR( cBase, 1, 5 ) == "DATOS", "DATOS", cBase ) + " / " 
		else
		 ( cBase )->( DbCloseArea() )
		  Return "" 			
	  endif
  else
  	Return "" 
	endif
endif

		AngioFibras()
 		
Return nil
//---------

//***************************
static function AngioFibras()
//***************************
local nArea := SELECT(), cArea := ALIAS( nArea )
local aFTabla := {}

memvar cInd
 
	CreaAngio( cBase, Especial )

cInd := cBase

usa_base( cBase, .f., "&cInd", 5, .t. )
// Listado de archivo del paciente en curso ..
ListaAngio()
 
( cBase )->( DbCloseArea() )

   //DbSelectArea( cArea )

   Historic->( DbGoto( mUltimo ) )

return nil
//---------

//********************************
Function CreaAngio( cFile, Espec )
//********************************
local aDbf := {}, i := 0, cPrev, indPrev

memvar cInd
FIELD historia, fecha

Especial := Espec

cInd	 := cFile

/*
cInd := 'FIBRAS'

Do Case

Case cFile == 'ANGIO'
	cInd := 'ANGIO'
Case cFile == 'PAFOTO'
	cInd := 'PAFOTO'
Case cFile == 'FOFOTO'
	cInd := 'FOFOTO'
Case cFile == 'PALASER'
	cInd := 'PALASER'
Case cFile == 'FOPBRUSH'	// Llamado desde wocfosp3.prg
	cInd := 'FOPBRUSH'
Case cFile == 'PAPBRUSH'	// Llamado desde wocfosp3.prg
	cInd := 'PAPBRUSH'
Case cFile   := 'REMISION'
	cInd := 'REMISION'
OtherWise
// ..

EndCase
*/

//if Upper( cFile ) == 'REMISION'	// No se crea aqui la base de datos
//	return nil
//endif
i := iif( Especial > 9, 128, 30 )
/*if !File( cFile + '.dbf' )

	Do Case
	Case Especial == 11
		if File( 'PAPFOTO.DBF' )
			LZCopyFile( 'PAPFOTO.DBF',  'DATOS11.DBF' )
		endif
		if File( 'PAPFOTO.NTX' )
			LZCopyFile( 'PAPFOTO.NTX',  'DATOS11.NTX' )
		endif
	Case Especial == 12
		if File( 'FOFOTO.DBF' )
			LZCopyFile( 'FOFOTO.DBF',  'DATOS12.DBF' )
		endif
		if File( 'FOFOTO.NTX' )
			LZCopyFile( 'FOFOTO.NTX',  'DATOS12.NTX' )
		endif
	EndCase
endif
*/
if !File( cFile + '.dbf' )
	aadd( aDbf, { 'HISTORIA'  , 'C', 10, 0 } )
	aadd( aDbf, { 'FECHA'     , 'D', 08, 0 } )
	aadd( aDbf, { 'TECNICA'   , 'C', 10, 0 } )
	aadd( aDbf, { 'OJO'       , 'C', 02, 0 } )
	aadd( aDbf, { 'MOTIVO'    , 'C', 30, 0 } )
	aadd( aDbf, { 'NUMERO'    , 'C', 20, 0 } )
	aadd( aDbf, { 'DESCRIPCIO', 'C',  i, 0 } )

	   DbCreate( cFile, aDbf )

	usa_base( cFile, .t., '', 5, .t. )

	index on ( historia+dtos(fecha) ) to &cInd
	
	appe_reg( 5 )

	FieldPut( 03, iif( Especial == 2, 'AFG', iif( Especial > 9, ;
					AllTrim( cTitEsp ), 'Fibras' ) ) )
	FieldPut( 04, 'D ' )
	FieldPut( 05, iif( Especial == 2, 'Diabetes', ;
			iif( Especial > 9, 'Datos ..', 'Glaucoma' ) ) )
	if cFile == 'FOFOTO' .or. cFile == 'PAFOTO'	//Especial == 4
		FieldPut( 03, 'Foto color' )
		FieldPut( 05, 'Anomalia' )
	endif
	if cFile == 'PALASER'
		FieldPut( 03, 'Laser' )
		FieldPut( 05, 'Anomalia' )
	endif
	FieldPut( 06, 'DESDE Y HASTA..' )       //iif( Especial == 2, '16', '50' ) )
	FieldPut( 07, iif( Especial == 2, '', '' ) )
	if cFile == 'PAPBRUSH' .or. cFile == 'FOPBRUSH'	//Especial == 6
		FieldPut( 03, 'Disco ' )
		FieldPut( 05, 'Directorio' )
		FieldPut( 06, '' )
	endif

	desbloq()

	( cFile )->( DbCloseArea() )

else
		usa_base( cFile, .f., '', 5, .t. )
		iif( ( cFile )->( LastRec() ) == 0, appe_reg( 5 ), Nil )
		aDbf := ( cFile )->( DbStruct() )
 	        ( cFile )->( dbclosearea() )
	if "PBRUSH" $ cFile .and. aDbf[ 5, 3 ] < 30	// En estos = salva directorio
		usa_base( cFile, .t., '', 5, .t. )
		aDbf[ 5, 3 ] := 30		

                  if !( PreCopTot( cFile, 'Temp1', aDbf ) )
                        Return Nil
                  endif
/*                 COPY TO Temp1
		( cFile )->( DbCloseArea() )
		dbcreate( cFile, aDbf )
		usa_base( cFile, .t., "", 5, .t. )
		APPEND FROM Temp1
		FErase( 'TEMP1.DBF' )
 	        ( cFile )->( dbclosearea() )
*/
	endif

endif


if !File( cFile + '.ntx' )
	usa_base( cFile, .t., '', 5, .t. )
	index on ( historia+dtos(fecha) ) to &cInd
	( cFile )->( DbCloseArea() )
endif

return( nil )
//------------

//*******************************
static Function AngCreaLista( aVal )
//*******************************
FIELD Historia, fecha
aValores := aVal

set exact on
DbSeek( mHistoria )

   do While ( (cBase)->Historia ) == mHistoria .and. !Eof()
	aadd( aValores, { OemToAnsi( DTOC( (cBase)->Fecha ) ),;
			 OemToAnsi( (cBase)->Tecnica ),;
			 OemToAnsi( (cBase)->Ojo ),;
			 OemToAnsi( (cBase)->Motivo ),;
			 OemToAnsi( (cBase)->Numero ),;
			 OemToAnsi( (cBase)->Descripcio ), Recno() } )
	DbSkip()
   enddo

   if Empty( aValores )
	aadd( aValores, { iif( Especial == 2, '  ', '  ' ), ;
		'  ->      ', '  ', 'Paciente'+SPACE(12), space(20), ;
						'Sin datos archivados', 0 } )
   endif

Return aValores
//--------------

//**************************
       function ListaAngio()
//**************************
local aCampoNom := {}, oBrw, oDlAng, oFont
local aStru := (cBase)->(DbStruct()), aLen := {}, nRec := RecNo()
local nItem := 1, cTxT := '', lRead := .t.
local oBot1, oBot2, oBot3, oBot4, oBot5, oBot6, oBot7, oBot8, oBot9, oBot16
local nVal := iif( nExpl > 9, 10, 0 )
memvar cInd

AEVAL( aStru, { | aLong | aadd( aLen, aLong[ 3 ] + 3 ) }, 02 ) 

   aadd( aCampoNom, "Fecha" )
   aadd( aCampoNom, OemToAnsi( "Tcnica" ) )
   aadd( aCampoNom, OemToAnsi( "Ojo " ) )
   aadd( aCampoNom, OemToAnsi( "Motivo" ) )
   aadd( aCampoNom, OemToAnsi( "  Nm." ) )
   aadd( aCampoNom, OemToAnsi( "  Descripcin" ) )

   aValores := AngCreaLista( {} )

   DEFINE FONT oFont NAME 'Arial' SIZE 6, 13 BOLD

   DEFINE DIALOG oDlAng FROM 2, 3 TO 27, 79 ;
      TITLE OemToAnsi( "Gestin de Hoja Clnica de " + cTitEsp + ;
        ' - Moverse: Flechas, AvPg, RePg' ) ;   //OF oWnd
	COLOR ColorTxt, ColorDlg

   @ 2, 1 LISTBOX oBrw FIELDS   ;
	  aValores[ nItem, 1 ], aValores[ nItem, 5 ], ;
	  aValores[ nItem, 6 ], aValores[ nItem, 2 ], ;
	  aValores[ nItem, 3 ], aValores[ nItem, 4 ]  ;
	  HEADERS aCampoNom[1],aCampoNom[5],aCampoNom[6],;
		  aCampoNom[2],aCampoNom[3],aCampoNom[4] ;
    	  FIELDSIZES 65, 140, 240, 100, 25, 140 ;	
	  OF oDlAng SIZE 284, 138   FONT oFont

   oBrw:bGoTop    = { || nItem := 1 }
   oBrw:bGoBottom = { || nItem := Eval( oBrw:bLogicLen ) }
   oBrw:bSkip     = { | nWant, nOld | nOld := nItem, nItem += nWant,;
		nItem := Max( 1, Min( nItem, Eval( oBrw:bLogicLen ) ) ),;
		nItem - nOld }
   oBrw:bLogicLen = { || Len( aValores ) }
   oBrw:cAlias    = "Array"                // Just put something
/*
     @ 0.1, 13.1 BUTTON "Inde&xar" OF oDlAng ;
	SIZE 25, 12                     FONT oFont ;
	ACTION  ( ;
funindex( cBase, "historia+dtos(fecha)", "&cInd", 01, 01, oDlAng, 02, 01 ),;
	 usa_base( cBase, .f., "&cInd", 5, .t. ),;
	aValores := AngCreaLista( {} ), oBrw:Refresh(), oBrw:SetFocus() ) ; 
	MESSAGE 'Ayuda en Busqueda / Introduccion de pacientes..'
*/
     @ 0.1*nXtR, 0.2*nXtC BUTTON oBot1 PROMPT "A&yuda" OF oDlAng ;
	SIZE 25, 12                     FONT oFont ;
        ACTION  ( ;
            IIF( FILE( "WOCAYUDA.EXE" ), WAITRUN( "WOCAYUDA 29" ),;
         FwHelp( "HojaClin.txt" ) ), oBrw:SetFocus() ) ;
	MESSAGE 'Ayuda ..'
		oBot1:cToolTip := 'Ayuda en ...'

     @ 0.1*nXtR, 4.5*nXtC BUTTON oBot2 PROMPT "&Valores" OF oDlAng ;
	SIZE 25, 12                       FONT oFont ;
	ACTION ( nRec := Recno(), editspe2( oBrw, .f., ;
		{ '', '', '', '', '', '', 1 } , ;
	oDlAng, aCamponom ), DbGoto( nRec ), oBrw:Refresh(), oBrw:SetFocus() ) ;
	MESSAGE OemToAnsi( 'Modificar valores iniciales por omision .. ' )
		oBot2:cToolTip := 'Modificar valores iniciales por omision .. '
/*
     @ 0.1, 8.8 BUTTON oBot3 PROMPT "&Ver" OF oDlAng ;
	SIZE 25, 12                       FONT oFont ;
	ACTION  ( Aeval( aValores[ nItem ], { | c, n | ;
		cTxT += cValToChar( aValores[ nItem, n ] ) } ) , ;
	MemoEdit( cTxT, 1, 1, 17, 61, 'Datos del Registro', lRead ), ;
                        oBrw:SetFocus() ) ; 
	MESSAGE 'Ver datos del registro actual ..'
		oBot3:cToolTip := 'Ver Datos registro actual ..'
0.1,13.1
*/
     @ 0.1*nXtR, 8.8*nXtC BUTTON oBot16 PROMPT "&Copy" OF oDlAng ;
	SIZE 25, 12                       FONT oFont ;
		ACTION( Copiar( ), ;
			oBrw:SetFocus() );
		MESSAGE 'Importar/Exportar ..' 
      oBot16:cToolTip := 'Importar/Exportar ..'

      @ 14*nXtR,  1*nXtC BUTTON oBot4 PROMPT OemToAnsi( "&Nuevo" )    OF oDlAng          ;
	ACTION ( editspe2( oBrw, .t., aValores[ len( aValores ) ], oDlAng,;
      aCamponom ), if( aValores[ 1, 7 ] > 0, ( oBot5:Enable(), ;
		oBot5:Refresh(), oBot6:Enable(), oBot6:Refresh() ), ), ;
				oBrw:Refresh(), oBrw:SetFocus() ) ;
		MESSAGE OemToAnsi( 'Aadir nueva fecha a la lista..' ) ;
		 SIZE 40, 12    
		oBot4:cToolTip := OemToAnsi( 'Aadir nueva fecha a la lista..' )

   @ 14*nXtR,  8*nXtC BUTTON oBot5 PROMPT "&Editar" OF oDlAng  ;
	ACTION ( EditSpe2( oBrw, .f., aValores[ nItem ], oDlAng, aCamponom ), ;
				oBrw:Refresh(), oBrw:SetFocus() ) ;
	MESSAGE 'Editar la linea actual';
	SIZE 40, 12      
	if aValores[ 1, 7 ] == 0
		oBot5:Disable()
	endif
		oBot5:cToolTip := 'Editar la linea actual'

   @ 14*nXtR, 15*nXtC BUTTON oBot6 PROMPT "E&limina"  OF oDlAng   ;
     ACTION ( aValores := ;
	DelAngio( oBrw, aValores[ nItem, 7 ], aValores[ nItem, 1 ] ), ;
	aValores := AngCreaLista( {} ), oBrw:Refresh(), oBrw:SetFocus() ) ;
		MESSAGE 'Eliminar la linea actual';
		SIZE 40, 12     
	if aValores[ 1, 7 ] == 0
		oBot6:Disable()
	endif
		oBot6:cToolTip := 'Eliminar la linea actual'

      @ 14*nXtR,  22*nXtC BUTTON oBot7 PROMPT "Im&pr.Bmp"    OF oDlAng          ;
		ACTION PrnAngio( aCampoNom, aValores, cBase )           ;
		MESSAGE 'Imprimir la lista actual';
		SIZE 40, 12     
		oBot7:Disable()	// Se anula pues es repeticion
		oBot7:cToolTip := 'Imprimir la lista actual'

      @ 14*nXtR,  29*nXtC BUTTON oBot8 PROMPT "In&forme"    OF oDlAng    ;
                ACTION CreaAscMh1( 30 + Especial, cTitEsp, Date, ;
                mNombre, mHistoria, oWnd,, ColorDlg, ColorTxt, mUltimo ) ;
                 MESSAGE 'Crea un fichero de informe en disco';
		SIZE 40, 12
		oBot8:cToolTip := 'Crea un fichero de informe en disco'

   @ 14*nXtR, 36*nXtC BUTTON oBot9 PROMPT "&Salir"    OF oDlAng ;
		MESSAGE 'Salir de la lista a la ventana de exploracion en uso';
		SIZE 40, 12 ;
		ACTION  oDlAng:End() 
		oBot9:cToolTip := 'Salir de la lista ..'

   oDlAng:bRClicked := { | nRow, nCol, nFlags | ( if( !empty( mHistoria ), ;
		VerHist( mHistoria, mNombre ), ) ) }
   oDlAng:bLClicked := ;
	{ | nRow, nCol, nFlags | ( if( !empty( mNombre ), VerClient(), ) ) }

   ACTIVATE DIALOG oDlAng CENTERED
   
		// El area actual es paciente.dbf, se restituye  el
		// orden de indice abierto normalmente, el uno

   oFont:End()
   oWnd:Refresh()
   oWnd:oCursor(CursorArrow()) 

return( .t. )
//------------

//********************************************
static function DelAngio( oLbx, nRec, aFecha )
//********************************************

memvar cInd

if nRec < 2	// No borables, valores por omision y contador
	MsgStop( 'Registro: ' + AllTrim( str( nRec ) ) + CRLF + ;
		'Es reservado para uso ' + CRLF + 'interno del programa !..', 'Aviso !.' )
else
   if MsgYesNo( OemToAnsi( "Atencin:" ) + CRLF + ;
		OemToAnsi( " Est seguro de " + ;
		"querer borrar este registro?" ) + CRLF + CRLF + ;
		"REGISTRO:    " + aFecha, 'Elija una opcin.' )

      (cBase)->( DbCloseArea() )
      usa_base( cBase, .t., "&cInd", 5, .T. )

      DbGoto( nRec )
      DbDelete()
      HB_DBPACK()  // PACK

      (cBase)->( DbCloseArea() )
      usa_base( cBase, .F., "&cInd", 5, .T. )
	
   endif
endif

return aValores
//---------

//***************************************************************
static function EditSpe2( oLbx, lAppend, aEdit, oDlAng, aCamponom )
//***************************************************************
   local oDlAngE, i, aSav := aEdit, cMemo
   local lSave := .f., cTecn := '...', oG1

do case
case Especial == 2
	cTecn := 'AFG,  AIVI, ..'
case Especial == 3
	cTecn := 'Aneritra ..'
case Especial == 4
	cTecn := 'Retinografia color, aneritra, ..'
OtherWise
	cTecn := 'Datos ..'
endcase
//   DEFAULT lAppend := .f.

   if aEdit[ 7 ] == 0   // Valores por omision del primer registro paciente
	DbGoTo( 1)
   else 
	DbGoto( aEdit[ 7 ] )
   endif

	aEdit := {}
	aadd( aEdit, ( (cBase)->Fecha ) )
	aadd( aEdit, OemToAnsi( (cBase)->Tecnica ) )
	aadd( aEdit, OemToAnsi( (cBase)->Ojo ) )
	aadd( aEdit, OemToAnsi( (cBase)->Motivo ) )
	aadd( aEdit, OemToAnsi( (cBase)->Numero ) )
	aadd( aEdit, OemToAnsi( (cBase)->Descripcio ) )
	aadd( aEdit, (cBase)->(Recno())  )
	aEdit[ 1 ] := iif( ( lAppend ), Date, aEdit[ 1 ] )
	aEdit[ 1 ] := CTOD(OemToAnsi( DTOC( aEdit[ 1 ] ) ) )
	// Se corrige la fecha a hoy si es aadiendo nuevo ..
   
   DEFINE DIALOG oDlAngE FROM 0, 0 TO 11, 78 ;
      TITLE If( lAppend, "Nuevo Registro", "Modifique Registro" )
   //     OF oWnd

   @ 00, 01*nXpC SAY "Fecha" OF oDlAngE
   @ 00, 08*nXpC SAY OemToAnsi( "Tcnica" ) OF oDlAngE
   @ 00, 17.5*nXpC SAY OemToAnsi( "Ojo" ) OF oDlAngE
   @ 00, 22*nXpC   SAY OemToAnsi( "Motivo" ) OF oDlAngE
   @ 2*nXpR , 01*nXpC SAY OemToAnsi( "Descripcin" + ;
	iif(  Especial > 9, ':  ( 128 caracteres .. )', '' ) ) OF oDlAngE
   @ 02*nXpR, 22*nXpC SAY OemToAnsi( "Nm. en archivo" ) OF oDlAngE

   @ 0.8,  01  GET aEdit[ 1 ] OF oDlAngE SIZE 40, 12 ;
	MESSAGE 'Ponga la fecha en formato:  DD/MM/AAAA'

   @ 0.8,   8  GET aEdit[ 2 ] OF oDlAngE  SIZE 60, 12 ;
	MESSAGE 'Ponga  TECNICA que va a desarrollar, p. ej.: ' + cTecn

   @ 0.8,  17.5  GET aEdit[ 3 ] OF oDlAngE PICTURE '@!' SIZE 20, 12 ;
	MESSAGE 'Ponga Ojo a explorar:  D  /  I  /  AO'

   @ 0.8,  22  GET aEdit[ 4 ] OF oDlAngE PICTURE '@!' SIZE 120, 12       ;
	MESSAGE ;
	OemToAnsi('Ponga el Motivo de esta exploracin ..')

   @ 2.8,  22  GET aEdit[ 5 ] OF oDlAngE SIZE 120, 12       ;
	MESSAGE OemToAnsi('Ponga el Nmero en formato Digitos y signos.')

if Especial > 9	
	cMemo := aEdit[ 6 ]
   @ 2.8,   1  GET oG1 VAR cMemo MEMO OF oDlAngE SIZE 160, 24 ;
	MESSAGE OemToAnsi('Ponga el teclado en maysculas .. ') ;
        VALID (  IIF( Len( Trim( cMemo ) ) > 128, ;
			( MsgInfo( 'Texto Memo ' + CRLF + ;
					'Longitud excesiva..', 'Informacin.' ),;
                cMemo := ValidaMemo( cMemo, 64, 2 ) ), nIL  ), ;
                aEdit[ 6 ] := Trim( cMemo ), oG1:Refresh() ) 
	oG1:cToolTip := 'Longitud = 128 caracteres ..'
	oG1:bGotFocus := {|| oG1:SetSel( 0, 0 ) }
  	
else
   @ 2.8,   1  GET aEdit[ 6 ] OF oDlAngE PICTURE '@!' SIZE 160, 12        ;
	MESSAGE OemToAnsi('Ponga el teclado en maysculas .. ')

endif

   @ 5.5*nXtR, 13*nXtC BUTTON "&Aceptar"  OF oDlAngE SIZE 50, 12 ;
				ACTION ( ( lSave := .t. ) , oDlAngE:End() ) ;
	MESSAGE 'Archivar los valores actuales'

   @ 5.5*nXtR, 23*nXtC BUTTON "&Cancelar" OF oDlAngE SIZE 50, 12 ;
				ACTION  oDlAngE:End() ;
				MESSAGE 'Salir sin archivar'   

   ACTIVATE DIALOG oDlAngE CENTERED

   oDlAngE:Destroy()    

   IF lSave

      if ( lAppend )
	appe_reg( 5 )
      else
	Bloq_reg( 5 )
      endif

      aEdit[ 1 ] := CTOD(AnsiToOem( DTOC( aEdit[1] ) ))
      aEdit[ 2 ] := AnsiToOem( aEdit[ 2 ] )
      aEdit[ 3 ] := AnsiToOem( aEdit[ 3 ] )
      aEdit[ 4 ] := AnsiToOem( aEdit[ 4 ] )
      aEdit[ 5 ] := AnsiToOem( aEdit[ 5 ] )
      aEdit[ 6 ] := AnsiToOem( aEdit[ 6 ] )

      if RecNo() > 1
	   FieldPut( 1, mHistoria )
	   FieldPut( 2, aEdit[ 1 ] )
      else
	   FieldPut( 1, space(10) )
	   FieldPut( 2, CtoD( '' ) )
      endif

      for i := 3 to 7
	fieldput( i, aEdit[ i-1 ] )
      next

	DbCommitAll()
	DesBloq()

	aValores := {}

	set exact on
	DbSeek( mHistoria )
	aValores := AngCreaLista( {} )

   endif

return aValores
//--------------

//*************************************
static Function sVAng( aEdit, lAppend )
//*************************************
local I

      if ( lAppend )
	appe_reg( 5 )
      else
	Bloq_reg( 5 )
      endif

      aEdit[ 1 ] := CTOD(AnsiToOem( DTOC( aEdit[1] ) ))
      aEdit[ 2 ] := AnsiToOem( aEdit[ 2 ] )
      aEdit[ 3 ] := AnsiToOem( aEdit[ 3 ] )
      aEdit[ 4 ] := AnsiToOem( aEdit[ 4 ] )
      aEdit[ 5 ] := AnsiToOem( aEdit[ 5 ] )
      aEdit[ 6 ] := AnsiToOem( aEdit[ 6 ] )

      if RecNo() > 1
	   FieldPut( 1, mHistoria )
	   FieldPut( 2, aEdit[ 1 ] )
      else
	   FieldPut( 1, space(10) )
	   FieldPut( 2, CtoD( '' ) )
      endif

      for i := 3 to 7
	fieldput( i, aEdit[ i-1 ] )
      next

	DbCommitAll()
	DesBloq()

	aValores := {}

	set exact on
	DbSeek( mHistoria )
	aValores := AngCreaLista( {} )

return .t.
//---------
//*************************************************
Function VerAngio( oAsc, oWn, cHis, cNom, nAction, lVal )
//*************************************************
   local aEl, cLinea, aBase := { '', 'Angio', 'Fibras', 'PaFoto', ;
				'FoFoto', 'PaLaser' }

local cBase := iif( nAction > 10, ;
	'DATOS' + PadL( AllTrim( Str( nExpl, 2 ) ), 02, '0' ), ;
							aBase[ nAction ] )

lAnsi     := lVal   
oWnd      := oWn
mHistoria := cHis
mNombre   := cNom

dbselectarea( cBase )

if DbSeek( mHistoria ) // Si hay archivados datos ..

	      cLinea := ''
              oAsc := CreaLine( oAsc, cLinea )

	Do While (cBase)->Historia == mHistoria .and. !Eof()

	  cLinea := "Fecha: " + DTOC( (cBase)->Fecha ) + TAB + ;
			"Tcnica: " +  (cBase)->Tecnica + TAB + ;
			"Ojo: " + (cBase)->Ojo    + TAB + ;
		   	" - Motivo: " + (cBase)->Motivo
              oAsc := CreaLine( oAsc, cLinea ) 
	  cLinea := "Nmero: " + (cBase)->Numero + TAB + ;
			"Descripcin: " + (cBase)->Descripcio
              oAsc := CreaLine( oAsc, cLinea ) 
          cLinea := ''
              oAsc := CreaLine( oAsc, cLinea ) 

	      DbSkip()
	enddo

endif

return oAsc
//----------
Static Function Crealine( oAsc, cLinea )

// sep 08 ansi
cLinea := iif( lAnsi, OemToAnsi( cLinea ), cLinea )
// 2008 ascii se crea en oem
oAsc:Add( cLInea )

return oAsc
//----------------------------------------------------------------------------//

//Recibe: via omision del programa, y via omision en uso actual
	// y ambas con el nombre del archivo ..QUE TIENE QUE SER EXISTENTE
//y cBase para el nombre de subdir por omision, creado .., Y letra A, P, F
//Envia : Unidad, via archivo actualizada, y Validacion .t./.f.
//*****************************************************
function MenuViaFile( cViaIni, cViaUso, cBase, Letra  )
//*****************************************************
   local nValue := 3, oRad, oWnd2, oBot1, oBot2
   local lValor := .f., aDrvs := aDrives()
   local bValidGet, cCurDrive := HB_CurDrive()
   local cDirDef := cCurDrive + ':\' + CurDir()
   local cFile := cFileName( cViaUso ), bFile
   local cPath := '\' + CurDir() + '\', cViaNueva := ''
   local cPathTip := cPath + cBase + '\', CtX, lValid := .f.
   local cDisc, lDisc, bDisc, cViaUs2 := cViaUso

   DEFAULT Letra := 'X'
// Bloque de rellenar a mano ..

bValidGet := { ||  Eval( bDisc ), cViaUso := AllTrim( cViaUso ), ;
           iif( Right( Trim( cViaUso ), 01 ) != '\', ;
               cViaUso := Trim( cViaUso ) + '\', Trim( cViaUso ) ), ;
    lValid := iif( lIsdir( Left( cViaUso, Len( cViaUso )-1 ) ), .t., .f. ),;
         iif( !lValid, lvalid := ;
         iif( MsgYesNo( Left( cViaUso, Len(cViaUso)-1 ) + CRLF + ;
          'NO accesible, o' + CRLF + ;             
          'NO es un Directorio ! ..' + CRLF + CRLF +;
          'Desea CREARLO?.', 'Elija una opcin.' ) .and. ;
               lMkDir( Left( cViaUso, Len(cViaUso)-1 ) ), .t., .f. ) ;
          , nIL ), ;
    lValid := lIsdir( Left( cViaUso, Len( cViaUso )-1 ) ),;
         lChDir( cDirDef ) }

// Bloque de elegir desde win ..                               
bFile := { || cViaUso := cGFile( AllTrim( cFile ), Letra, ;
				'Elija Via de Archivo ..' ) }

// Bloque validar unidad
bDisc := { || ;
cDisc := cFileDisc( cViaUso ),;
cDisc := iif( Empty( cDisc ), cCurDrive, cDisc ),;
cDisc := iif( Len( cDisc ) > 1, Left( cDisc, 1 ), cDisc ),;
cDisc := iif( Upper( cDisc ) $ 'ABCDEFGHIJKLMNOPQRSTUVXYZ', ;
                Upper( cDisc ), cCurDrive ),;
   iif( ASCAN( aDrvs, { |x| Upper( Trim( x ) ) == cDisc + ":" } ) > 0, Nil, ;
        MsgAlert( 'La UNIDAD  ' + cDisc + ':' + CRLF + ;
                        'No Existe o No esta CONECTADA !.', 'Atencin !.' ) ) }
//MsgList( aDrives() )

   DEFINE DIALOG oWnd2 FROM 01, 01 TO 13, 65 ; 
      TITLE "Elija, por favor .." COLOR "N/W"

   @ 0.5*nXtR, 1*nXtC BUTTON oBot1 PROMPT "&Aceptar" SIZE 50, 10 OF oWnd2 ;
      ACTION oWnd2:End()
			
   @ 0.5*nXtR, 10*nXtC BUTTON oBot2 PROMPT "E&xaminar" SIZE 50, 10 OF oWnd2 ;
      ACTION ( oWnd2:Hide(), cViaUs2 := cGetDir(), ;
        cViaUso := iif( !Empty( cViaUs2 ), Trim(cViaUs2) + '\' , cViaUso ),;
                oWnd2:End() )
			
   @ 1.5,  1 TO 6, 30 LABEL "Via Archivo: " OF oWnd2
   @ 2.3, 2 RADIO oRad VAR nValue OF oWnd2 ;
      PROMPT "&Escribir Via de Archivo ..", ;
	"&Restablecer Via del programa", "&Seguir Via actual"

   ACTIVATE DIALOG oWnd2 CENTER 

Do Case
// Por nivel de anidamiento de ventanas, da error de pila, IMPOSIBLE EVITAR
// Se sustituye por llamada a elegir via en boton 1 nivel antes

Case nValue == 1
 
	Do While !lValid
	   cViaUso := Left( cFilePath( cViaUso ) + Space(30), 90 ) 
	   if MsgGet( 'Via de Archivo', ;
		'Por Ej.: ' + Upper( cDirDef ) + '\', @cViaUso, ;
					".\bitmaps\Archivo.bmp" )
		lValid := .t.
	   else
		lValid := .f.
	        Exit
	   endif
                Eval( bValidGet )
	EndDo

Case nValue == 2        //3
	cViaUso := cViaIni
	lValid := !Empty( cViaUso )

Case nValue == 3	//4
	lValid := !Empty( cViaUso )
	// ...

OtherWise
	// ...

EndCase

//Eval( bDisc )
cViaUso := Trim( cFilePath( SubsTr( cViaUso, at( ':', cViaUso ) +1 ) ) )
cViaUso := iif( Left( cViaUso, 1 ) == '\', '', '\' ) + cViaUso

cViaUso := cFilePath( cViaUso )
cViaUso := SubsTr( cViaUso, at( ':', cViaUso ) +1 )
cViaUso := Trim( cViaUso )

if lvalid
	Eval( bValidGet )
endif

return { cDisc, cViaUso, lValid }
//------------

function imprimirbmp(Bmp,oBmp)
local oPrn
local nZoom:=oBmp:Zoom()
local anchura:=oBmp:nWidth()*nZoom
local altura :=oBmp:nHeight()*nZoom


PrnBmp( Bmp, oBmp )
/*
PRINT oPrn NAME "IMAGEN" PREVIEW
   PAGE
      oPrn:SayImage(0,0,obmp,anchura*4,altura*4)
//      oPrn:SayBitmap(0,0,bmp,anchura*4,altura)
   ENDPAGE
ENDPRINT
*/
return nil

Function DefImage( Bmp )
Return TImage():Define( , Bmp )

   //@ 4, 2 BUTTONBMP oBtnBmp OF oWnd ACTION MsgInfo( "XP themes aware Button Bitmaps" ) ;
   //   BITMAP ".\bitmaps\16x16\garrow.bmp" PROMPT "Test" TEXTRIGHT SIZE 80, 25 ;
   
function zMsgList( aData, cTitle, nTop, nLeft, nBottom, nRight, cBtnTitle, ColorDlg, ColorTxt, ;
				nUs, oWn )

   local oFont, oDlg, oLst, oBtnClose, oWIco, aNum := {}, lResize := .f., bSize
   local nItem, oBtnCancel, lSel := .f., cFCoors, aCoors, aCoors2, cMemoCoors
   local oBtnFont, aTypes, aFon, cFon, bParamFont, FlbxColr, bSelf, bColrSave, bColrLoad, ;
   	bFntSave, bFntLoad, bMasmeno, nColor, cExt, FlbxFont, nOpc, lFontSave := .t., bBotF
  DEFAULT nUs := 1
  
  oWnd := oWn
  nUsuario := nUs 	
      cExt := PADL( AllTrim( str( nUsuario, 3 ) ), 3, "0" )
  nColor := ColorTxt    
   if aData == nil .or. len(aData) = 0
      MsgStop("Parametro incorrecto pasado a la funcion zMsgList")
      return nil
   endif
    nItem := 0
   //              9           9             22            68.5
   DEFAULT nTop := 09, nLeft := 9, nBottom := 22, nRight := 68,;
           cTitle := "Array list", cBtnTitle := "&OK"
//---------------------Coordenadas-------------------------
// Guardar coordenadas..
// Estas son las originales del DIALOGO
aCoors := { 9, 9, ;
             22, ; 
             68.5 ; 
               }

 cFCoors := 'UCoords.' + cExt
   
 aCoors2 := aCoors       // respaldo para el reset

MemoWrit( 'UCoords.000',  Str( aCoors[ 1 ], 10, 2 ) + CRLF + ;
 Str( aCoors[ 2 ], 10, 2 ) + CRLF + Str( aCoors[ 3 ], 10, 2 ) + CRLF + ;
                                Str( aCoors[ 4 ], 10, 2 ) )

cMemoCoors := Trim( MemoRead( cFCoors ) )
//? MLCount( cMemoCoors )
If MLCount( cMemoCoors ) == 4
    // Valor valido
else // En caso de error, valor original.. q s  establece en cada entrada
   cMemoCoors :=  MemoRead( 'UCoords.000' )
Endif

aCoors[ 1 ] := Val( TRIM( Memoline( cMemoCoors,, 1 ) ) )
aCoors[ 2 ] := Val( TRIM( Memoline( cMemoCoors,, 2 ) ) )
aCoors[ 3 ] := Val( TRIM( Memoline( cMemoCoors,, 3 ) ) )
aCoors[ 4 ] := Val( TRIM( Memoline( cMemoCoors,, 4 ) ) )

// Correcciones..
aCoors[ 3 ] := iif( aCoors[ 3 ] < aCoors[ 1 ], aCoors[ 1 ] + 20, aCoors[ 3 ])
aCoors[ 4 ] := iif( aCoors[ 4 ] < aCoors[ 2 ], aCoors[ 2 ] + 20, aCoors[ 4 ])
//? aCoors[1], aCoors[2], aCoors[3], aCoors[4]
Iif( aCoors[ 1 ] < 0, ( aCoors[ 3 ] += Abs( aCoors[ 1 ] ), aCoors[ 1 ] := 0 ), Nil )
Iif( aCoors[ 2 ] < 0, ( aCoors[ 4 ] += Abs( aCoors[ 2 ] ), aCoors[ 2 ] := 0 ), Nil )

//msglist( acoors, "hola" )
//-------------------Fin Coordenadas-----------------------
//-----------------------Fonts----------------------------
//DEFINE FONT oFont NAME GetSysFont() SIZE 0, -8 BOLD
FLbxColr := 'ZMSGColr.' + cExt
  bColrLoad:= {|| nColor := Val( AllTrim( Memoread( FLbxColr ) ) ) }                     
  Eval( bColrLoad )
  bColrSave := {|| MemoWrit( FLbxColr, AllTrim( Str( nColor ) ) ) }
  DEFINE FONT oFont NAME 'Arial' SIZE 0, -12 BOLD
// Objeto TFont Nuevo, con los datos del array aFont leidos de ChooseFont()
bParamFont := {|| iif( oFont != Nil, oFont:End(), Nil ), ;
                oFont := TFont():New( aFon[14],;
		aFon[02],      aFon[01], .f.,   ;
                ! ( aFon[05] == FW_NORMAL ),      aFon[03],    ;
		aFon[04],      aFon[05],        ;
		aFon[06],      aFon[07],     ;
		aFon[08],      aFon[09],       ;
		aFon[10],      aFon[11], ;
		aFon[12] )      }

// Llamar a ChooseFont con un Font por omision, y obtener array de sus datos

//aTypes := { -12, 0, 0, 0, 700, .t., .f., .f., 0, 3, 2, 1, 0, 'System' }
//  aTypes := { -12, 0, 0, 0, 700, .t., .f., .f., 0, 0, 0, 0, 0, 'Omision' }
  aTypes := { 14, 5, 0, 0, 700, .f., .f., .f., 0, 0, 0, 0, 0, 'Arial' }
FLbxFont := 'ZMSGFONT.' + cExt

// Se varia el tamao
bMasMeno := {| n |  aFon[01] := iif( aFon[01] < 0, -( Abs( aFon[01] ) + ( n ) ), ;
											aFon[01] + ( n ) ),	aFon[02] := iif( ABS( aFon[02] + ( n/5 ) ) > 2, ;
											aFon[2], aFon[02] + ( n/5 ) ) , aFon[04] := 0, ;
                Eval( bFntSave ), Eval( bFntLoad ),;
        oLst:SetFont( oFont ), ;
                  SysRefresh() }

// Aqui los info afean mucho y se pasan a Nil para no tocar el codigo
bFntSave := {|| iif( lFontSave, ;
	( cFon := '',             ;
        iif( len(aFon)==13, aadd( aFon, 'Arial' ), ;
                aFon[14]:=iif( empty(aFon[14]),'Arial',aFon[14] ) ), ;
        aEval( aFon, { | c, n | cFon += cValToChar( c ) + CRLF } ), ;
        iif( ! MemoWrit( FLbxFont, cFon ), ;
                Nil, Nil ),  cFon := '' ), Nil )  }

bFntLoad := {|| cFon := Memoread( FLbxFont ), ;
		Iif( MLCount( cFon ) > 0, ;
                ( aFon := Array( 14 ), ; 
        aEval( aFon, { | c, n | aFon[n] := AllTrim(Memoline( cFon,, n )), ;
  aFon[n] := uCharToVal( AllTrim( aFon[n] ), aTypes[n] ) } ) ), ;
                                                        aFon := aTypes ),;
		iif( !Empty( aFon ), Eval( bParamFont ), Nil ) }

Eval( bFntLoad )
Eval( bColrLoad )                               
    bSelF :=  {||;
                  iif( File( FLbxFont ) .and. ;
		xMsgNoYes( 'Restablecer Font por omision ' + CRLF + ;
		'del programa?.', 'Elija una opcin' ), ;
                (     Ferase( FLbxFont ), ;
       oLst:SetFont( oFont ) ),;
		( iif( !File( 'WocGest.Exe' ), ;
	MsgStop( 'Modulo: ' + 'WocGest.Exe' + CRLF + 'NO encontrado ' + ;
                        CRLF + 'para Font !.', 'Aviso !.' ), ;
                 ( WaitRun( 'WocGest' + ' ' + FLbxFont  ), ;
        oLst:SetFont( Eval( bFntLoad ) ) ) ) ) ), ;
          oLst:Refresh()  }
  
    bBotF := {|| nOpc := Alert2( '[Esc]->Salir;Elija ..', {"Font -","Font +","&Elegir", "&Salir"}, ;
                                'Modificar el Font' ), ;
         iif( nOpc == 3, Eval( bself ), ;
                        Eval( bMasMeno, iif( nOpc == 1, ( -1 ), iif( nOpc == 2, 1, 0 ) ) ) ),;
                        oLst:SetColor( Eval( bColrLoad ), CLR_WHITE ),;
                        Eval( bFntLoad ),;
             oLst:SetFont( oFont ),;            
           oLst:Refresh(), ;
           iif( nOpc > 0 .and. nOpc < 4, Eval( bBotF ), oLst:SetFocus() ) }

//MsgList( aGetWorkAreas() )
//-----------------------fin font-----------------------

   //DEFINE FONT oFont NAME GetSysFont() SIZE 0, -8 BOLD
   
   DEFINE ICON oWIco FILE "WOCUL3.ico" //FONT oFont            
   DEFINE DIALOG oDlg FROM aCoors[1], aCoors[2] TO aCoors[3], aCoors[4] OF oWnd ;
      TITLE cTitle  COLOR ColorTxt, ColorDlg ICON oWIco ;
      STYLE nOr(WS_POPUP, WS_CAPTION, WS_BORDER, WS_THICKFRAME, WS_MAXIMIZEBOX)
//      STYLE nOr(WS_POPUP, WS_CAPTION, WS_BORDER, WS_SYSMENU, WS_THICKFRAME, WS_MAXIMIZEBOX)    
  
   @ 0, 0 LISTBOX oLst VAR nItem ITEMS aData OF oDlg PIXEL SIZE 100, 100 ;
   FONT oFont	COLOR nColor, CLR_WHITE
   oLst:bLDblClick := {|| lSel := .t., oDlg:End() }
   
   @ 78, 24 BUTTONBMP oBtnFont SIZE 36, 10 PIXEL ;
      ACTION ( Eval( bBotF ), oDlg:Refresh(), oLst:Refresh() ) PROMPT "&Font"
      
   @ 78, 176 BUTTONBMP oBtnClose  DEFAULT SIZE 36, 10 PIXEL ;
      ACTION ( lSel := .t., oDlg:End() ) PROMPT cBtnTitle 

   @ 78, 100 BUTTONBMP oBtnCancel  SIZE 36, 10 PIXEL ;
      ACTION oDlg:End() PROMPT "&Cancelar"
      
     bSize := {|| ;
     oLst:SetSize( oDlg:nWidth() - 10, oDlg:nHeight() - iif(LargeFonts(), 79, 69) ),;
                        oBtnFont:nTop    := oDlg:nHeight() - iif(LargeFonts(), 68, 58),;
                        oBtnFont:nLeft   := oDlg:nWidth() -  259 ,;      
                        oBtnClose:nTop    := oDlg:nHeight() - iif(LargeFonts(), 68, 58),;
                        oBtnClose:nLeft   := oDlg:nWidth() -  87 ,;
												oBtnCancel:nTop    := oDlg:nHeight() - iif(LargeFonts(), 68, 58),;
                        oBtnCancel:nLeft   := oDlg:nWidth() -  173, oLst:Refresh(), oDlg:Refresh() }
  
   oDlg:cToolTip := "Selecc.: Intro, DblClick Izq., Aceptar"
   oLst:cToolTip := "Selecc.: Intro, DblClick Izq., Aceptar"
  
   oDlg:bResized := {|| lReSize := .t., Eval( bSize ) }
 //NO funciona y hay q ponerla centered, como fwmemo
 //  oDlg:bMMoved := {|| lReSize := .t., oDlg:CoorsUpdate() }
    
   ACTIVATE DIALOG oDlg CENTERED ON PAINT Eval( bSize ) ;
    VALID ( iif( lReSize, MemoWrit(  cFCoors,  Str( oDlg:nTop/16, 10, 2 ) + ;
                     CRLF + Str( oDlg:nLeft/8, 10, 2 ) + CRLF + ;
                Str( oDlg:nBottom/16, 10, 2 ) + CRLF + ;
             Str( oDlg:nRight/8, 10, 2 ) ), Nil ), ;
              .t. ) 

/*
   oDlg:bMMoved := {|| oDlg:CoorsUpdate(), ;
             MemoWrit(  cFCoors,  Str( oDlg:nTop/16, 10, 2 ) + ;
                     CRLF + Str( oDlg:nLeft/8, 10, 2 ) + CRLF + ;
                Str( oDlg:nBottom/16, 10, 2 ) + CRLF + ;
             Str( oDlg:nRight/8, 10, 2 ) ) }
 
   */
   oFont:End()

return iif( lSel, nItem, 0 ) // solo elige con intro, dobleclic izq o aceptar