 // WOCFUN.PRG
#include "FiveWin.ch"
#include "Report.ch"
//#include "InKey.ch"
#include "Fget.ch"
#include "GTF.ch"


//#define K_ESC   27
#define BTN_WIDTH  50   //45   //18
#define BTN_HEIGHT 18
//#define CRCR chr( 13 )
//#define K_F5 (-34)
//#define K_F7 (-36)

#define PADCHAR   Chr( 32 )
	
static oWnd, oClp, oMeter

		// Variables propias imprescindibles en todos los fuentes
static mNombre  := ''
static mHistoria:= ''
static mPrimero := 0
static multimo  := 0
static mFechaNaci
static mfechaulti
static Date
static a10      := '', cValW := ""
static oBrush   := ''
//atic FileHelp := '' 
static SetAyuda := 0
static lMotivo  := .f.
static oMenu
static nNivelacc:= 4
static nUsuario := 1
static cTitular         //:= "DR JUAN PLANELLES LAZAGA"
static contaajeno := ''
static cEleccion:= '', cMant := ''
static nMant := 0
static cLista := ''
static lChek := .t.
static lCancel := .f.
static ColorDlg 
static ColorTxt
static nXpR := 0.862, nXpC := 1.34  // Correccion Says
static nXtR := 0.66  , nXtC := 1.16 // Correccion botones

//*******************************
function HelpFun( nExpl, nNivel )
//*******************************
local aFileHelp, SetAyuda, n := 0
local cDosFile, aFile := {}

DEFAULT nExpl  := 0
DEFAULT nNivel := 0

nExpl      := Iif( ValType( nExpl ) != 'N', 0, nExpl )
SetAyuda   := nExpl

do case

case SetAyuda == -20                    // Busqueda introd de pacientes
	aFileHelp := { 'BUSQUEDA' }     

case SetAyuda == -9 .or. SetAyuda == -10 // Tt automatico y protocolos
	aFileHelp := { 'PROTOCOL' }     

case SetAyuda == -8                     // Analisis y expl. complementarias
	aFileHelp := { 'ANALISIS' }     

case SetAyuda == -7                     // Carta de remision a otro centro
	aFileHelp := { 'CARTA' }        

case SetAyuda == -6                     // Receta de medicamentos   
	aFileHelp := { 'RECETA' }       

case SetAyuda == -5                     // Escrito libre            
	aFileHelp := { 'ESCRITO' }      

case SetAyuda == -4                     // Informe reducido manual  
	aFileHelp := { 'INFORMES' }     

case SetAyuda <=-1 .and. SetAyuda >= -3 // Antecedentes pres fam obs
	aFileHelp := { 'ANTECED' }      
/*
case SetAyuda == 0                      // Menu inicial del programa
	aFileHelp := { 'OCULC' }        
	If !File( 'OCULC.WLP' ) .and. File( 'OCULC.DOC' )
		LZCopyFile( 'OCULC.DOC', 'OCULC.WLP' )
	EnDif
*/
case SetAyuda == 0.5                    // Motivo de consulta           
	aFileHelp := { 'Motivo' }       

case SetAyuda >= 1 .and. SetAyuda <= 14 // Textos de exploraciones

	Do Case
	Case SetAyuda == 3
		Do Case
		Case nNivel == 0
			aFileHelp := { 'Explorac' }
		Case nNivel == 1
			aFileHelp := { 'Graduar' }
		Case nNivel == 2
			aFileHelp := { 'Correcci' }
		Case nNivel == 3
			aFileHelp := { 'Lentilla' }
		Case nNivel == 4
			aFileHelp := ;
			{ 'Explorac', 'Correcci', 'Graduar', 'Lentilla' }
		EndCase
	Case SetAyuda == 4
		Do Case
		Case nNivel == 0
			aFileHelp := { 'Explorac' }
		Case nNivel == 1
			aFileHelp := { 'Pio' }
		Case nNivel == 2
			aFileHelp := { 'Explorac', 'Pio' }
		EndCase
	OtherWise
		aFileHelp := { 'EXPLORAC' }
	EndCase

OtherWise                       // Controla los demas casos provisionalmente

	n := Alert2( 'Por favor, elija ..', ;
		{ ' &Oculc ', '  &Win  ', '&Cancelar' }, 'Opciones de Ayuda' )
	Do Case
	Case n == 0 .or. n == 3
		MsgStop( 'NO se ha elegido Ayuda ..', 'Aviso !.' )
		Return ''
	Case n == 1
             if File( 'WOCAYUDA.EXE' )
                  WinExec( 'WOCAYUDA.EXE', 1 )
                  Return 'XXX' // PARA CONTROLAR LLAMADA..
             else
        	aFileHelp := { 'OCULC' }
                If Len(AllTrim( memoRead( 'Oculc.Wlp' ) )) < 100
                        Ferase( 'Oculc.Wlp' )
                endif
		If !File( 'OCULC.WLP' ) .and. File( 'OCULC.DOC' )
			LZCopyFile( 'OCULC.DOC', 'OCULC.WLP' )
        	EnDif
             endif
	Case n == 2
		// Ayuda de Windows
		WinHelp( 'WinHelp.Hlp' )        // 'Progman.Hlp' )      
		Return ''
	endCase

endcase

// O se copia la ayuda de la version del dos de wocul3
// o se crea una ayuda vacia para escribirla..
aEval( aFileHelp, { | cEl, nEl | ;
		cDosFile := cEl + '.TXT', ;
		Iif( !File( cEl + '.Wlp' ), iif( File( cDosFile ), ;
		LZCopyFile( cDosFile, cEl + '.Wlp' ), ;
	MemoWrit( cEl + '.Wlp', 'Texto para escribir la Ayuda ..' ) ), ) } )

return( aFileHelp )
//-----------------
//********************************************************
FUNCTION justific( cLinea, lon_linn, oFont, oPrn, lMedic, lNojus )
//********************************************************
// local lon_linn := len( cLinea )
local estoy_en, letraini, cuantos, busca, cadena
			 // justifica por la izq. y como no son campos memo
local t, sitio, ncadena, nletrain, n := 5
local espafin, nCs := 44, lJustif := .t., bCs
// lineas a justificar aquellas q no terminan en un punto, y tengan 
// un tamao superior al 80 por ciento de los 60 caracteres asignados
// FWH 2008 probando 90 por ciento = Mejor NOOOO
// a cada linea de impresion.. si no es font de windows
DEFAULT lon_linn := 60
DEFAULT oFont    := {}
DEFAULT lMedic   := .f.	// Justificar lineas medicamentos ..
DEFAULT lNoJus   := .f. // NO Justific lineas determinados arch ( analisis..)
 
if Empty( cLinea )
	Return ''

endif
if !Empty( oFont ) .and. oPrn:GetTextWidth( cLinea, oFont ) >= lon_linn
		Return cLinea
endif
cLinea := Trim( cLinea )
espafin  := ABS( lon_linn - ;
		iif( !Empty( oFont ),  oPrn:GetTextWidth( cLinea, oFont ), ;
 									 len( cLinea ) )      )
        bCs := {|| ;
nCs := iif(  !Empty( oFont ),  ( espafin / oFont:nWidth ), lon_linn - Len(Trim( cLinea )) ), ;  // se pasa de pixel a caracteres 
n   := iif( !Empty( oFont ), 1, n ) }

Eval( bCs )
 
// Los textos de font peq en minusculas, controlar q no hay un feo justificado 
lJustif := iif( !Empty( oFont ) .and.  ;                     // 0.6
        oPrn:GetTextWidth( cLinea, oFont ) < lon_linn * 0.4, ;
							 .f., lJustif )
lJustif := iif( lMedic, .t., lJustif )
lJustif := iif( right( trim( cLinea ), 1 ) == ';', .t., lJustif )

// En font normal lon_linn / n es = > 48 p q se justifique
// y en cambio con font no influye la longitud a no ser q, y por eso se pone,
// q se valore aparte > 44 p q no se justifiquen las demasiado cortas
// excepto receta medica por su estructura
 
espafin := Max( espafin, 0 )
 
if !lNoJus .and. espafin > 0 .and. espafin <= int( lon_linn / n ) .and. ;
      len( AllTrim( cLinea ) ) > 44 .and. ;
                !( right( trim( cLinea ), 1 ) $ ".-:" ) .and. lJustif .and. ;
                right( trim( cLinea ), 1 ) != chr(13) .and. lJustif .and. ;
		AnsiToOem( right( trim( cLinea ), 2 ) ) != chr(13) + chr( 10 )

   letraini := len( cLinea ) - len( ltrim( cLinea ) )
   estoy_en := letraini
   cuantos  := 1
   busca    := PADCHAR	//space(1)
   cLinea   := iif( Empty( Trim( cLinea ) ), CRLF, Trim( cLinea ) )
  
   cadena   := substr( cLinea, letraini + 1 )
 
   for t = 1 to espafin
      sitio := at( busca, cadena )
      if sitio  == 0 .and. t == 1
	    cLinea := cLinea + space( espafin )
	 exit
      endif
      if sitio > 0
	 estoy_en := estoy_en + sitio
	 cLinea   := stuff( cLinea, estoy_en, 1, "  " )
	 ncadena  := substr( cLinea, estoy_en )
	 nletrain := len( ncadena ) - len( ltrim( ncadena ) )
         estoy_en := estoy_en + iif( nletrain > 10, 1, nletrain ) //++     // := estoy_en + nletrain
         cadena   := substr( cLinea, estoy_en + 1 )
      endif
      if sitio == 0 .and. t <= espafin
	 cadena := substr( cLinea, letraini + 1 )
	 estoy_en := letraini
	 t = t - 1
	 
      endif
      nCs := nCs -1
 //     if nCs < 1
  //          exit
    //  endif
	if !Empty( oFont )	// Garantiza y limita el justificado
 		if oPrn:GetTextWidth( cLinea, oFont ) >= lon_linn
			exit
		else
                        t := 4  // Obliga a seguir justificando..
		endif
     else
        if nCs < 1
              exit
        endif
	endif
   next

endif
 
    cLinea := Trim( cLinea )
    if right( cLinea, 1 ) == ";"
         cLinea := Stuff( cLinea, Len( cLinea ), 1, '' )     
    endif
 
return( cLinea )
//-------------
 
//*******************************************************
function abrebase(cbasedatos, lmodoapert, nsegundos, area )
//*******************************************************
// Abre una base en red
local iniseg := 0
local mientras, reiniciar, tiempo_espera, ca10 , cresp
nsegundos  := iif( empty( nsegundos ), 5, nsegundos )
lmodoapert := iif( empty( lmodoapert ), .f., lmodoapert )
area       := iif( empty(area), .f., area )  // .t. = area cero, para llamar
				       //  por el alias-nombre  
/*
MSGINFO('ABRIENDO: ' + cbasedatos  +CRLF+;
	'MODO: ' + ( IF( LMODOAPERT, '.F.', '.T.' ) ) )
*/
reiniciar  := .t.
mientras := (nsegundos == 0)
//cbasedatos := cbasedatos + '.dbf'

do while reiniciar == .t.
   tiempo_espera := nsegundos
   do while ( mientras .or. tiempo_espera > 0 )
      
      if ( lmodoapert )  // se valora si compartido es t o f
	 DbUseArea( area, , cbasedatos, , .F. ) // modo exclusivo
      else
	 DbUseArea( area, , cbasedatos, , .T. ) // modo compartido
      endif
      
      if !neterr()
	 return .t.
      endif
      
//      inkey(1)
	iniseg := val( substr( TIME(), 7, 2 ) )
	do while val( substr( TIME(), 7, 2 ) ) - iniseg < 1
	enddo
      tiempo_espera = tiempo_espera - 1
      
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Fichero: " + cbasedatos + " - NO se ha abierto.;" + ;
		 "Cierre cualquier otra version del programa;" + ;
		 "que se pueda estar ejecutando !"

   cresp := fallo_acc(cbasedatos, ca10)
   if cresp # "R"
      QUIT
      exit      
   endif
   
enddo

return .f.
//-------
//
//************************
function addrec(numsegesp)      // Crea nuevo registro 
//************************
local mientras, tiempo_espera, reiniciar,ca10,cresp

dbappend()
if .not. neterr()
   return .t.
endif

reiniciar = .t.
mientras  = (numsegesp = 0)

do while reiniciar = .t.
   
   tiempo_espera = numsegesp
   do while (mientras .or. tiempo_espera > 0)
      
      dbappend() 
      if .not. neterr()
	 return .t.
      endif
      
      inkey(.5)                     && Espera 1/2 segundo.
      tiempo_espera = tiempo_espera - .5
      
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Registro NO se ha creado."
   cresp := fallo_acc('',ca10)
   // reiniciar := resp5
   if cresp # "R"
      exit
   endif
   
   
enddo

return .f.
//-------
//
//*************************
function fillock(numsegesp)  // bloquea un fichero - Red
//*************************

local mientras, tiempo_espera, reiniciar,ca10,cresp

if flock()
	 return .t.                 && Bloqueo correcto.
endif

reiniciar = .t.
mientras  = (numsegesp = 0)

do while reiniciar = .t.
   
   tiempo_espera = numsegesp
   do while (mientras .or. tiempo_espera > 0)
      
      inkey(2)                     && Espera 1/2 segundo.
      tiempo_espera = tiempo_espera - 2
      
      if flock()
      endif
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Fichero NO bloqueado .." 
   cresp := fallo_acc('',ca10)
   //reiniciar := resp5
   if cresp # "R"
      exit
   endif
   
   
enddo

return (.f.)
//---------
//
//*************************
function reclock(numsegesp, cBase)
//*************************
local nArea := SELECT()
local mientras, tiempo_espera, reiniciar,ca10,cresp

DEFAULT cBase := ALIAS( nArea )
DbSelectArea( (cBase) )

if rlock()
   return .t.
endif

reiniciar = .t.
mientras  = (numsegesp = 0)

do while reiniciar = .t.
   
   tiempo_espera = numsegesp
   do while (mientras .or. tiempo_espera > 0)
      
      if rlock()
	 return .t.                 && Bloqueado.
      endif
      
      inkey(.5)                     && Espera 1/2 segundo.
      tiempo_espera = tiempo_espera - .5
      
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Registro NO bloqueado .. "
   cresp := fallo_acc('',ca10)
//   reiniciar := resp5
   if cresp # "R"
      exit
   endif
   
enddo

return .f.

//************************************         
function fallo_acc( basededato, ca10 )
//************************************          
local  aopciones := {  "&Reintentar ", "&Interrumpir" }
local  cresp := ""  // Alert( ca10, aopciones, 'Atencin !.' )  //, resp5
local nI := Alert2( ca10, aOpciones, 'DIALOGO de RED !..' )
 if nI == 1
    cResp := "R" 
 //   cresp := iif( cresp == 1, "R", "I" )
else
   MsgWait( "El programa se cerrar...", "Agenda", 1.5 )
   QUIT
endif
//resp5 = .t.
return( cresp )
//------------
//
//***********************************
function SelectDb( baseusa, cAreaNw )
//***********************************
local desde := 0, i
local aBases := aGetWorkAreas(), cText := ''
local nArea := SELECT(), cAreaUso := ALIAS( nArea )
local cDrive := '.' + LEFT( DBSETDRIVER(), 3 )

DEFAULT cAreaNw := ""   //cAreaUso
baseusa         := Upper( baseusa )
cAreaNw         := upper( cAreaNw )
cAreaUso        := upper( cAreaUso )
cAreaUso        := iif( cAreaUso == baseusa, '', cAreaUso )

if !Empty( baseusa ) .and. !File( baseusa + cDrive )
        MsgStop( 'Seleccionada BASE: ' + baseusa + cDrive + CRLF + ;
                'NO ENCONTRADA ..' + ;
                CRLF + 'NO Se Interrumpe el programa.', 'Aviso !.' )
//        QUIT
endif

// Establecer el select area ..
// cAreaNw, si lo hay, si no -> cAtreaUso si lo hay.., si no -> nada
//cAreaNw := iif( Empty( cAreaNw ), cAreaUso, cAreaNw )
aBases := aGetWorkAreas()
if Len( aBases ) > 0
      baseusa := iif( !Empty( baseusa ) .and. Ascan( aBases, ;
             { | x | Upper( AllTrim( x ) ) == AllTrim( baseusa ) } ) > 0, ; 
                baseusa, ATAIL( aBases ) )
            if !Empty( baseusa )        // la ultima de la lista actual
                DbSelectArea( baseusa ) // se selecciona
            else
                // Abrirla????
            endif
endif

Return .t.
//-------
//
// rutina q controla cierre de las bases
// y evita errores de ejecucion si la base no estaba en uso
//***********************************
function CierraDb( baseusa, cAreaNw )
//***********************************
local desde := 0, i
local aBases := aGetWorkAreas(), cText := ''
local nArea := SELECT(), cAreaUso := ALIAS( nArea )
local cDrive := '.' + LEFT( DBSETDRIVER(), 3 )

DEFAULT cAreaNw := ''
baseusa         := Upper( baseusa )
cAreaNw         := upper( cAreaNw )
cAreaUso        := upper( cAreaUso )
cAreaUso        := iif( cAreaUso == baseusa, '', cAreaUso )

if !File( baseusa + cDrive )  // Se ha pasado mal el nombre en la macro
	// MsgStop( 'Cerrar BASE: ' + baseusa + cDrive + CRLF + ;
	//	'NO ENCONTRADO ..' + ;
	//	CRLF + 'Se Interrumpe el programa.', 'Aviso !.' )
	// QUIT
endif

if cAreaNw != BaseUsa   // Si NO se va a seleccionar la q se va a cerrar ..
			// Cierra 
	if Ascan( aBases, ;
		{ | x | Upper( AllTrim( x ) ) == AllTrim( baseusa ) } ) > 0 
					// Si la base estaba abierta,
		( BaseUsa )->( DbCloseArea() )  // se cierra
					// Si NO = Nada
	endif

endif

// Establecer el select area ..
// cAreaNw, si lo hay, si no -> cAtreaUso si lo hay.., si no -> nada
cAreaNw := iif( Empty( cAreaNw ), cAreaUso, cAreaNw )
aBases := aGetWorkAreas()
if Len( aBases ) > 0
	cAreaNw := iif( Empty( cAreaNw ), ATAIL( aBases ), cAreaNw )
	if !Empty( cAreaNw ) .and. Ascan( aBases, ;
		{ | x | Upper( AllTrim( x ) ) == AllTrim( cAreaNw ) } ) > 0 
					// Si la base estaba abierta,
		DbSelectArea( cAreaNw ) // se selecciona
					// Si NO = Nada
	endif
endif

Return .t.
//--------
//
//*******************
function AreasEnUso()
//*******************
local aBases := aGetWorkAreas(), cText := ''
local nArea  := SELECT(), cAreaUso := ALIAS( nArea )

if Empty( aBases )

	cText += 'NO hay Areas abiertas ..'

else

	cText += 'AREAS' + CRLF + 'EN USO:' + CRLF + CRLF
	aEval( aBases, { | cEl, nEl | ;
		cText += Upper( cEl ) + CRLF } )

	cText += CRLF + 'Select: ' + cAreaUso
	if AT( 'LIS_RED', cText ) > 0
	    cText += CRLF + 'nUser: ' + AllTrim( Str( Lis_red->( RecNo() ) ) )
	endif
endif

	MsgInfo( cText, 'Informacin' )

Return .t.
//--------
//
  // rutina q controla todas las llamadas a bases e indices
//*********************************************************
function usa_base( baseusa, uso, indices, numseg, areacero)
//*********************************************************
local desde := 0, i, nRec := 0, aIndex := { '','','','' }, aStru:= {}
local aBases := aGetWorkAreas(), cText := '', cIndice := ''
local nArea := SELECT(), cAreaUso := ALIAS( nArea )
local cDrive := '.' + LEFT( DBSETDRIVER(), 3 ), ;
        cDrvInd := '.' + Right( DBSETDRIVER(), 3 ), cDBT := '.DBT'
local lHay   := .f., lAbre := .f., lMemo := .f., aIndice := {}

MEMVAR  ind1, ind2, ind3, ind4, mindn, indn
DEFAULT areacero := .t., numseg := 5, indices := "", uso := .f.

ind1 := ind2 := ind3 := ind4:= ""
indices := AllTrim( indices )

        cDrvInd := ".NTX"
cDrive := Upper( cDrive )
//? baseusa
baseusa := cFileNoExt( BaseUsa )
//? baseusa
baseusa := Upper( AllTrim( baseusa ) )
//baseusa := iif( at( baseusa, '.' ) > 0, cFileNoExt( baseusa ), baseusa )
lHay :=  ( Ascan( aBases, { | x | Upper(AllTrim(x)) == baseusa } ) > 0 )
// ? ".\" + baseusa + cDrive , File( ".\" + baseusa + cDrive ), uso
// xMsgList( aBases )

if lHay
//     xMsgList( aBases )
else
     
   if !File( ".\" + Upper( baseusa + cDrive ) ) .and. !File( ".\" + Lower( baseusa + cDrive ) )
          MsgInfo( "BASE: " + baseusa + CRLF + "NO ENCONTRADO ..", "Informacin" )
          QUIT
   endif

   
endif

if !( uso ) // Si es modo compartido .. uso == .f.
    if lHay
                                // Si la base ya esta abierta,
	DbSelectArea( BaseUsa ) // se selecciona y se sale sin tener q abrirla
                                // pero los indices pueden variar la llamada
      //  Return BaseUsa
    else
        lAbre := ( abrebase( baseusa, uso, numseg, areacero ) )
    endif
else
            // Abrir en modo Exclusivo .. uso == .t.
    if lHay // Si la base ya esta abierta
        DbSelectArea( BaseUsa ) // se selecciona 
        nRec  := RecNo()        // leyendo los indices
        aEval( aIndex, { |c,n| aIndex[ n ] := INDEXKEY( n ) } )
        ind1 := aIndex[1] ; ind2 := aIndex[2]
        ind3 := aIndex[3] ; ind4 := aIndex[4]
        ( BaseUsa )->( DbCloseArea() )  // Se cierra..
    endif
    // Se abre en modo exclusivo ..
    lAbre := ( abrebase( baseusa, uso, numseg, areacero ) )
 
    if nRec > 0 .and. ;                                // Si se habia cerrado..
         Ascan( aGetWorkAreas(), ;
             { | x | Upper( AllTrim( x ) ) == AllTrim( baseusa ) } ) > 0
         ( BaseUsa )->( DbGoto( nRec ) )        // Restablece puntero
    endif
endif

if ( lAbre ) .or. ;      // Si se ha abierto .., ahora los indices..
                lHay     //El indice puede ser por otro orden ..


   if !empty( indices )
 
      indices := AllTrim( Upper( indices ) )

      for i = 1 to 4
         indn = "ind" + alltrim( str( i ) )
         mindn := ''

	 desde = at( ",", indices )
	 if desde > 0
	    mindn = left(indices,len(indices)-len(substr(indices, desde )))
            // Si el fichero indice no existe, se ignora y no da error
//     ? mindn
            mindn := AllTrim( mindn )
            mindn = iif( File( '.\' + mindn + cDrvInd ), mindn, '' )
//            &indn := mindn
            store mindn to &indn
            indices = AllTrim( substr( indices, desde + 1 ) )
	    
	 else
	    
            mindn := alltrim( indices )
            mindn = iif( File( '.\' + mindn + cDrvInd ), mindn, '' )
//     ? mindn
//            &indn := mindn
            store mindn to &indn
	    indices = ""
	    exit
	    
	 endif

   //  ? mindn
	 
      next
      
      set index to &ind1, &ind2, &ind3, &ind4

//     ? ind1, ind2, ind3, ind4

   endif
else
   quit
endif

release all like ind*
release mindn

return(baseusa)
//--------------
//
//*********************
function bloq_reg(nseg, cBase) && rutina q controla todas las llamadas en red a
			  && bloqueo de registros
//*********************
local nArea := SELECT()
DEFAULT cBase := ALIAS( nArea )
DEFAULT nSeg := 5
if Empty( cBase )
    MsgWait( "Datos NO guardados", "Aviso !", 1 )
    Return .f.
endif
if reclock( nseg )
   dbgoto( recno() )
else
   quit
endif

return .t.
//--------
//
//*********************
function appe_reg(nseg, cBase) && rutina q controla todas las llamadas en red a
			  && append blank
//*********************
local nArea := SELECT()
DEFAULT cBase := ALIAS( nArea )

if addrec( nseg )
   
else
   quit
endif

return .t.
//--------
//
//*********************
function bloq_fil(nseg, cBase) && rutina q controla todas las llamadas en red a
		    && bloqueo de ficheros
//*********************
local nArea := SELECT()
DEFAULT cBase := ALIAS( nArea )

if fillock( nseg )
   
else
   quit
endif

return .t.
//--------
//
//********************
function desbloq(nseg) && rutina q controla todas las llamadas en red a
		    && desbloqueo de ficheros previo vaciado
//********************

dbcommitall()           // Garantizando la actualizacion del registro
DbGoto( Recno() )
dbunlockall()

return .t.
//--------
//
//******************
Function colegiado( lEdit )
//******************
Local aDbf := {}, cFile := 'CONTROL', dFecha
local bModif, aBases, cBase, nField, nLong
local n, N1, nFiles, nLast, lVisto := .t., cFVisto := 'VISTO.GDO'
//RETURN NIL
DEFAULT lEdit := .f.

If !File( 'Control.Dbf' )
        MsgStop( 'NO encuentro: CONTROL.DBF'+ CRLF + ;
                        'Consulte con su proveedor..', 'Aviso !.' )
        // Return Nil
Endif
// SE ANULA EL MANTENIMIENTO FEBRE 2005
// Si mantenimiento aun se hacia con fechas en vez de con consultas
// hay que actualizar la revision de estructuras y el mantenimiento
If at( '/', MemoRead( 'MANTENER.DAT' ) ) > 0
       Ferase( 'MANTENER.DAT' )
       Ferase( cFVisto )
EnDif

if !File( 'VisionW.Dbf' ) //.or. !File( 'Alergias.Dbf' )  //Lentes.Dbf' )
       Ferase( cFVisto )
endif

lVisto := ( MemoRead( cFVisto ) == 'S' )

if !( lVisto )

        MsgRun( "INSPECCIONANDO Estructura, Espere ..", ;
                "Ficheros ..", { || Colegiado2() } )

        MsgWait( "INSPECCION Terminada.." ,"Ficheros ..", 2 )

        MemoWrit( cFVisto, 'S' )

MemoWrit( 'LISMODST.DAT', cLista )

if File( 'LISMODST.DAT' ) .and. lEdit
        MemoEdi2( MemoRead( 'LISMODST.DAT' ) )
//        WinExec( 'NOTEPAD.EXE ' + 'LISMODST.DAT', 1 )
endif
endif

Return Nil
//--------

Function AutoTra1()
local aDbf, cFile, cTx := "", lResult := .f., aF, aDir1, aDir2, nVal, Temp1 := "TEMP1.DBF"
local bCarga, cCurDrive := HB_CurDrive()
local nI := 0
local bDir, carpeta := ""

bDir := { | c | carpeta := c, iif( !lIsDir( carpeta ), lMkDir( carpeta ), Nil ) }

			if File( "AUTOTRA1.DBF" )
			        Return Nil
			endif
      if !File( "WANALIS.DBF" )
           LZCopyFile( "AUTOTRA2.DBF", "AUTOTRA1.DBF" )
           Return Nil
      endif										 

      Eval( bDir, Upper( cCurDrive ) + ':' + '\' + CurDir() + '\' + "AUTOTRA1" )
                usa_base( "WANALIS", .f., '', 5, .t. )
								aF := Array( Wanalis->( FCount() ) )
                
                cFile := 'AutoTra2'
                usa_base( 'AutoTra2', .t., '', 5, .t. )
                aDbf := AutoTra2->( DbStruct() )
								//AutoTra2->( DbCloseArea() )
								
								DbCreate( "AUTOTRA1", aDbf )
								
								AutoTra2->( DbCloseArea() )
								
								If !File( "AUTOTRA1.DBF" )
								   MsgStop( "No ha sido creado !", "AUTOTRA1.DBF" )
								   Return( Nil )
								else
                    usa_base( "AUTOTRA1", .t., '', 5, .t. )																								
							      index on ( AutoTra1->Protocolo ) to AutoTra1
								  For nI = 1 To Wanalis->( LastRec() )
								    AUTOTRA1->( DbAppend() )
								    Wanalis->( DbGoto( nI ) )
								    AUTOTRA1->( FieldPut( 1, Wanalis->( FieldGet( 1 ) ) ) )
								    AUTOTRA1->( FieldPut( 2, ".\AUTOTRA1\F" + ;
								    		PADL( AllTrim( str( nI, 3 ) ), 7, "0" ) + ".ALS" ) )
								   	AUTOTRA1->( FieldPut( 3, nI ) )							    
								   	cTx := ""
								    aEval( aF, {| c, n | cTx += Wanalis->( FieldGet( n ) ) }, 2 )
								    MemoWrit( Trim( Autotra1->( FieldGet( 2 ) ) ), cTx )    
                    DesBloq()
								  next	
								  AutoTra1->( DbGoto( 1 ) )
								  Bloq_Reg( 5 )
								  AutoTra1->( FieldPut( 3, nI ) )
								  DesBloq()
						    Endif
                Autotra1->( DbCloseArea() )
                Wanalis->( DbCloseArea() )
Return( Nil )

//--------
Function RequeRef() // 06-12-2008
local aDbf, cFile, lResult := .f., aDir1, aDir2, nVal, Temp1 := "TEMP1.DBF"

                cFile := 'Refrac'
                usa_base( cFile, .t., '', 5, .t. )
                aDbf := Refrac->( DbStruct() )
								( cFile )->( DbCloseArea() )
								             
        if aDbf[ 1, 3 ] < 40
           //if MsgYesNo( "Actualizar?", "Base de Refraccin" )
				        MsgRun( "Actualizando Estructura, Espere ..", ;
                		"Base de Refraccin ..", { || WaitSeconds( 0.8 ) } )
								CursorWait()
								
                aDbf[ 01, 3 ] := 40
                aDbf[ 02, 3 ] := 40
                aDbf[ 03, 3 ] := 40
                aDbf[ 04, 3 ] := 40
                aDbf[ 05, 3 ] := 40
                aDbf[ 06, 3 ] := 40
                // usa_base( cFile, .t., '', 5, .t. )
                // COPY TO Temp1
 							  LZCopyFile( 'REFRAC.DBF', 'TEMP1.DBF' )                 
								//( cFile )->( DbCloseArea() )
                
                aDir1 := Directory( cFile + ".Dbf" )
                aDir2 := Directory( "Temp1.Dbf" )
          //     ? aDir1[ 1, 2 ], aDir2[ 1, 2 ]
                if aDir1[ 1, 2 ] == aDir2[ 1, 2 ]               
                		nVal := aDir1[ 1, 2 ]
                else
                		MsgWait( "Imposible continuar", "Se har mas adelante" )
                		Return Nil
                endif 
                
								DbCreate( cFile, aDbf )
          //      aDir1 := Directory( cFile + ".Dbf" )								
          //     ? aDir1[ 1, 2 ]								
								usa_base( cFile, .t., "", 5, .t. )
								APPEND FROM Temp1
 								( cFile )->( DbCloseArea() )

                aDir1 := Directory( cFile + ".Dbf" )
                aDir2 := Directory( "Temp1.Dbf" )
          //     ? aDir1[ 1, 2 ], aDir2[ 1, 2 ]
                
                if aDir1[ 1, 2 ] > aDir2[ 1, 2 ]               
 										lResult := .t.
 								endif								
								
 							  if ( lResult )
 							  		MsgRun( "Actualizacin Terminada", "Base de Refraccin..",;
 							  															 { || WaitSeconds( 1.2 ) }  )
								FErase( 'TEMP1.DBF' )
 							  else
 							  //		MsgStop( "Error en la Actualizacin", "Se Recuperar Refrac.DBF" )
 							  		LZCopyFile( 'TEMP1.DBF', 'REFRAC.DBF' )
 							  //										FErase( 'TEMP1.DBF' )							
 							  endif
								//FErase( 'TEMP1.DBF' )
           //endif
         endif

Return Nil
//******************
Static Function colegiado2()
//******************
Local aDbf := {}, cFile := 'CONTROL', dFecha, lHacer := .f., aDb
local bModif, aBases, cBase, nField, nLong, aDir1, aDir2, nVal, lResult := .f.
local n, N1, nFiles, nLast, lVisto := .t., cFVisto := 'VISTO.GDO'
FIELD Historia
memvar cCampos, cIndice

cLista := 'Inspeccion de Estructuras: ' + DToC( Date() ) + CRLF 

aBases := {}
CursorWait()
//FEDRERO 2005, LIS_RED DE 1994 ACTUALIZARLO, JORDANO AND SO ON
cFile := "Lis_Red"
usa_Base( "LIS_RED", .t., "", 5, .t. )
//? LIS_RED->( FCOUNT() )

if LIS_RED->( FCOUNT() ) < 34 
   Lis_Red->( DbCloseArea() )
 
 		aDbf := ;
{ { 'TEXTO', 'C', 18, 0 }, ;
{ 'NIVEL', 'C', 1, 0 }, ;
{ 'USADO_POR', 'C', 4, 0 }, ;
{ 'HISTORIA', 'C', 10, 0 }, ;
{ 'CLAVE1', 'C', 4, 0 }, ;
{ 'CLAVE2', 'C', 4, 0 }, ;
{ 'CLAVE3', 'C', 4, 0 }, ;
{ 'CLAVE4', 'C', 80, 0 }, ;
{ 'MEMBRETE01', 'C', 70, 0 }, ;
{ 'MEMBRETE02', 'C', 70, 0 }, ;
{ 'MEMBRETE03', 'C', 70, 0 }, ;
{ 'MEMBRETE04', 'C', 70, 0 }, ;
{ 'MEMBRETE05', 'C', 70, 0 }, ;
{ 'MEMBRETE06', 'C', 70, 0 }, ;
{ 'MEMBRETE07', 'C', 70, 0 }, ;
{ 'MEMBRETE08', 'C', 70, 0 }, ;
{ 'MEMBRETE09', 'C', 70, 0 }, ;
{ 'MEMBRETE10', 'C', 70, 0 }, ;
{ 'MEMBRETE11', 'C', 70, 0 }, ;
{ 'MEMBRETE12', 'C', 70, 0 }, ;
{ 'MEMBRETE13', 'C', 70, 0 }, ;
{ 'MEMBRETE14', 'C', 70, 0 }, ;
{ 'MEMBRETE15', 'C', 70, 0 }, ;
{ 'MEMBRETE16', 'C', 70, 0 }, ;
{ 'MEMBRETE17', 'C', 70, 0 }, ;
{ 'MEMBRETE18', 'C', 70, 0 }, ;
{ 'NBRUSH', 'N', 1, 0 }, ;
{ 'NFRGBCOLOR', 'N', 10, 0 }, ;
{ 'ESTILO', 'C', 50, 0 }, ;
{ 'BMPBRUSH', 'C', 50, 0 }, ;
{ 'NCOLORDLG', 'N', 10, 0 }, ;
{ 'NCOLORTXT', 'N', 10, 0 }, ;
{ 'EDITOR', 'C', 70, 0 }, ;
{ 'PINTAR', 'C', 70, 0 }  }

/*
	if !FILE( "MODELRED.DBF" )
  	 MsgStop( "Una copia de LIS_RED.DBF actualizada, renombrada como: MODELRED" + ;
   	 CRLF + "se necesita para poder reparar LIS_RED.DBF de versiones anteriores !" )
	else

		usa_Base( "MODELRED", .t., "", 5, .t. )
		aDbf := ModelRed->( DbStruct() )
    ModelRed->( DbCloseArea() )
   ? LEN( aDbf )
*/    
							//	Lis_Red->( DbCloseArea() )
 							  LZCopyFile( 'Lis_Red.Dbf', 'TEMP1.DBF' )                 
                
                aDir1 := Directory( "Lis_Red.Dbf" )
                aDir2 := Directory( "Temp1.Dbf" )
  //             ? aDir1[ 1, 2 ], aDir2[ 1, 2 ]
                if aDir1[ 1, 2 ] == aDir2[ 1, 2 ]               
                		nVal := aDir1[ 1, 2 ]
                else                    
                		MsgWait( "Imposible continuar", "Se har mas adelante" )
                		Return Nil
                endif 
                //FERASE( "LIS_RED.DBF" )
								DBCREATE( "Lis_Red", aDbf )

          //      aDir1 := Directory( cFile + ".Dbf" )								
          //     ? aDir1[ 1, 2 ]								
								usa_base( "Lis_Red", .t., "", 5, .t. )
//? Lis_Red->( FCOunt() )
								APPEND FROM Temp1
 								aDb := Lis_Red->( DbStruct() )
 								Lis_Red->( DbCloseArea() )

                aDir1 := Directory( "Lis_Red.Dbf" )
                aDir2 := Directory( "Temp1.Dbf" )
          //     ? aDir1[ 1, 2 ], aDir2[ 1, 2 ]
                
                if Len( aDb ) == Len( aDbf ) //.and. aDir1[ 1, 2 ] > aDir2[ 1, 2 ]               
 										lResult := .t.
 			 endif								
								
 							  if ( lResult )
 							  		MsgRun( "Actualizacin Terminada", "Base LIS_RED.DBF..",;
 							  															 { || WaitSeconds( 1.2 ) }  )
								FErase( 'TEMP1.DBF' )
 							  else
 							  		MsgStop( "Error en la Actualizacin", "Se Recuperar LIS_RED.DBF" )
 							  		LZCopyFile( 'TEMP1.DBF', 'LIS_RED.DBF' )
 							  //										FErase( 'TEMP1.DBF' )							
 							  endif


    DbCloseAll()

//  endif
else
  DbCloseAll()
//  if !FILE( "MODELRED.DBF" )
//     LZCopyFile( "Lis_Red.Dbf", "MODELRED.DBF" )
//  endif 
endif
//  Lis_Red->( DbCloseArea() )
  
  
// Marzo 2001 .. Campo Memo en Motivo.Dbf para q no cree excesivos registros
// En Reus
// SE ANULA ENERO 2005
/*
                cFile := 'Motivo'
                usa_base( cFile, .t., '', 5, .t. )
                aDbf := ( cFile )->( DbStruct() )
                N1 := Motivo->( FCount() )   //Len( aDbf )
                    ( cFile )->( DbCloseArea() )

                cLista += iif( at( Upper( cFile ), Upper( cLista ) ) == 0, ;
                                cFile + CRLF, '' )
                if N1 < 3
                        aadd( aDbf, { 'MEMOTXT', 'M', 10, 0 } )
                  if !( PreCopTot( cFile, 'Temp1', aDbf ) )
                        Return Nil
                  endif

                endif   
*/
//FIN ANULACION CAMPO MEMO EN MOTIVO CONSULTA

// Para Pepe Jordano, aumentar los campos de A.V. a 15 espacios
// Oct.2000

if !File( 'VisionW.Dbf' )
                    cFile := 'Vision'

                    cLista += cFile + CRLF
                    If FunCopToT( cFile, 'VisionW' )
                    // Se mandan y reciben cerrados
                        usa_base( cFile, .t., '', 5, .t. )
                        aDbf := DbStruct()
                        ( cFile )->( DbCloseArea() )
                    Else
                      MsgStop( 'Error al copiar de ' + cFile + ' a: VisionW', 'Aviso !.' )
                      Return Nil
                    Endif

                    cFile := 'VisionW'
                    If FunCopToT( cFile, 'Temp1' )
                    // Se mandan y reciben cerrados
                        N1 := Len( aDbf )
                        for n := 1 to N1
                            aDbf[ n, 3 ] := 15
                        next
                        dbcreate( cFile, aDbf )
                    Else
                      MsgStop( 'Error al copiar de ' + cFile + ' a: Temp1', 'Aviso !.' )                        
                      Return Nil
                    Endif

                    If FunAppFrom( cFile, 'Temp1' )
                    // Cargar los datos sin Fallo XP
                        FErase( 'TEMP1.DBF' )
                        FErase( 'TEMP1.DBT' )
                    Else
                        If FunCopTot( 'Temp1', cFile )
                        Endif
                      MsgStop( 'Error al cargar de Temp1 a: ' + cFile, 'Aviso !.' )
                      Return Nil

                    Endif

endif    

// Oct 2000 Refrac.dbf vision ao cc y sc pasa de 6 a 15 espacios
// SE ANULA ENERO 2005
/*

                cFile := 'Refrac'
                usa_base( cFile, .t., '', 5, .t. )
                aDbf := DbStruct()
		( cFile )->( DbCloseArea() )

                cLista += cFile + CRLF
        if aDbf[ 1, 3 ] < 25
                aDbf[ 01, 3 ] := 25
                aDbf[ 02, 3 ] := 25
                aDbf[ 03, 3 ] := 25
                aDbf[ 04, 3 ] := 25
                aDbf[ 05, 3 ] := 25
                aDbf[ 06, 3 ] := 25
                aDbf[ 07, 3 ] := 15
                aDbf[ 08, 3 ] := 15
                aDbf[ 15, 3 ] := 15
                aDbf[ 16, 3 ] := 15

                  if !( PreCopTot( cFile, 'Temp1', aDbf ) )
                        Return Nil
                  endif

         endif

// Crear un campo memo para cada base de exploraciones 1 a 14..
// Julio 2000
// SE ANULA EN ENERO 2005
                aDbf := {}
                aadd( aDbf, { 'LINEA1', 'C', 29, 0 } )
                aadd( aDbf, { 'LINEA2', 'C', 29, 0 } )
                aadd( aDbf, { 'LINEA3', 'C', 29, 0 } )
                aadd( aDbf, { 'LINEA4', 'C', 29, 0 } )
                aadd( aDbf, { 'AMPLIA', 'N', 07, 0 } )
                aadd( aDbf, { 'LINEA5', 'M', 10, 0 } )

           usa_base( 'B1', .f., '', 5, .t. )
           N1 := B1->( FCount() )
           B1->( DbCloseArea() )

    if N1 < 6
        for n := 1 to 14
           cFile := 'B' + AllTrim( Str( n, 2, 0 ) )    
           usa_base( cFile, .t., '', 5, .t. )
           N1 := ( cFile )->( FCount() )
           ( cFile )->( DbCloseArea() )
           cLista += cFile + CRLF

           if N1 < 6      //Len( aDbf ) < 6
                  if !( PreCopTot( cFile, 'Temp1', aDbf ) )
                        Exit    //Return Nil
                  endif

           endif            
        next

    endif
*/
// FIN ANULACION CAMPO MEMOO EXPLORACIONES

// AVISO = SI SE CAMBIA O NO LA LONGITUD DE NOMBRE DE PACIENTE
// EN PACIENTE.DBF HAY QUE HACER LO MISMO EN MATRIZ.DBF Y INFORME.DBF
// SI NO ES ASI FUNCIONARAN MAL ESTAS BASES.

// Aadir Distrito Postal a los campos datos paciente
// a peticion de antonio fernandez repeto 23 julio 2000
// y poner los campos a 40 espacios
        cFile  := 'Paciente'
        nField := 16
        nLong  := 30

        usa_base( cFile, .t., '', 5, .t. )
	aDbf := DbStruct()
        ( cFile )->( DbCloseArea() )
                cLista += iif( at( Upper( cFile ), Upper( cLista ) ) == 0, ;
                                cFile + CRLF, '' )
        //cLista += cFile + CRLF

IF len( aDbf ) < nField
                aadd( aDbf, { 'DPOSTAL', 'C', 30, 0 } )
                lHacer := .t.
EndIf

if aDbf[ 1, 3 ] < 40
                lHacer := .t.
       
                aDbf[ 01, 3 ] := 40
                aDbf[ 02, 3 ] := 40
                aDbf[ 03, 3 ] := 40
                aDbf[ 04, 3 ] := 40
                aDbf[ 08, 3 ] := 40
                aDbf[ 10, 3 ] := 40
endif

if lHacer
                  if !( PreCopTot( cFile, 'Temp1', aDbf ) )
                        Return Nil
                  endif
endif

// aadir:   Base.dbf, Num.Campo, Nueva longitud del campo..
aadd( aBases, { 'CONTROL' , 11, 19 } )
aadd( aBases, { 'CONTROL' , 12, 15 } )
aadd( aBases, { 'MINUTA'  , 01, 15 } )
aadd( aBases, { 'MATRIZ'  , 07, 15 } )
aadd( aBases, { 'REMISION', 10, 30 } )

// Aumentar long campos datos paciente
// a peticion de antonio fernandez repeto 17 nov 1999
// OJO = DEBEN SER DE LA MISMA LONGITUD QUE EN
// PACIENTE.DBF

aadd( aBases, { 'INFORME' , 01, 40 } )
aadd( aBases, { 'MATRIZ'  , 01, 40 } )


aadd( aBases, { 'MATRIZ'  , 02, 50 } )
aadd( aBases, { 'MATRIZ'  , 03, 50 } )
aadd( aBases, { 'MATRIZ'  , 04, 50 } )
                        
nFiles := Len( aBases )

For n := 1 to nFiles

        cFile  := aBases[n,1]
        nField := aBases[n,2]
        nLong  := aBases[n,3]
                cLista += iif( at( Upper( cFile ), Upper( cLista ) ) == 0, ;
                                cFile + CRLF, '' )
        //cLista += cFile + CRLF

        usa_base( cFile, .t., '', 5, .t. )
	aDbf := DbStruct()
        ( cFile )->( DbCloseArea() )

        if aDbf[ nField, 3 ] != nLong    // , 3 ES longitud campo
                aDbf[ nField, 3 ] := nLong

                  if !( PreCopTot( cFile, 'Temp1', aDbf ) )
                        Exit    //Return Nil
                  endif
         /*        
                 COPY TO Temp1
		( cFile )->( DbCloseArea() )
		dbcreate( cFile, aDbf )
		usa_base( cFile, .t., "", 5, .t. )
		APPEND FROM Temp1
		FErase( 'TEMP1.DBF' )
        */

        Endif

Next

                         
//ENDIF
        CursorArrow()

Return Nil
//--------
//
//*****************************
function RECETAescrito( cFile )
//*****************************
// RECETA, ESCRITO, CARTA REMISION ..
// SVRECET2.DBF, SVESCRIT.DBF, SVCARTA
// En la version DOS: SVESCRIT = LA MASCARA ERA .ESC, ahora es .EST
// Era SVRECETA = Archivaba el texto en 18 campos
// CARTAS = no se archivaban.
local aDbf := {}, i := 0, lCrea := .f.
local cTarget := ''	
local cPath, cCurDrive := HB_CurDrive()
memvar cIndice

FIELD historia, fecha

cIndice := cFile
//cTarget += "\" + CurDir( cTarget ) + "\" + cFile + "\"
cTarget := ".\" + cFile + "\"	// Vale para C y RED

if !file( cFile + '.DBF' )

	aadd( aDbf, { 'NOMFICHERO', 'C', 12, 0 } )
	aadd( aDbf, { 'COMENTARIO', 'C', 59, 0 } )
	aadd( aDbf, { 'HISTORIA'  , 'C', 10, 0 } )
	aadd( aDbf, { 'FECHA'     , 'D', 08, 0 } )
	aadd( aDbf, { 'UNIDAD'    , 'C', 02, 0 } )
	aadd( aDbf, { 'DISCONUM'  , 'N', 07, 0 } )
	aadd( aDbf, { 'DIRECTORIO', 'C', 59, 0 } )

	   DbCreate( cFile, aDbf )

	usa_base( cFile, .t., '', 5, .t. )

	index on ( historia+dtos(fecha) ) to "&cIndice"

        appe_reg( 5 )   // Se aade reg num 1 para valores omision
	lCrea := .t.
else
	usa_base( cFile, .t., '', 5, .t. )
	aDbf := DbStruct()
                        ( cFile )->( DbCloseArea() )

	if Len( aDbf ) < 7
		aadd( aDbf, { 'DIRECTORIO', 'C', 59, 0 } )

//                  Mejor dejarlo asi ..
                    If FunCopToT( cFile, 'Temp1' )
                    // Se mandan y reciben cerrados
                        dbcreate( cFile, aDbf )
                        usa_base( cFile, .t., "", 5, .t. )
                        Appe_reg( 5 )   // Crea reg. 1 para datos omision y contador
                        lCrea := .t.
                        ( cFile )->( DbCloseArea() )
                    Else
                      MsgStop( 'Error al copiar de ' + cFile + ' a: Temp1', 'Aviso !.' )                        
                      Return Nil
                    Endif
       
                    If FunAppFrom( cFile, 'Temp1', , 1 )
                    // Cargar los datos sin Fallo XP
                        FErase( 'TEMP1.DBF' )
                        FErase( 'TEMP1.DBT' )
                    Else
                        If FunCopTot( 'Temp1', cFile )
                        Endif
                      MsgStop( 'Error al cargar de Temp1 a: ' + cFile, 'Aviso !.' )
                      Return Nil

                    Endif


/*
		COPY TO Temp1
		( cFile )->( DbCloseArea() )
		dbcreate( cFile, aDbf )
		usa_base( cFile, .t., "", 5, .t. )
		Appe_reg( 5 )   // Crea reg. 1 para datos omision y contador
		lCrea := .t.
		APPEND FROM Temp1
		FErase( 'TEMP1.DBF' )
*/
	Endif
                        usa_base( cFile, .t., '', 5, .t. )
                        cPath := ( cFile )->DIRECTORIO 
                        if at( '\\', cPath ) > 0
                                cPath := cTarget
                                ( cFile )->DIRECTORIO := cPath
                        endif
                        ( cFile )->( DbCloseArea() )

endif    

if lCrea        // Si ha habido creacion = valores omision reg. num 1

	( cFile )->( DbGoTop() )
	Fieldput( 01, '0' )             // '0'
	Fieldput( 02, '' )
        FieldPut( 05, Upper( cCurDrive ) + ':') // 'C:'
	FieldPut( 06, 1 )               // 1
	Fieldput( 07, cTarget )         // '\OCUL\SV..\'

	( cFile )->( dbclosearea() )

	if Upper( cFile ) == 'SVRECET2'
		CargaReceta( .t. )
	endif
endif

return( nil )
//-----------
//
//***********************************
Static Function CargaReceta( lCarga )
//***********************************
Local aListaCampos := {}, n := 0, cTxt := '', cFile := ''

IF FILE( 'SVReceta.Dbf' )
	usa_base( 'SVReceta', .t., 'SVReceta', 5, .t. )
	usa_base( 'SVRecet2', .t., 'SVRecet2', 5, .t. )

	SVRecet2->( DbGoTo( 1 ) )	// Se anota el contador
	SVRecet2->( DbGoTop() )	// Inicio por indice
	For n := 1 to SVRecet2->( FCount() )
				// Respaldo Reg. 1 -> Valores por omision
		AAdd( aListaCampos, SVRecet2->( FieldGet( n ) ) )
	Next
	Do While !( SVReceta->( Eof() ) )
		aListaCampos[ 1 ] := Str( Val( aListaCampos[ 1 ] ) +1 )
		Appe_Reg( 5 )
		For n := 1 to SVRecet2->( FCount() )-1
			SVRecet2->( FieldPut( n, aListaCampos[ n ] ) )
		Next	
			SVRecet2->( FieldPut( 1, ;
          'E' + PADL( alltrim( aListaCampos[ 1 ] ),    7, "0" ) + '.RCT' ) )
			SVRecet2->( FieldPut( 3, SVReceta->Historia ) )
			SVRecet2->( FieldPut( 4, SVReceta->Fecha ) )
  		   SVRecet2->( FieldPut( 7, AllTrim( aListaCampos[ 7 ] ) + ;
          'E' + PADL( alltrim( aListaCampos[ 1 ] ),    7, "0" ) + '.RCT' ) )
		Desbloq()
	     cFile := SVRecet2->( FieldGet( 7 ) ) // Via y nombre fich destino
		cTxt := ''	// Reiniciar
		For n := 1 to 16	// Lectura de la receta
			cTxt += SVReceta->( FieldGet( n ) ) + CRLF
		Next		
		MemoWrit( cFile, cTxt )	// Se salva fichero ..
		SVReceta->( DbSkip() )
	EndDo
	SVRecet2->( DbGoTo( 1 ) )	// Se anota el contador
	Bloq_Reg( 5 )
	SVRecet2->( FieldPut( 1, Str( Val( aListaCampos[ 1 ] ) ) ) )
	DesBloq()

	SVReceta->( DbCloseArea() )
	SVRecet2->( DbCloseArea() )
ENDIF

Return Nil
//--------
//
//***********************
static function BorrBas()
//***********************
local nCampo := 0, aCampos := { 'Nombre', 'Direccion', ;
		'Poblacion', 'Telefono', 'FechaNaci', 'FechaUlti', ;
				'Historia', 'OtrosDatos', 'Sexo', 'Alergias' }
local cFile := ''       //upper( Left( cItem, 8 ) ) + '.' 
local adirectorio

AEVAL( aCampos, { | cEl, nEl | ;        // Listados pacientes por campos
		aDirectorio := 'W' + upper( Left( cEl, 7 ) ) + '.*', ;
	aDirectorio := Directory( aDirectorio ), BasBorr( aDirectorio ) } )

aCampos := Titulos( {} )
AEVAL( aCampos, { | cEl, nEl | ;                // Listados pacientes
		cEl := AllTRim( cEl ), ;        // por patologia de expl..
		cEl := StrTran( cEl, " ", "" ), ;
		cEl := 'W' + upper( Left( cEl, 7 ) ) + '.*', ;
	aDirectorio := Directory( cEl ), BasBorr( aDirectorio ) } )

aCampos := {}
aadd( aCampos, "*.Mh?" )                // Historias
aadd( aCampos, "WPacient.*" )           // Listado pac. por apellidos
aadd( aCampos, "*.Sp?" )                // Expl. especiales
aadd( aCampos, "*.Fo?" )                // Idem     
aadd( aCampos, "Z*.Dbf" )               // Bases temporales del DOS
aadd( aCampos, "X*.Dbf" )               // Bases temporales del DOS
aadd( aCampos, "Temp*.*" )              // Bases temporales
aadd( aCampos, "*.Tmp" )                // Bases temporales
aadd( aCampos, "*.Tm" )                // Bases temporales
aadd( aCampos, "*.Red" )                // Informe reducido manual
aadd( aCampos, "*.Rct" )                // Recetas medicas        
aadd( aCampos, "*.Msv" )                // Cartas de remision     
aadd( aCampos, "*.Es?" )                // Escritos libres        
aadd( aCampos, "*.??W" )                // Temporales de estos 3 ultimos        
aadd( aCampos, "*.Als" )                // Temporales de estos 3 ultimos        
aadd( aCampos, "*.Prt" )                // Temporales de estos 3 ultimos        
aadd( aCampos, "*.Aut" )                // Temporales de estos 3 ultimos        
aadd( aCampos, "*.Imp" )                // Temporales de estos 3 ultimos        
aadd( aCampos, "*.C1?" )                // Control error motivo cons.        
aadd( aCampos, "*.C?" )                // Control error motivo cons.        
aadd( aCampos, "*.Ed?" )                // Control error motivo cons.        
aadd( aCampos, "*.Ver" )                // Control error motivo cons.        
aadd( aCampos, "G00*.Dbf" )                // Control error motivo cons.        
aadd( aCampos, "R*.Ini" )                // Menus oMru para Lasik       
aadd( aCampos, "*.ES?" )                // Temporales de escritos       
aadd( aCampos, "*.MOT" )                // Temporales de motivo de consulta

aadd( aCampos, "?0??????.JPG" )                // Temporales de IMAGENES
aadd( aCampos, "?0??????.TIF" )                // Temporales de IMAGENES       
aadd( aCampos, "?0??????.BMP" )                // Temporales de IMAGENES       
aadd( aCampos, "W00?????.ANT" )                // Temporales de TEXTO          
*
AEVAL( aCampos, { | cEl, nEl | ;
	aDirectorio := Directory( cEl ), BasBorr( aDirectorio ) } )

return( nil )
//-----------
//
//************************************
static function basborr( adirectorio )
//************************************
local fName, Fichero

fName := space(0)
//dbcloseall()
aeval( adirectorio, { | afichero | fName := afichero[1],; 
			ferase( fName )              ;
			 } )
fName := space(0)

return( nil )
//-----------
//
//*********************
Function ReindInforme( oWn )
//*********************
local aBase := directory( "Informe.dbf" )
local aInde := directory( "Informe.ntx" )
local aLista:= directory( "*.ntx" )
Field Nombre

oWnd := oWn
/*
if Len( aLista ) < 69 .and. ;
        MsgYesNo( 'REINDEXAR las BASES de Datos?', 'Elija una opcin.' )  // a Nov 2000 son 79 indices y Notas.Ntx

        MsgRun( "REINDEXANDO, Espere ..", ;  // Reindexado Automatico
                "Ficheros ..", { || IndexFun( oWnd, .t. ) } )

    MsgWait( "INDICES Actualizados.." ,"Ficheros ..", 2 )
    DbCloseAll()
    Return .f.
endif
*/
aInde := Iif( Empty( aInde ), ;
		{ { 'Sin Indice', 0, Ctod( '' ), '00:00:00' } }, aInde )

// Se desfasa el indice si se usa desde el DOS
// que esa version usa la base informe.dbf sin indice ..
if aBase[ 1, 3 ] > aInde[ 1, 3 ] .or. ;
        ( aBase[ 1, 3 ] == aInde[ 1, 3 ] ) .and. ;
                               ( aBase[ 1, 4 ] > aInde[ 1, 4 ] )
/*
	MsgInfo( aBase[ 1, 1 ] + '   ' + ;
		DtoC( aBase[ 1, 3 ] ) + '   ' + aBase[ 1, 4 ] + CRLF + ;
			 aInde[ 1, 1 ] + '   ' + ;
		DtoC( aInde[ 1, 3 ] ) + '   ' + aInde[ 1, 4 ] + CRLF + ;
			CRLF + 'SE VA A REINDEXAR .. ', 'Informacin' )
*/
/*
	CursorWait()
	Usa_base( 'Informe', .t., '', 5, .t. )
	DBCREATEINDEX( "INFORME", "NOMBRE", { || NOMBRE } )
	//INDEX ON Nombre TO Informe
	Informe->( DbCloseArea() )
	CursorArrow()
*/
endif
// o sea que en 2012 ya aqu no se hace nada, sino en reindexar.
Return .f.
//--------
//
//*******************************************
static function basSave( adirectorio, cPath )
//*******************************************
local fName, Fichero

cPath := Trim( CurDir( HB_CurDrive() ) ) + ":\" + cPath + "\"
fName := space(0)
dbcloseall()
aeval( adirectorio, { | afichero | Memory( -1 ), fName := afichero[1],; 
	iif( !File( cPath + fName ), LZCopyFile( fName, cPath + fName ), ) ;
			 } )
	// Se salva si no lo estaba, de lo contrario puede ser
	// un temporal con num. hist. pac. y machacaria sin deberlo hacer 
	// pues se habria elegido no salvar

return( nil )
//-----------
//
//************************
       function mantener( lEdit )
//************************
local aBases := {}, i, veces, aTabla, Fichero, cTxt := ''
local cFile := 'MANTENER.DAT',dMant := CtoD( '' ), aMant := { 0, '' }
local nDias := 100, nCons := 100, nVan := 100, nRegs := 0
DEFAULT lEdit := .f.

cLista := ''// Statica, lista de bases mantenidas ..

 RETURN NIL // ESTO ERA PARA ANA GLARIA PROVISIONALMENTE ..
            // y puerta del mar 01-12-03

            // Y SE RESTABLECE EN 2005 POR NO USARSE YA
            // LOS CAMPOS MEMO, SUSTITUIDOS POR ARCHIVOS DE TEXTO
            // EN SUBDIRECTORIOS.

            // Y en 2006 se vuelve a quitar para mas seguridad de datos


if !File( cFile )
     nVan := 101
     nDias:= 100
     MemoWrit( cFile, '1' )
//     if !File( 'MANTDIAS.DAT' )
             MemoWrit( 'MANTDIAS.DAT', '100' ) 
//     endif
//     MemoWrit( cFile, DtoC( Date() -6 ) )
//     MemoWrit( 'MANTDIAS.DAT', '100' ) 
//     MemoWrit( 'MANTREGS.DAT', '0' ) 
else
     nVan := Val( AllTrim( MemoRead( cFile ) ) )
//     dMant := CtoD( Trim( MemoRead( cFile ) ) )
     nDias :=  Val( Trim( MemoRead( 'MANTDIAS.DAT' ) ) )
     nDias :=  Max( nDias, 25 )
     nDias :=  Min( nDias, 500 )
//     nCons :=  Val( Trim( MemoRead( 'MANTCONS.DAT' ) ) )
endif
     if !Empty( AllTrim( MemoRead( 'MANTERR.LOG' ) ) )
        if MsgYesNo( 'Hay un Mensaje de ERROR' + CRLF +;
                'en MANTENIMIENTO anterior.' + CRLF +;
                'Desea LEERLO?.', 'Elija una opcin.' )
                MemoEdit( AllTrim( MemoRead( 'MANTERR.LOG' ) ) )
               ? 'NO DEBERIA USAR EL PROGRAMA',;
                  'SIN CONSULTAR ANTES AL RESPECTO',;
                  'YA QUE PUEDE PERDER MUCHOS DATOS..'
        endif
     endif
//if Date() - dMant < nDias       //15    // 7
if nVan < nDias 
        //nCons

        MemoWrit( cFile, AllTrim( Str( nVan + 1 ) ) )
        Return Nil
else
        /*
        IF MsgYesNo( 'Corresponde MANTENIMIENTO de DATOS.'+CRLF+;
                  'Es un proceso LENTO que NO debe INTERRUMPIR' +CRLF +;
                  'una vez INICIADO.' + CRLF + CRLF + ;
                  'HACER EL MANTENIMIENTO AHORA?.', 'Elija una opcin.')
        ELSE
        
                Return Nil
        ENDIF
        */
     MemoWrit( cFile, '1' )
     MemoWrit( 'CIRUGMEM.DAT', DtoC( Date() ) )

        MsgRun( "Efectuando MANTENIMIENTO, Espere ..", ;
                "Ficheros ..", { || Mantener2() } )

//                "Ficheros ..", { || aMant := Mantener2() } )

if nMant == 0   //aMant[ 1 ] == 0
        MemoWrit( 'LISTMANT.DAT', cLista )

     MsgWait( "MANTENIMIENTO Terminado.." ,"Ficheros ..", 2 )
if File( 'LISTMANT.DAT' ) .and. lEdit
        MemoEdi2( MemoRead( 'LISTMANT.DAT' ) )
//        WinExec( 'NOTEPAD.EXE ' + 'LISTMANT.DAT', 1 )
endif
     if File( 'MANTERR.LOG' )
        MemoWrit( 'MANTERR.OLD', AllTrim( MemoRead( 'MANTERR.LOG' ) ) +;
                CRLF + AllTrim( MemoRead( 'MANTERR.OLD' ) ) )
                // Se crea una especie de historia de errores
                // que contiene todos loas ficheros alterados..
        Ferase( 'MANTERR.LOG' )
     endif
else
//          aMant[ 2 ] + CRLF +

       cTxt := 'ERROR de MANTENIMIENTO: ' + Str( nMant ) + CRLF +;
          cMant + CRLF + ;
          'PUEDE HABERSE PRODUCIDO'+ CRLF +;
          'IMPORTANTE PERDIDA DE DATOS' +CRLF + ;
          'DEBEN REVISARSE SUS BASES DE DATOS' +CRLF + ;
          'HABLE CON SU PROVEEDOR.'
       MemoWrit( CtoD( DATE() ) + CRLF + cTxt +;
                CRLF + MemoRead( 'MANTERR.LOG' ), 'MANTERR.LOG' )
       If MsgYesNO( cTxt + CRLF + CRLF +;
        'DEBE CERRAR EL PROGRAMA' + CRLF + 'CONFORME?', 'Elija una opcin.' )
                QUIT
       EndIf
//       MemoWrit( CtoD( DATE() ) + CRLF + cTxt, 'MANTERR.LOG' )
endif

endif

// Fin control mantener

Return Nil

static function mantener2()
local aBases := {}, i, veces, aTabla, Fichero
local cFile := 'MANTENER.DAT',dMant := CtoD( '' ), lMant := .t.
local nLast := 0, nLastNw := 0   //, cMant := '', nMant := 0
local aDirect1 := {}, aDirect2 := {}

DbCloseAll()

    // Lista de BASES con campos MEMO para mantenimiento..
    aadd( aBases, 'Anal' )

/*  SOLO SE HACE DE ANAL.DBF Y LOS CIRUG...

    aadd( aBases, 'MOTIVO' )
    usa_base( 'Motivo', .t., '', 5, .t. )
    if Motivo->( FCount() ) < 3
         Motivo->( DbCloseArea() )
         Colegiado2()   // Modificar estructurassss...
    endif

DbCloseAll()

FOR I := 1 TO 14            // B1 a B14..
    aadd( aBases, 'B' + AllTrim( Str( I, 2, 0 ) ) )
NEXT
*/
FOR I := 1 TO 3            // CIRUG01, 2, Y 3 ..
    aadd( aBases, 'CIRUG0' + AllTrim( Str( I, 2, 0 ) ) )
NEXT

CursorWait()
veces := len( aBases )

//      @ 05 , 20 say 'Mantenimiento de ficheros.' COLOR 'w+/b'
//      @ 06 , 20 say '--------------------------' COLOR 'w+/b'

cLista += 'Lista de MANTENIMIENTO efectuado:' + DToC( Date() ) + CRLF

for i = 1 to veces

        Memory( -1 )

        fichero := aBases[ i ]
        if !File( fichero + '.Dbf' )    // Cirug puede no existir an
             i ++      
             Loop
        endif

	usa_base( fichero, .t., '', 5, .t. )
	aTabla := ( fichero )->( DbStruct() )
        nLast  := ( fichero )->( LastRec() )
	( fichero )->( DbCloseArea() )

        /* COPY TO Temporal  .. Fallo en XP..' */

    // Creacion de copia temporal sin fallo en XP
                  if !( PreCopTot( Fichero, 'Temporal', aTabla, i ) )
                        Exit    //Return Nil
                  endif

                cLista += iif( at( Upper( fichero ), Upper( cLista ) ) > 0, ;
                                fichero + CRLF, '' )
//cLista +=  fichero + CRLF

if lCancel
     cLista +=  'MANTENIMIENTO INTERRRUMPIDO POR USUARIO.' + CRLF
     lCancel := .f.
     exit
endif

next             
 
        CursorArrow()

return( Nil )   //{ nMant, cMant } )
//-----------
function Mostrar( oMeter, oText, oDlg, lEnd, nLast, ;
                                        Fichero, Temporal, nFields )
local nI := 0, lOk := .t.
local aF := Array( nFields )

   oMeter:nTotal = nLast
   aFill( aF, 0 )

//      DBEVAL( {|| oMeter:Set( RecNo() ), SysRefresh(), ! lEnd } )

// Mejor con FieldName por si se usa tras crear un campo nuevo ..
// Mas seguro usar el num de campo, pues los aadidos nuevos van siempre
// a cola..
//        Do While !( ( Temporal )->( eof() ) )        // y se copian los datos
//                ( Fichero )->( DbAppend() )

/*                      ( Fichero )->( FieldPut( n, ;
                                 ( Temporal )->( FieldGet( n ) ) ) ) ;
                                } ), ;
*/

        ( Temporal )->( DbEval( {|| ;
                ( Fichero )->( DbAppend() ),;
                Eval( {|| oMeter:Set( ( Fichero )->( RecNo() ) ), ;
                                                SysRefresh(), ! lEnd } ),;
                aEval( aF, { | c, n | ;
                       aF[ n ] := ( Temporal )->( FieldGet( n ) ) } ),;
                aEval( aF, { | c, n | ;
                      ( Fichero )->( FieldPut( n, aF[ n ] ) ) } ),;
                                         Memory( -1 ) ;
                                        } ) )       // Cierra DbEval
/*
                For nI = 1 To nFields

                      ( Fichero )->( FieldPut( nI, ;
                                 ( Temporal )->( FieldGet( nI ) ) ) )
                Next
*/ 
//                Memory( -1 )

//                ( Temporal )->( dbskip() )
//        EndDo
   

return nil

// Para superar falta compatibilidad comandos MSDos con Win XP ..
// pasando a usar funciones del api de clipper, quizas mas seguras..
  Function FunAppFrom( Fichero, Temporal, nBase, nMas )
Local lOk := .t., nI := 0, nReg := 0, nLast := 0, nFields := 0
Local lSeguir := .t., cFldNam := ''
DEFAULT nBase := 1
DEFAULT nMas  := 0

        usa_base( Fichero, .t., '', 5, .t. )
        usa_base( Temporal, .t., '', 5, .t. )
        nLast   := ( Temporal )->( LastRec() )                    
        nFields := MIN( ( Temporal )->( FCount() ),;
                                ( Fichero )->( FCount() ) )

//                APPEND FROM Temp1

   xMsgMeter( { | oMeter, oText, oDlg, lEnd | ;
             Mostrar( oMeter, oText, oDlg, @lEnd, ;
                        nLast, Fichero, Temporal, nFields ) },;
             AllTrim( Str( nBase ) ) + ' - Base: ' + Fichero + ' ...', ;
                             'Efectuando Mantenimiento..' )


// Mejor con FieldName por si se usa tras crear un campo nuevo ..
// Mas seguro usar el num de campo, pues los aadidos nuevos van siempre
// a cola..
/*        Do While !( ( Temporal )->( eof() ) )        // y se copian los datos
                ( Fichero )->( DbAppend() )
                For nI = 1 To nFields

                      ( Fichero )->( FieldPut( nI, ;
                                 ( Temporal )->( FieldGet( nI ) ) ) )
                Next
                      ( Temporal )->( dbskip() )
                Memory( -1 )
        EndDo
*/
      lOk := ;
        ( ( Fichero )->( LastRec() == ( Temporal )->( LastRec() ) + nMas ) )
        ( Temporal )->( DbCloseArea() )
        ( Fichero )->( DbCloseArea() )

Return lOk
//--------

  Function PreCopTot( cFile, Temp1, aDbf, nBase )
DEFAULT nBase := 1

                    If FunCopToT( cFile, Temp1 )
                    // Se mandan y reciben cerrados
                        dbcreate( cFile, aDbf )
                    Else
                      MsgStop( 'Error al copiar de ' + cFile + ' en: ' + Temp1, 'Aviso !.' ) 
                      Return .f.
                    Endif
                    If FunAppFrom( cFile, Temp1, nBase )
                    // Cargar los datos sin Fallo XP
                        FErase( 'TEMP1.DBF' )
                        if File( 'TEMP1.DBT' )
                                FErase( 'TEMP1.DBT' )
                        endif
                    Else
                        If FunCopToT( Temp1, cFile )
                        Endif
                      MsgStop( 'Error al cargar de Temp1 a: ' + cFile, 'Aviso !.' )
                      Return .f.

                    Endif


  Return .t.

  Function FunCopToT( Fichero, Temporal )
//---------------------------------------
local aDirect, lOk := .t.
local aDirect1 := {}, aDirect2 := {}
       Memory( -1 )
       if at( '.', Fichero ) > 0

            LZCopyFile( Fichero, Temporal )
            if File( Temporal )
                        aDirect1 := Directory( Fichero )
                        aDirect2 := Directory( Temporal )
   //   ? aDirect1[ 1, 2 ], aDirect2[ 1, 2 ]
                        IF aDirect1[ 1, 2 ] != aDirect2[ 1, 2 ]
  //                              'CREA MAL a ' + Temporal + ' !.'
    //                        nMant := 1
                            lOk := .f.
                        endif
                        Return( lOk )
            endif
       endif

       LZCopyFile( Fichero + '.DBF', Temporal + '.Dbf' )
       if File( Fichero + '.DBT' )
               Memory( -1 )
               LZCopyFile( Fichero + '.DBT', Temporal + '.Dbt' )
       //endif
       else
        aDirect1 := Directory( Fichero  + '.Dbf' )
        aDirect2 := Directory( Temporal + '.Dbf' )

     /* ? Fichero  + '.Dbf = ', File( Fichero  + '.Dbf'), ;
                aDirect1[ 1, 2 ], Temporal + '.Dbf = ',;
                File( Temporal + '.Dbf'), aDirect2[ 1, 2 ]
       */
          IF aDirect1[ 1, 2 ] != aDirect2[ 1, 2 ]
            cMant += Fichero + '.Dbf' + ;
                'CREA MAL a ' + Temporal + '.Dbf' + ' !.'
            nMant := 1
            lOk := .f.
          ENDIF
            return( lOk )

       endif
       Memory( -1 )

       IF File( Temporal + '.Dbf' ) .and. File( Temporal + '.Dbt' )

        aDirect1 := Directory( Fichero  + '.Dbf' )
        aDirect2 := Directory( Temporal + '.Dbf' )

          IF aDirect1[ 1, 2 ] != aDirect2[ 1, 2 ]
            cMant += Fichero + '.Dbf' + ;
                'CREA MAL a ' + Temporal + '.Dbf' + ' !.'
            nMant := 1
            lOk := .f.
 
          ENDIF

       ELSE
            cMant += Fichero + '.Dbf' + ;
                'NO CREA el ' + Temporal + '.Dbf' + ' !.'
            nMant := 3
            lOk := .f.
       ENDIF

Return lOk
//
//----------------------
Function ResetBasTemp( nRun ) // Eliminar ficheros temporales de consulta anterior
//----------------------
Local nLast, aDbf := {}, lDel := .f., cUlti := ''
DEFAULT nRun := 1

// Eliminacion de ficheros temporales de fecha anterior ..
usa_base( 'Historic', .f., 'historic, historia', 5, .t. )
// estaba en modo exclusivo, se pone compartido, 2006
// para evitar error red xp..
// se crea nuevo sistema con cUlti para q solo se ejecute una vez al dia
// cuando sea llamado

//cUlti := CtoD( MemoRead( 'cUlti.Dat' ) )

nLast := Historic->( LastRec() )
Historic->( DbGoto( nLast ) )   //Bottom() )

//if cUlti < Date()
//? date()
//? Historic->Fecha 
// Ya  se controla desde Wocul3.prg al iniciar la aplicacion
//if ( Historic->Fecha ) < Date()
//? 'Vale'
	BorrBas()
	Mantener()

        if nRun == 0    // regs de historic.dbf vacios
                Do While Empty( Historic->Historia ) .and. ;
                                        !( Historic->( Bof() ) )

                        Historic->( DbDelete() )
                        if Historic->( Deleted() )
                                lDel := .t.
                        endif
                        Historic->( DbSkip( -1 ) )
                EndDo

                if lDel         //Historic->( Deleted() )
		      HB_DBPACK()  // PACK
                endif
        endif
//endif
/*
MemoWrit( 'cUlti.Dat', DtoC( Date() ) )  

	DbCloseAll()
        DbCloseAll()
*/

Return( nil )
//-----------
//--------------------------------
function su_clave( base_acc, xn, cResp, lIni )   && pide claves de acceso ..
local bqi, bqtono, bqresp := .f., veces := 3, aPass := { '', 0, 0 }
local cNivel := '4', lNivel := .f.
//local cResp := space( 4 )
FIELD nivel

DEFAULT lIni := .t.

set intensity on

cResp := alltrim( cResp )
cResp := cResp + space( 4 -len( cResp ) )

      usa_base( base_acc, .f., "", 5 )
   
      // bloque de proteccion de errores por usuario principal
      if lastrec() == 0   // error por borrado todos los registros
	 appe_reg( 5 )
	 desbloq()
      endif

   for bqi := 1 to lastrec() // error por no haber ninguna clave archivada
      dbgoto( bqi )
      bqresp := iif( !empty( fieldget( xn ) ), .t., bqresp ) 
      lNivel := iif( !lNivel, ( at( cNivel, fieldget( 2 ) ) > 0 ), lNivel )
   next
   if !lNivel	// Si no hay ningun nivel 4 hay q crearlo
      dbGoTo( 1)
      bloq_reg( 5 )
      fieldput( 2, "4" )
      desbloq()
   endif
   if bqresp == .f.          // reparacion del error
      dbGoTo( 1)
      bloq_reg( 5 )
      fieldput( 2, "4" )
      fieldput( xn, "13" )
      desbloq()
   endif
   // fin bloque proteccion
*
if lIni	// Llamada inicio programa
   locate for AllTrim( fieldget( xn ) ) == AllTrim( cresp )

   bqresp := .f.   

   if found()
		// aqui nNivelAcc y nUsuario
	 nUsuario  := recno()
	 nNivelAcc := val( nivel )
	      aPass[ 1 ] := cResp        
	      aPass[ 2 ] := nNivelAcc    
	      aPass[ 3 ] := nUsuario     

      if Lis_red->( Fcount() ) > 30
	 if empty( Lis_red->nFRGBColor ) .and. empty( Lis_red->nColorDlg )
		bloq_reg( 5 )
		Lis_red->nFRGBColor := nRGB( 255, 255, 255 )
		Lis_red->nColorDlg  := nRGB( 255, 255, 255 )
		Desbloq()
	 endif
      endif
   else

	cResp := replicate( chr( 64 ), 20 )

   endif

//else	// Llamada tras modificar claves de acceso
//	Return nil
endif
   DbCommitAll()
   DbCloseAll()

return aPass    //( alltrim(cResp) )
//---------------------
function noentrar()
local ca10 := "Acceso denegado a NIVEL = " + str( nnivelacc, 1 )
MsgAlert( ca10, 'Atencin !.' )
return( nil )
//-----------
function Titulos( aTitulo )

DEFAULT aTitulo := {}

aadd( aTitulo,  ( "   Polo anterior    " ) )
aadd( aTitulo,  ( "    Fondo ocular    " ) )
aadd( aTitulo,  ( "     Refraccin     " ) )
aadd( aTitulo,  ( "    Tonometras     " ) )
aadd( aTitulo,  ( "     Motilidad      " ) )
aadd( aTitulo,  ( "     Biometra      " ) )
aadd( aTitulo,  ( " Reflejos pupilares " ) )
aadd( aTitulo,  ( "    Campo visual    " ) )
aadd( aTitulo,  ( "  Vas lagrimales   " ) )
aadd( aTitulo,  ( "   Biomicroscopa   " ) )
aadd( aTitulo,  ( "  Vision cromtica  " ) ) 
aadd( aTitulo,  ( "   Otras tcnicas   " ) ) 
aadd( aTitulo,  ( "    Diagnstico     " ) ) 
aadd( aTitulo,  ( "    Tratamiento     " ) )

return( aTitulo )
//---------------
//
//***********************
Function SelArea( cArea )
//***********************
local lHay := .f., aBases := aGetWorkAreas()

if !Empty( cArea ) .and. !Empty( aBases )
	aEval( aBases, { | cEl, nEl | ;
		aBases[ nEl ] := Upper( cEl ) } )

	if Ascan( aBases, Upper( cArea ) ) > 0
	   DbSelectArea( cArea )
	   lHay := .t.  
	endif
endif

return lHay
//---------
//
//*******************************************
function Copiar( cFileOrig, letra, lSelOrig, lImagen )
//*******************************************
local cFileDest := cFileOrig
local lG32 := ( File( GetWinDir() + "\RunDll32.exe" ) .or. ;
                        File( GetSysDir() + "\RunDll32.exe" ) ) .or. ;
( File( GetWinDir() + "\RunDlg32.exe" ) .or. ;
                        File( GetSysDir() + "\RunDlg32.exe" ) )
DEFAULT letra    := '', cFileOrig := ''
DEFAULT lSelOrig := .t.
DEFAULT lImagen  := .f.
                      
if lSelOrig .or. Empty( cFileOrig )
          cFileOrig := ;
             cGFile( cFileOrig, letra, 'Elija Fichero de ORIGEN', lImagen )
endif

//     ? lG32
// La funcion va perfecta con y sin usar RunDlg32.exe
// No encuentro las diferencias..

If !Empty( cFileOrig ) .and. File( cFileOrig )

	  cFileDest := cGFile( cFileName( cFileOrig ), letra, ;
                       'Elija Fichero de DESTINO', lImagen, .t. )

	if Empty( cFileDest )
		MsgStop( "No se ha elegido" + CRLF + ;
			"o NO se encuentra" + CRLF + ;
			"Fichero de DESTINO", 'Aviso !.' )
		Return nil
	endif
else
	MsgStop( OemToAnsi( 'No se ha elegido' + CRLF + ;
		' NO se encuentra' + CRLF + ;
		'Fichero de ORIGEN' ), 'Aviso !.' )
	Return nil
endif

if !Empty( cFileOrig ) .and. !Empty( cFileDest )

    If !File( cFileDest ) .or. MsgYesNo( cFileDest + CRLF + ;
		'Ya existe' + CRLF + 'Desea Sobreescribir?', 'Elija una opcin.' )
	if cFileDest == cFileOrig
		MsgStop( 'Fichero: ' + cFileOrig + CRLF + ;
			'No puede copiarse a si mismo..', 'Aviso !.' )
	else 
		CursorWait()
                Memory( -1 )
                LZCopyFile( cFileOrig, cFileDest )
		CursorArrow()
		MsgInfo( 'ORIGEN: ' + cFileOrig + CRLF + ;
			'DESTINO: ' + cFileDest + CRLF + CRLF + 'Copia ' + ;
		iif( File( cFileDest ), '', 'NO' ) + ' Conseguida !..', 'Informacin' )
	endif
    else
		MsgInfo( 'Copia NO efectuada ..', 'Informacin' )
    endif

Endif

return Nil      //cFilePath( cFileDest )
//---------------------------
//
//******************************************
       Function cGFile( cFile, letra, cTit, lImagen, lSave )
//******************************************
local cMasc := '', cPath := ".\", cFTx := cFile
local cPlt := '', nIF := 1
local lG32 := ( File( GetWinDir() + "\RunDlg32.exe" ) .or. ;
                        File( GetSysDir() + "\RunDlg32.exe" ) )
DEFAULT letra   := '?'
DEFAULT lSave   := .f.
DEFAULT lImagen := .f.
cMasc := Iif( !Empty( cFile ), Substr( cFile, AT( ".", cFile ) ), '' )
cPath := iif( Empty( cFilePath( cFile ) ), cPath, cFilePath( cFile ) )
nIf := iif( nGetFileFilter() > 0, nGetFileFilter(), nIf )

 If at( '.BM', upper( cMasc ) ) > 0 .or. lImagen

	cPlt := "Plantillas ( *.Bmr ) | *.Bmr |" + ;
	"Dibujos archivados ( " + letra + "*.Bmp ) | " + letra + "*.Bmp |" + ;
        "Plantillas ( *.Bmp ) | *.Bmp |" + ;
                             "BMP   (*.bmp)| *.bmp|" +          ;
                             "DIB   (*.dib)| *.dib|" +          ;
                             "PCX   (*.pcx)| *.pcx|"  +         ;
                             "JPEG  (*.jpg)| *.jpg|" +          ;
                             "GIF   (*.gif)| *.gif|"  +         ;
                             "TARGA (*.tga)| *.tga|" +          ;
                             "RLE   (*.rle)| *.rle|"
 else
	cPlt := Iif( !Empty( cFile ), ;
		( "Archivos ( *" + cMasc + ") | *" + cMasc + "|" ), '' ) 
 endif

cFile := iif( !Empty( cFile ), ( " (" + cFile + " ) |" +  cFile + "|" ), '' )

    if lG32
       cFile := cGetFile32( cFile + cPlt + ;
       iif( lImagen, '',    "Bases datos ( *.Db? ) | *.Db? |" + ;
        "De Texto ( *.Txt ) | *.Txt | " ) + ;
	"Todos ( *.* ) | *.* " , ;
        cTit, nIF, cPath, lSave, , cFTx )
    else
       cFile := cGetFile( cFile + cPlt + ;
       iif( lImagen, '',    "Bases datos ( *.Db? ) | *.Db? |" + ;
        "De Texto ( *.Txt ) | *.Txt | " ) + ;
	"Todos ( *.* ) | *.* " , ;
        cTit, nIF, cPath, lSave, .t. )
   endif
   
Return cFile
//----------
//
//**************************************
Function FunCopy( cFileOrig, cFileDest )
//**************************************
local lValor := .f., cMsg := '', bViaFil
local ViaFil := cFileDest	//, cFile
local cDir, n
local cCad1 := '', cCad2, bCad, n2, ;
        aFOrig  := Directory( cFileOrig ), aFDest := Directory( cFileDest )

if cFileOrig == cFileDest // Si es sobre si mismo
	Return .t.        // Se da la copia por hecha
endif

	CursorWait()

// Nombre, Tamao, Fecha y Hora..
if !Empty( aFOrig ) .and. !Empty( aFDest ) .and. ;
        aFOrig[ 1, 2 ] == aFDest[ 1, 2 ] .and. ;
        aFOrig[ 1, 3 ] == aFDest[ 1, 3 ] .and. ;
        aFOrig[ 1, 4 ] == aFDest[ 1, 4 ]
        // NO se ha modificado, no hay que copiarlo..

	Return .t.        // Se da la copia por hecha
else
        Memory( -1 )
        LZCopyFile( cFileOrig, cFileDest )
        Memory( -1 )
endif

aFDest := Directory( cFileDest ) // Para comprobar q se ha copiado
        
if !Empty( aFOrig ) .and. !Empty( aFDest ) 

     if aFOrig[ 1, 2 ] == aFDest[ 1, 2 ] .and.  ;
        aFOrig[ 1, 3 ] == aFDest[ 1, 3 ] .and.  ;
        aFOrig[ 1, 4 ] == aFDest[ 1, 4 ]

        lValor := .t.           //iif( File( cFileDest ), .t., lValor )

     else
        cMsg := 'NO'            //iif( File( cFileDest ), cMsg, "NO " )

     endif
else
        cMsg := 'NO'            //iif( File( cFileDest ), cMsg, "NO " )
endif

	if !( lValor )
		MsgInfo( "Copia " + cMsg + "conseguida ..!!" + CRLF + ;
			"Origen: " + cFileOrig + CRLF + ;
			"Destino: " + cFileDest, 'Informacin' )
	endif

	CursorArrow()

Return lValor
//-----------
//
//***************************************
       Function Salva( aLista, nLlamada )
//***************************************
local cFileOrig := '', cDisc, cPath, cFile, cNum := aLista[ 2 ]
local cFileDest, cUnidad := 'C', nUnidad := 1, nSize := 1, aTabla := {}
local lSalvado := .f., cCurDrive := HB_CurDrive()

DEFAULT nLlamada        := 0    // 3 -> Llamado desde wocfosp3.prg
				// 1 ->               wocfosp1.prg

/*      Valores de aLista desde wocfosp3.prg
aLista[ 1 ] = Fecha, en tipo fecha
 ....   2   = Numero del disco si es externo, en caracteres

	3       Unidad: a:, b, c, d: ...
	4       Directorio
	5       Nombre del fichero

	6       Comentarios
	7       Recno
	
	Se corresponden con los campos del registro desfasados en -1,
	o sea que aLista[ 2 ] es para el campo numero 3
y en Argon Unidad = es lo mismo en el array
 */

        // Origen = Directorio de la consulta
        cFileOrig := Trim( cCurDrive ) + ':\' + CurDir() + '\' + ;
                                AllTrim(cFileName( alltrim( aLista[ 5 ] ) ))

        cDisc := aLista[ 3 ] 
        cDisc := cCurDrive
//        cDisc := iif( Empty( cDisc ), HB_CurDrive(), cDisc )
        cDisc := Left( Upper( Alltrim( cDisc ) ), 1 ) + ':'
        cUnidad    := Upper( Left( cDisc, 1 ) )
	nUnidad    := Asc( cUnidad ) -64        // Para DiskSpace()

        if Empty( aLista[ 4 ] )
                aLista[ 4 ] := '\' + CurDir() + '\'
	endif 
        cPath      := cFilePath( AllTrim( aLista[ 4 ] ) )
        cPath      := SubsTr( cPath, Rat( ':', cPath )+1 )
        // Se guarda en el subdirectorio tipico del programa
        // pero la unidad q habria anotada ya no es valida porq
        // se ha cambiado de unidad posiblemente por variar el equipo..
        if AT( CurDir(), cPath ) > 0 .and. ;
                Left(AllTrim( Upper( cCurDrive ) ),1)  != ;
                                 Left(AllTrim( Upper( cDisc ) ),1)
                // Se archiva en el subdirectorio de la consulta
                cDisc := Left( AllTrim( Upper( cCurDrive ) ), 1 )
                aLista[ 3 ] := cDisc
                cDisc := cDisc + ':'
        endif
        
        cFile      := cFileName( AllTrim( aLista[ 5 ] ) )

        // Destino = Directorio para archivar
        cFileDest  := cDisc + cPath + AllTrim( cFile )

        aTabla     := Directory( cFileOrig )
	if !Empty( aTabla )
		nSize      := aTabla[ 1, 2 ]
	endif

if !( File( cFileOrig ) )
	MsgStop( cFileOrig + CRLF + 'No existe', 'Aviso !.' )
        Return .f.
endif

if DiskSpace( nUnidad ) <= nSize

        if ! MsgYesNo( cFileName( cFileDest ) + ' = ' + CRLF + ;
                        AllTrim( Str( nSize / 1000 ) ) + ' Kb.' + CRLF + ;
                'NO cabe en: ' + cFilePath( cFileDest ) = + CRLF + ;
        AllTrim( Str( DiskSpace( nUnidad ) / 1000 ) ) + ' Kb.'  + CRLF + ;
		'CAMBIAR el disco / ANULAR copiar' + CRLF + ;
		'Elije CAMBIAR?', 'Elija una opcin.')
			Return .f.
	else
		// Operaciones para anotar el cambio de disco ..?
	     Do Case

		// Desde wocfosp1 y 3.prg
	     Case nLlamada == 1 .or. nLlamada == 3   
		If MsgGet( "Variar Numero del disco", ;
			"Unidad: " + cDisc + CRLF + ;
			"Entre Nuevo Numero: ", @cNum ) 
			Bloq_reg( 5 )
			FieldPut( 3, cNum ) // Se archiva
			DesBloq()
		Endif
	     Endcase
	endif
endif 

if ( FunCopy( cFileOrig, cFileDest ) )
	Return .t.
endif

if cFilePath( cFileOrig ) != cFilePath( cFileDest )     //.and.  
//    if !( lIsDir( cFilePath( cFileDest ) ) ) // fALLA .. //.and. 
	if MsgYesNo( 'Introduzca Disco Num.: ' + aLista[ 2 ] + CRLF + ;
			'de la Unidad: ' + cDisc + CRLF + ;
			'para Salvar: ' + cFileOrig + CRLF + ;
			'en:  ' + cFileDest, 'Elija una opcin.' )

            lSalvado := .f.
            Do while ! lSalvado
            lSalvado := ( FunCopy( cFileOrig, cFileDest ) ) .and. ;
		MsgYesNo( 'Via Destino: ' + cFilePath( cFileDest ) + CRLF + ;
			'No encontrado' + CRLF + ;
                        'Buscar en otras unidades?', 'Elija una opcin.' )

                    cFileDest := cGetFile(  cFileName( cFileDest ) + ;
			"Imagenes ( *.Bmp ) | *.Bmp | " + ;
			"Todos ( *.* ) | *.* " , ;
                        "Elija Destino ", 01, ".\", .t., .t. )

	    enddo       

	endif   // De si msgyesno = si
//   endif      // De si hay el directorio o no
/*
    if File( cFileOrig) .and. ;
	FunCopy( cFileOrig, cFileDest )
    else
	MsgInfo( 'Fichero: ' + cFileOrig + CRLF + ;
		'NO encontrado' + CRLF + 'Copia NO efectuada' )
    endif
*/
endif

Return lSalvado         //.t.
//--------
//
//********************************
       Function Restaura( aLista )
//********************************
local cFileOrig := '', cDisc, cPath, cFile 
local cFileDest, aDrvs := aDrives(), n := 0, cCurDrive := HB_CurDrive()

/*      desde wocfosp1.prg argon
	aadd( aRest, { OemToAnsi( DTOC( Argon->Fecha ) ),;
			 OemToAnsi( Argon->Disco ),;
			 OemToAnsi( Argon->Unidad ),;
			 OemToAnsi( Argon->Directorio ),;
			 OemToAnsi( Argon->NomImagen ) ,;
			 OemToAnsi( Argon->Descripcio ), Recno() } )

        desde wocfosp3.prg      imagenes fo y polo ant...
	aadd( aValores, { OemToAnsi( DTOC( (cBase)->Fecha ) ),;
			 OemToAnsi( (cBase)->Tecnica ),;	// Disco
			 OemToAnsi( (cBase)->Ojo ),;		// Unidad
			 OemToAnsi( (cBase)->Motivo ),;		// Directorio
			 OemToAnsi( (cBase)->Numero ),;		// Fichero
			 OemToAnsi( (cBase)->Descripcio ), Recno() } )
*/
        cDisc := aLista[ 3 ] 
        cDisc := iif( Empty( cDisc ), cCurDrive, cDisc )
        cDisc := Left( Alltrim( cDisc ), 1 ) + ':'
  //? cDisc
  //MsgList( aDrvs )                                              
   iif( ASCAN( aDrvs, { |x| Left(Upper( Trim( x ) ),1) == ;
                                Left(Upper(Trim(cDisc)),1) } ) > 0, Nil, ;
        MsgAlert( 'La UNIDAD  ' + cDisc + CRLF + ;
                        'No Existe o No esta CONECTADA !.', 'Atencin !.' ) )

        cPath      := cFilePath( AllTrim( aLista[ 4 ] ) )
        cPath      := SubsTr( cPath, Rat( ':', cPath )+1 )
        cFile      := cFileName( alltrim( aLista[ 5 ] ) )

        // Se guard en el subdirectorio tipico del programa
        // pero la unidad q habria anotada ya no es valida porq
        // se ha cambiado de unidad posiblemente por variar el equipo..
        if AT( CurDir(), cPath ) > 0 .and. ;
          Left(AllTrim( Upper( cCurDrive ) ),1) != ;
                                        Left(AllTrim( Upper( cDisc ) ),1)

                // Se  lee donde estaba, aunque luego se
                // Se archive en el subdirectorio de la consulta ...

                // Si no est en la unidad q seria antigua
                // y esta en subdir propia consulta, cogerlo de aqui
                // o si esta en los dos pero aqui el mas actualizado
                if !( File( cDisc + cPath + cFile ) ) .or. ;
                      ( File( AllTrim( cCurDrive ) + ':' + cPath + cFile ) )
                      aLista[ 3 ] := cDisc := AllTrim( cCurDrive )
                endif
        endif

        cDisc      := Left( Alltrim( Upper( cDisc ) ), 1 ) + ':'
        
        // Destino = directorio de la consulta
        cFileDest  := Trim( cCurDrive ) +  ':\' + CurDir() + '\' + ;
                                                        AllTrim( cFile )
        // Origen = Directorio donde estan archivados
        cFileOrig  := cDisc + cPath + AllTrim( cFile )
                       
if !( File( cFileOrig ) )
	MsgStop( cFileOrig + CRLF + 'No existe', 'Aviso !.' )
        Return .f.
endif
if ( FunCopy( cFileOrig, cFileDest ) )
	Return .t.
endif

if cFilePath( cFileOrig ) != cFilePath( cFileDest ) .and.  ;
	MsgYesNo( 'Introduzca Disco Num.: ' + aLista[ 2 ] + CRLF + ;
			'de la Unidad: ' + cDisc + CRLF + ;
			'para Restaurar: ' + cFileOrig + CRLF + ;
			'en:  ' + cFileDest, 'Elija una opcin.' )

    Do while !File( cFileOrig) .and. ;
	MsgYesNo( 'Fichero: ' + cFileOrig + CRLF + ;
			'No encontrado' + CRLF + ;
                        'Buscar en otras unidades?', 'Elija una opcin.' )
	    cFileOrig := cGetFile(  ;
		"Imagenes ( *.Bmp ) | *.Bmp | " + ;
		"Todos ( *.* ) | *.* " , ;
                "Elija Fichero ", 01, ".\", .t., .t. )

    enddo

endif    

Return .t.
//--------
//
//*****************************************
Function VerOtras( ClDlg, ClTxt, oWn, nUs )
//*****************************************
local otrasbases :=  ARRAY( 17 )        //18 )
local mensajes   :=  ARRAY( 17 )        //18 )
local cItem      := '', cMensaje, nmensaje
 
otrasbases[1] := "VISIONW"
otrasbases[2] := "VISION"
otrasbases[3] := "TABULAR"
otrasbases[4] := "EJES"
otrasbases[5] := "CERCA"
otrasbases[6] := "D_PUPILA"
otrasbases[7] := "MLITERAL"
otrasbases[8] := "K_RADIO"
otrasbases[9] := "K_DIAM"
otrasbases[10] := "PU_DIAM"
otrasbases[11] := "A_PARP"
otrasbases[12] := "D_VERT"
otrasbases[13] := "L_RADIO"
otrasbases[14] := "L_DIAM"
otrasbases[15] := "EJES2"
otrasbases[16] := "L_PRUEBA"
otrasbases[17] := "PIO"
//otrasbases[17] := "MINUTA"
//otrasbases[18] := "MOTIVO"

mensajes[1] := OemToAnsi( "Agudezas visuales" + CRLF + ;
                          "10 caracteres o cifras: " + ;
                          "0.25 Pte., Amaurosis, Proy .." )
mensajes[2] := mensajes[1]
mensajes[3] := OemToAnsi( "Dioptrias esf. y cil.                               " )
mensajes[4] := OemToAnsi( "Ejes de cilindros en gafas                          " )
mensajes[5] := OemToAnsi( "Valores de adicin para las gafas de cerca          " )
mensajes[6] := OemToAnsi( "Distancias interpupilares. Solo cifras,  --        " )
mensajes[7] := OemToAnsi( "En receta gafas texto sustitutorio                  " )
mensajes[8] := OemToAnsi( "Radios corneales                                    " )
mensajes[9] := OemToAnsi( "Dimetros corneales                                 " )
mensajes[10] := OemToAnsi( "Dimetros pupilares                                 " )
mensajes[11] := OemToAnsi( "Apertura palpebral                                 " )
mensajes[12] := OemToAnsi( "Distancia lentilla a vrtice                       " )
mensajes[13] :=  OemToAnsi(  "Radio lentillas                                    " )
mensajes[14] :=  OemToAnsi( "Dimetro lentillas                                 " )
mensajes[15] :=  OemToAnsi( "Ejes en lentillas                                  " )
mensajes[16] :=  OemToAnsi( "Lentes de pruebas y recetas                        " )
mensajes[17] :=  OemToAnsi( "Valores tonometras aplanacin: Solo cifras,  --  " )
//mensajes[17] :=  OemToAnsi( "Valor CERO  similar en minuta: ----,Nada,000,etc. " )
//mensajes[18] :=  OemToAnsi( "Texto de normalidlad  igual a anterior.           " )

				// Lista de las bases .., y seleccionar una
//otrasbases := Asort( otrasbases )

cItem := "X"

Do While !EmpTy( cItem )  // Para q no escape la ventana cada vez..Requena
cItem := Verde2( otrasbases, '', ClDlg, ClTxt, oWn, 'Bases de Apoyo',mensajes)

if !Empty( cItem )      // Solo si se eligio una opcion de la lista ..
	nmensaje := ASCAN( otrasbases, cItem ) 
	cmensaje := iif( nmensaje == 0, '', alltrim(otrasbases[ nmensaje ] ))
  Exportar( 'F', AllTrim( cItem ), 01, cmensaje, ;
					mensajes[nmensaje], nUs, oWn )
endif                                   //Acceso a la base seleccionada

EndDo

Return Nil
//--------
//*******************************************
Function Normalidad( ClDlg, ClTxt, oWn, nUs )
//*******************************************
local otrasbases := {}                       
local mensajes   := {}
local cItem      := '', cMensaje, nmensaje, igualmotivo, normalmotivo
local oDlNor, oG1, oG2, oG3, oG4
local oS1, oS2, oS3, oS4, Fnt1
local oB1, oB2, oBt6, Fila1, Fila2, Fila3, Fila4
local cBase := '', nLen := 1, lSave := .f., lMotivo := .f.

oTrasBases := Titulos( {} )
aadd( oTrasBases, '   Motivo Consulta  ' )
mensajes   := Titulos( {} )
aadd( mensajes,   '   Motivo Consulta  ' )

nUsuario := nUs
cItem := "X"

Do While !Empty( cItem )

cItem := Verde2( otrasbases, '', ClDlg, ClTxt, oWn, ;
		'Textos de: Normalidad e Igual a anterior', mensajes )

if !Empty( cItem )      // Solo si se eligio una opcion de la lista ..
	nmensaje := ASCAN( otrasbases, cItem ) 
	cmensaje := iif( nmensaje == 0, '', alltrim( mensajes[ nmensaje ] ) )
//msginfo( 'Elegido: ' + alltrim( cItem ) )

CursorWait()
lMotivo := ( nmensaje == Len( mensajes ) )

if lMotivo // Motivo de consulta
        Usa_base( 'Motivo', .f., '', 5, .t. )
        DbGoto( 1 )
        NormalMotivo := OemToAnsi( FieldGet( 1 ) )
        Fila1 := Normalmotivo
        igualmotivo := OemToAnsi( AllTrim( MemoRead( 'IgualMot.Dat' ) ) + Space( 100 ) )
/*
        Usa_base( 'Anal', .f., '', 5, .t. )
        DbGoto( 1 )
        igualmotivo := ( FIELDGET(1) )
        igualmotivo := substr( igualmotivo, 12, 30 )
        igualmotivo := iif( empty(igualmotivo), '*', ;
                                OemToAnsi( alltrim(igualmotivo)) )
*/
        Fila3 := igualmotivo
        // se asigna un valor por omision a igual anterior motivo ..

        
else    // Bases de exploraciones, de texto
        cBase := 'B' + AllTrim( str( nmensaje ) )
        Usa_base( cBase, .f., '', 5, .t. )
        DbGoto( 1 )
        nLen := Len( FieldGet( 2 ) )
        Fila1 := OemToAnsi( FieldGet( 1 ) + FieldGet( 2 ) )
        Fila2 := OemToAnsi( FieldGet( 3 ) + FieldGet( 4 ) )
        DbGoto( 2 )
        Fila3 := OemToAnsi( FieldGet( 1 ) + FieldGet( 2 ) )
        Fila4 := OemToAnsi( FieldGet( 3 ) + FieldGet( 4 ) )
endif

   DEFINE FONT Fnt1 SIZE 6, 12 BOLD
   DEFINE DIALOG oDlNor FROM 5, 4 TO 23, 74 TITLE cItem ;       //OF oWn 
        COLOR ClTxt, ClDlg FONT Fnt1

   @ 02*nXpR, 02*nXpC SAY "Texto de Normalidad:" OF oDlNor COLOR ClTxt, ClDlg

   @ 2.8,  02  GET oG1 VAR Fila1 OF oDlNor SIZE 240, 12 ;
	MESSAGE 'Texto de normalidad..'
if !( lMotivo )
   @ 3.8,  02  GET oG2 VAR Fila2 OF oDlNor SIZE 240, 12 ;
	MESSAGE 'Texto de normalidad..'
endif

   @ 5.5*nXpR, 02*nXpC SAY "Clave para Igual a anterior:" OF oDlNor ;
                                                        COLOR ClTxt, ClDlg

   @ 6.3,  02  GET oG3 VAR Fila3 OF oDlNor SIZE 240, 12 ;
	MESSAGE 'Clave para igual a anterior'

if !( lMotivo )
   @ 7.3,  02  GET oG4 VAR Fila4 OF oDlNor SIZE 240, 12 ;
	MESSAGE 'Clave para igual a anterior'
endif

   @ 10*nXtR, 12*nXtC BUTTON "&Archivar"  OF oDlNor SIZE 50, 12 ;
		ACTION ( lSave := .t., oDlNor:End() ) ;
		MESSAGE 'Archivar los valores actuales'

   @ 10*nXtR, 20*nXtC BUTTON "&Cancelar" OF oDlNor SIZE 50, 12 ;
				ACTION  oDlNor:End() ;
				MESSAGE 'Salir sin archivar'   

   @ 0.1, 0.2 BUTTON obt6 PROMPT "A&yuda" OF oDlNor ;
	SIZE 25, 18                     ;
        ACTION  ;
            IIF( FILE( "WOCAYUDA.EXE" ), WAITRUN( "WOCAYUDA 10" ),;
         FwHelp( "busqueda.txt" ) ) ;  //, oDlNor:SetFocus() )
	MESSAGE 'Ayuda en textos de normalidad / igual a anterior ..'

   ACTIVATE DIALOG oDlNor CENTERED ON INIT CursorArrow() //CENTERED

   oDlNor:Destroy()    
   Fnt1:End()

if lSave
   if lMotivo // Motivo de consulta
        NormalMotivo := Fila1
        igualmotivo  := Fila3
        MemoWrit( 'IgualMot.Dat', AnsiToOem( AllTrim( igualmotivo ) + Space( 100 ) ) )
/*
        DbSelectArea( 'Anal' )
        igualmotivo := Substr( FieldGet( 1 ), 1, 11 ) + ;
                                        AnsiToOem( igualmotivo )
	Bloq_reg( 5 )
        FieldPut( 1, igualmotivo )
	DesBloq()
        ( 'Anal' )->( DbCloseArea() )
        // se asigna un valor por omision a igual anterior motivo ..
*/
        DbSelectArea( 'Motivo' )
	Bloq_reg( 5 )
        FieldPut( 1, AnsiToOem( NormalMotivo ) )
	DesBloq()
        ( 'Motivo' )->( DbCloseArea() )

   else     
	DbGoto( 1 )
	Bloq_reg( 5 )
	FieldPut( 1, AnsiToOem( Left( Fila1, nLen ) ) )
	FieldPut( 2, AnsiToOem( Right( Fila1, nLen ) ) )
	FieldPut( 3, AnsiToOem( Left( Fila2, nLen ) ) )
	FieldPut( 4, AnsiToOem( Right( Fila2, nLen ) ) )
	DesBloq()
	DbGoto( 2 )
	Bloq_Reg( 5 )
	FieldPut( 1, AnsiToOem( Left( Fila3, nLen ) ) )
	FieldPut( 2, AnsiToOem( Right( Fila3, nLen ) ) )
	FieldPut( 3, AnsiToOem( Left( Fila4, nLen ) ) )
	FieldPut( 4, AnsiToOem( Right( Fila4, nLen ) ) )
	DesBloq()
        ( cBase )->( DbCloseArea() )

   endif

endif

endif           //Acceso a la base seleccionada

EndDo

Return Nil
//--------
//
//***********************************************************
Function VerEscritos( mHist, ClDlg, ClTxt, oWn, nExpl, cTit )
//***********************************************************
local aLista     := {}  // Array de nombres + fechas de ficheros
local mensajes   := {}  // Array de comentarios
local cFichero   := '', aDirectorio := {}, cFMxpH, nReg
local cItem      := '', cMensaje, nmensaje, lUsar := .f., nRecAct := 0
local nArea  := SELECT(), cAreaUso := ALIAS( nArea )
local aBases := { 'SvCarta', 'SvRecet2', 'SvEscrit', 'Informe' }
local cBase  := aBases[ nExpl + 8 ], cInd := cBase, mNom := mHist
local nLong  := 12, mHistCero := space( 10 ), cMemo := "", nI, aRegs := {}
Field NomFichero, Comentario, Historia, Fecha, Directorio, Nombre
// nExpl = -5 svescrit, -6 Svrecet, -7 Svcarta, -4 Informe
cTit := OemToAnsi( cTit )
Usa_base( cBase, .f., cInd, 5, .t. )    // Abre o Select si estaba abierta

//nLong := Len( NomFichero )

/*if ( cBase )->( DbSeek( mHistCero ) )
	Do While Historia == mHist .and. !Eof()
		aadd( aLista, NomFichero + ' - ' + DtoC( Fecha ) )
		aadd( mensajes, Comentario )
		aadd( aDirectorio, Directorio )
		DbSkip()
	EndDo
endif
*/
 
	nRecAct := ( cBase )->( RecNo() )

Do Case

Case nExpl == -4
if ( cBase )->( DbSeek( mNom ) )
	Do While Nombre == mNom .and. !Eof()
	       cMemo := ""
	       nReg := ( cBase )->( RecNo() )
         
         cFMxpH := '.\INFORED\F' + ;    // Se crea el nuevo en cPathFile
         PADL( alltrim( Str( nReg ) ) , 7, "0" ) + '.' + "RED" 
         // q es en el subdirectorio de archivo, usando el num de reg del dbf
          nLong := Len( cFMxpH )
          For nI := 3 To ( cBase )->( FCount() )
              cMemo += ( cBase )->( FieldGet( nI ) )
          Next
          
              cMemo := Trim( cMemo )
              cMemo += Trim( MemoRead( cFMxpH ) )
              if !Empty( cMemo )
                  aadd( aRegs, AllTrim( Str( ( cBase )->( RecNo() ) ) ) )
                  aadd( aLista, cFMxpH + " - " + cValToChar( ( cBase )->( FieldGet( 2 ) ) ) )
                  aadd( mensajes, cFMxpH )
              endif
              
       ( cBase )->( DbSkip() )
	EndDo
else
	MsgInfo( 'Nombre: ' + mNom + CRLF + ;
		'NO hay ' + cTit + ' Archivados ..', 'Informacin' )
	Return { .f., '' }
endif

Case nExpl < -4 .and. nExpl > -8

nLong := Len( NomFichero )

if ( cBase )->( DbSeek( mHist ) )
	Do While Historia == mHist .and. !Eof()
             // Los perdidos no se ponen
             if File( AllTrim( NomFichero ) ) .or. ;
                        File( AllTrim( Directorio ) )
                aadd( aLista, NomFichero + ' - ' + DtoC( Fecha ) )
		aadd( mensajes, Comentario )
		aadd( aDirectorio, Directorio )
             endif
        	DbSkip()
	EndDo
else
	MsgInfo( 'Historia: ' + mHist + CRLF + ;
		'NO hay ' + cTit + ' Archivados ..', 'Informacin' )
	Return { .f., '' }
endif

Endcase

if Len( aLista ) > 0
	cItem := aLista[ 1 ]
else
	MsgInfo( 'Nombre: ' + mNom + CRLF + ;
		'NO hay ' + cTit + ' Archivados ..', 'Informacin' )
	Return { .f., '' }
endif

//cItem := aLista[ 1 ]
Do Case

Case nExpl == -4
  
Do While !Empty( cItem ) .and. !lUsar
    cItem := Verde2( aLista, '', ClDlg, ClTxt, oWn, cTit, mensajes, cItem )
    IF Empty( cItem )
			Exit
    Endif
    nI := Ascan( aLista, cItem )
 
    if nI > 0
         nReg := Val( AllTrim( aRegs[ nI ] ) )
         cFMxpH := '.\INFORED\F' + ;    // Se crea el nuevo en cPathFile
         PADL( alltrim( Str( nReg ) ) , 7, "0" ) + '.' + "RED" 
          cMemo := ""
          ( cBase )->( DbGoto( nReg ) )

          For nI := 3 To ( cBase )->( FCount() )
              cMemo += ( cBase )->( FieldGet( nI ) )
          Next
          
              cMemo := Trim( cMemo )
              cMemo += Trim( MemoRead( cFMxpH ) )
              MemoWrit( cFileNoPath( cFMxpH ), cMemo)    
    endif
    cFichero := cFileNoPath( cFMxpH )
    lUsar := CargarFich( cFichero, cTit + cFichero, oWn )
EndDo
          ( cBase )->( DbGoto( nRecAct ) )
          
Case nExpl < -4 .and. nExpl > -8

Do While !Empty( cItem ) .and. !lUsar
    cItem := Verde2( aLista, '', ClDlg, ClTxt, oWn, cTit, mensajes, cItem )
    IF Empty( cItem )
			Exit
    Endif
    cFichero := Left( cItem, nLong )
    cFichero := IIf( !File( cFichero ), ;
		Trim( aDirectorio[ Ascan( aLista, cItem ) ] ), cFichero )
//      Trim( aDirectorio[ Ascan( aLista, cItem ) ] ) + cFichero, cFichero )
    if !File( cFichero )
	MsgStop( 'Fichero: ' + CRLF + ;
			cFichero + CRLF + ;
				'No pudo ser encontrado ..', 'Aviso !.' )
	Loop
    endif       
    lUsar := CargarFich( cFichero, cTit + Substr( cItem, nLong+1 ), oWn )
//    lUsar := CargarFich( cFichero, cTit, oWn )
EndDo

Endcase

SelectDb( cAreaUso )

Return { lUsar, cFichero }
//------------------------

//*****************************************
Function Analisis( nAnal, nUlt, oWn, mNom, nUs, nItInit )
//*****************************************
local FieldIni := 1, nVeces, LongField, i := 0, cItem := '',  ;
        aItems := {}, aAnal := {}, lApp := .f., lDel := .f., nI := 0
local nUltReg  := 0, cMemo := '', nExpl, cTituloReg := '', cTxt := ''
local cTit     := 'Analisis', cBase := 'Analisis', cFile := '', cInd := ''
local cMessg   := 'Analisis ..', nLineas,  cLinea := "", cTxtm
local lArchiva := .f., lSave := .f., lImprime := .f., aValor := {}, aDbf := {}
local nArea  := SELECT(), cAreaUso := ALIAS( nArea ), nRec
local nRegAct := 0, lSeguir := .t., lSalir := .f., nConta := 1, cFNw := ''
local aTit := { 'Perfil Serico', 'Preoperatorio', 'E.C.G.', ;
		'Perfil B.Hospitalario', 'Uveitis', 'Frotis' }
local cTarget := Upper( HB_CurDrive() ) + ':', cFileAsc := ""
local cDir := '\', bDir, nA, nB, cMemo2, cMemo3, cFileAs2, cFileAs3
local cFileCont, lFormat := .f., lCrea := .f.
local cExt     := PADL( AllTrim( str( nUs, 3 ) ), 3, "0" ), lMsgFormat := .f.
local cTextFormat := "{\rtf" //  FORMAT_TEXT_TYPE //+ SP_REG + ;
                        //FORMAT_TEXT_VERSION + SP_FIELD

Field NivelAcc

DEFAULT nItInit := 1
     //MsgList( aGetWorkAreas() )
     nUsuario := nUs
     cValW  := Trim( MemoRead( "CONFIGUR." + cExt ) ) + Space( 200 )     
     lMsgFormat := ( SubsTr( cValW, 40, 1 ) == "S" )

bDir := { | carpeta | ;
                iif( !lIsDir( carpeta ), ;
                       ( lMkDir( carpeta ), lCrea := .t. ), Nil ) }

FieldIni := 2   // El primer campo es el titulo del analisis, TT AUT Y PROTOC

DEFAULT nAnal := -8

nExpl := nAnal

nAnal := 1
CursorWait()

nNivelAcc := Val( Lis_Red->Nivel )      // Estatica

do case

case nExpl == -8        // Analisis

        cBase := 'Autotra1'
        cInd  := 'Autotra1'
	      cTit     := AnsiToOem( 'Anlisis' )
	      cMessg   := 'Anlisis ..'
        cFileCont:= 'ANACONTA.SAV'
        FieldIni := 2  
              
case nExpl == -9        // TT automatico, separa interlinea entre medicamentos
        cBase := 'Autotra2'
        cInd  := 'Autotra2'
	      cTit     := AnsiToOem( 'Tratamiento automtico' )
	      cMessg   := 'Tratamientos automticos ..'
        cFileCont:= 'AUTCONTA.SAV'
        FieldIni := 2  
 
case nExpl == -10       // Protocolos mdicos. NO interlineas aqui, se decide en wocimp
        cBase := 'Autotra3'
        cInd  := 'Autotra3'
	      cTit  := AnsiToOem('Protocolos mdicos')
	      cMessg   := 'Protocolos ..'
        cFileCont:= 'PROCONTA.SAV'
        FieldIni := 2  
        
case nExpl == -10.5       // Protocolos quirurgicos. NO interlineas aqui, se decide en wocimp
        cBase := 'Autotra4'
        cInd  := 'Autotra4'
//   usa_base( "Autotra4", .t., "", 5 )
//   INDEX ON Autotra4->Protocolo TO Autotra4
//   Autotra4->( DbCloseArea() )	
	      cTit  := AnsiToOem('Protocolos quirrgicos')
	      cMessg   := 'Protocolos quirgicos..'
        cFileCont:= 'PRQCONTA.SAV'
        FieldIni := 2  

endcase

usa_base( cBase, .f., cInd, 5, .t. )
if nExpl == -9 .or. nExpl == -10  .or. nExpl == -10.5    //aqui se toma el contador..
    nRec := ( cBase )->( RecNo() )   // trat aut y protocolos

    ( cBase )->( DbGoto( 1 ) )

    if !File( cFileCont )
        nConta := ( cBase )->( LastRec() )
        MemoWrit( cFileCont, AllTrim( Str( nConta ) ) )
        Bloq_Reg( 5 )
        ( cBase )->Contador := nConta
        DesBloq()
    else

        nConta := Val( Trim( MemoRead( cFileCont ) ) ) //( cBase )->Contador

    endif
     // Por si hubo errores..
     nConta := Max( nConta, ( cBase )->( LastRec() ) )
    ( cBase )->( DbGoto( nRec ) )

endif   // FIN BLOQUE CONTADOR TT AUT Y PROTOC.

Do While lSeguir
usa_base( cBase, .f., cInd, 5, .t. )
aAnal   :=  Exportar( '', Upper( cBase ), 01, OemToAnsi( cTit ), cMessg, nUsuario, oWn,,,, nItInit )
 
if Empty( aAnal[1] )
	Return nIL
endif 
if Len( aAnal ) == 4
  		aadd( aAnal, nItInit )
endif

Do While .t. 
cItem   := aAnal[ 1 ]
lApp    := aAnal[ 2 ]
lDel    := aAnal[ 3 ]
nItInit := aAnal[ 5 ]
nRegAct := Val( aAnal[ 4 ] )

Do case

case Empty( cItem )     // SALIDA SIN ELEGIR
	IF cBase != cAreaUso
		( cBase )->( DbCloseArea() )
	endif
        SelectDb( cAreaUso )
        //Return Nil    // TERMINAR..
		    lSeguir := .f.	// aprovechamos esta var para terminar

				EXIT

case lApp       // Se va a crear un reg nuevo..
	Appe_reg( 5 )
	nRec := ( cBase )->( RecNo() )
	( cBase )->( FieldPut( 1, AnsiToOem( cItem ) ) )
        DesBloq()
 //      if nExpl== -9 .or. nExpl == -10
           nConta ++    // se incrementa el contador
           // Se comprueba q el archivo nuevo a crear, no existe
           // q seria antiguo coincidente por algun error de funcionamiento
           // y se correria el contador hasta no existente
           cFNw :=  '.\' + cBase + '\' + ;
                 'F' + PADL( alltrim( Str(nConta) ), 7, "0" ) + ;
                        iif( nExpl == -9, '.AUT', iif( nExpl == -8, 'ANA', '.PRT' ) ) 
                        
           //cFNw := iif( nExpl == -8, '.\' + cBase + '\' + cFileAsc, cFNw )
           Do While File( cFNw )
              nConta++
              cFNw :=  '.\' + cBase + '\' + ;
                 'F' + PADL( alltrim( Str(nConta) ), 7, "0" ) + ;
                        iif( nExpl == -9, '.AUT', '.PRT' )
           EndDo
           // Fin comprobacion contador
           Bloq_Reg(5)
           // se anota el nombre del nuevo archivo del subdirect.
           FieldPut( 2, cFNw )
           DesBloq()
           ( cBase )->( DbGoto( 1 ) )   // En el reg primero
           Bloq_Reg(5)
           ( cBase )->Contador := nConta //se anota el contador
           DesBloq()
           ( cBase )->( DbGoto( nRec ) )
           // Y se guarda en disco el respaldo del contador
           MemoWrit( cFileCont, AllTrim( Str( nConta ) ) )
   //    endif             
      	nAnal := nRec
      	
        Exit    // Para que se cree el nuevo documento ..

case lDel
     IF nRegAct > 0 .and. nRegAct <= ( cBase )->( LastRec() )
				( cBase )->( DbCloseArea() )
				usa_base( cBase, .t., cInd, 5, .t. )
				( cBase )->(  DbGoto( nRegAct ) )
 //     if nExpl == -9 .or. nExpl == -10
        Ferase( ( cBase )->( FieldGet( 2 ) ) )
 //     endif
        DBdelete()
        HB_DBPACK()  // PACK 
        ( cBase )->( DbCloseArea() )
				usa_base( cBase, .f., cInd, 5, .t. )
				MsgInfo( OemToAnsi( cTit ) + ' BORRADO: ' + CRLF + cItem, 'Informacin' )      
     Endif
     
     Exit

OtherWise  // Se ha elegido un item..
     Exit

Endcase

EndDo
       
     If DbSeek( AnsiToOem( cItem ) )
		nAnal := RecNo()
	else
		nAnal := 1
	endif

( cBase )->( DbGoto( nAnal ) )
nveces     := Fcount()
longField  := len( FieldGet( FieldIni ) )

                  // EDITAR EL REGISTRO ..
cMemo := ''
 
        cMemo := MemoRead( Trim( ( cBase )->( FieldGet( 2 ) ) ) )         
        cFile := cFileAsc := Trim( ( cBase )->( FieldGet( 2 ) ) )

        cFile := AllTrim( cFile )
//       cMemo := StrTran( cMemo, "@", CRLF )
  //     MemoWrit( cFile, cmemo )        
    if SubsTr( Upper( cBase ), 1, 2 ) == "AU" //.or. SubsTr( Upper( cBase ), 1, 1 ) == "W"
      // autotrat1, 2 y 3                            ya si =y NOO analisis
    endif

  aValor := FWmemo( aAnal[ 5 ], , cMemo, ;
            iif( nExpl == -8 .or. nExpl == -9 .or. nExpl == -10 .or. nExpl == -10.5, 60, LongField ), ;
            iif( nExpl == -8 .or. nExpl == -9 .or. nExpl == -10 .or. nExpl == -10.5, 17, nVeces ) + 1 -FieldIni, ;
                        cTit, cMessg, , , , nExpl, AllTrim(cFile), oWn, cBase, FieldIni )
  lSeguir       := aValor[ 3 ]
  
SelectDb( cAreaUso )

EndDo

Return Nil

Function Abrevia( aValor, nExpl, FieldIni, cBase, LongField, cFile, lFormat )
Local lSave := .f., cMemo := "", lSeguir := .f., lSalir := .f., lArchiva := .f.
Local lImprime := .f., cTituloReg := "", lSalvado := .f.
Local cTxtm := "", cTxt := "", cTit := "", cLinea := "", cFileAsc := ""
Local i := 0, nLineas := 0, nVeces := 0, nI := 0
 local cTextFormat := "{\rtf"   // FORMAT_TEXT_TYPE + SP_REG + ;
                        // FORMAT_TEXT_VERSION + SP_FIELD
DEFAULT lFormat := .f., cFile := "", cBase := "", FieldIni := 2 , LongField := 60, nExpl := -9
nVeces := FCount()
LongField := iif( nExpl == -8, 59, LongField )

  lSave         := aValor[ 1 ]
  cMemo         := aValor[ 2 ]
  // lSeguir       := aValor[ 3 ]
  lSalir        := aValor[ 4 ]
  lArchiva      := aValor[ 5 ]
  lImprime      := aValor[ 6 ]
  cTituloReg    := aValor[ 7 ]
//? cBase, cFile, cMemo
//cMemo := StrTran( Trim( cMemo ), Chr( 26 ), "" )
cMemo := StrTran( Trim( cMemo ), OemToAnsi( Chr( 26 ) ), "" )

FieldIni := 2 
cTit := cBase + " / " + cTituloReg
cTxtm := cMemo
SelectDb( cBase )
cFile := AllTrim( cFile )

 if !Empty( cMemo )    // lImprime     // Archivat tt aut y protoc en expl de tt
  if nExpl == -8 .or. nExpl == -9 .or. nExpl == -10  .or. nExpl == -10.5
     // Receta medica, tt aut, y protoc salvan titulo en tratamiento, 2009 aado analisis
        cMemo := Explorar( -6 )      // Obtiene archivo de expl tt hoy
        cTxt  := Trim( ( cBase )->( FieldGet( 1 ) ) )
	cTxt  := SubsTr( cTxt, at( '*', cTxt )+1 )
	// p q no se repita el texto si ya estaba
//	cMemo := iif( at( ' - ' + cTxt, cMemo ) == 0, Trim( cMemo ) + ' - ' + cTxt, cMemo )
	cMemo := iif( at( AllTrim( cTxt ), cMemo ) == 0, Trim( cMemo ) + ' - ' + cTxt, cMemo )
	Usa_base( 'B14', .f., '', 5, .t. )
	SalvaDatos( cMemo, 'B14', ( 14+8 ), Paciente->Ultimo, , , )
			// de exploraciones
	CierraDb( "B14", cBase )
  endif
 endif

          cMemo := cTxtM        // Se recupera .. 1
 
if lArchiva    // archivar

if ( nExpl == -8 .or. nExpl == -9 .or. nExpl == -10 .or. nExpl == -10.5 )
 
if nNivelAcc < 4
        MsgStop( 'Su Nivel de acceso es = ' + ;
		AllTrim( str( nNivelAcc ) ) + CRLF + ;
		'SUSTITUCION del texto ..' + CRLF + ;
		'solo permitido a Nivel = 4 ', 'Aviso !.' )
else

	if lSave
	  if Empty( cMemo ) 
	     lSave := !MsgYesNo( 'Texto vacio ..' + CRLF + ;
			 'Desea ARCHIVARLO ASI?', cTit )
	  // ? cmemo
          MemoWrit( cFile, "" )
	      return Nil
	  endif
	endif

   if lSave
       cMemo := cTxtM        // Se recupera .. 2
	     cMemo := Trim( cMemo )	 

                cFile := AllTrim( ( cBase )->( FieldGet( 2 ) ) )
                Bloq_reg( 5 )
                ( cBase )->( FieldPut( 1, AnsiToOem( cTituloReg ) ) )
                DesBloq()
 
                  // se crea el archivo en el subdirect., pus viene con el path
                  if lFormat
                    MemoWrit( cFile, Trim( cMemo ) )                  
                  else
                    MemoWrit( cFile, StrTran( Trim( AnsiToOem( cMemo ) ), Chr( 26 ), "" ) )                     
                  endif
  
       					  lSalvado := .t. 
   MsgWait( "Datos " + iif( lSalvado, "SI", "NO" ) + " Guardados ..", AllTrim(cTituloReg), 1 )
   
 endif // De si lsave

endif   // de acceso permitido o no

endif  // -8 a -10 y -10.5

endif   // de lArchivar  o NO

Return Nil
//--------

//**************************
Function FtoMemo2( FieldIni, cBase )
//**************************
Local nveces     := ( cBase )->( Fcount() ), i := 0, nUltField := 1, cMemo := ''
Local longField 
//MsgList( aGetWorkAreas() )
( cBase )->( DbSelectArea() )
//? cBase		// Wanalis.dbf
//return nil

DEFAULT FieldIni := 2 // Para salvar el parametro desde analisis en FWMemo
longField  := len( ( cBase )->( FieldGet( FieldIni ) ) )

	  for i := nveces to FieldIni step -1
		if !Empty( ( cBase )->( FieldGet( i ) ) )
			exit    // Se ignoran campos vacios a cola del registro
		endif
	  next
		nUltField := i

	  for i := FieldIni to nUltField
      cMemo += Trim( ( cBase )->( FieldGet( i ) ) ) + Space( 1 )  //Trim( FieldGet( i ) )			
			//cMemo += rCarro2( ( cBase )->( Fieldget(i) ) )
			/*
			cMemo += IIF( !Empty( ( cBase )->( FieldGet( i ) ) ), ;		
			iif( len(( cBase )->( Fieldget(i))) == len(Trim(( cBase )->( Fieldget(i)))), ;
			rCarro( ( cBase )->( Fieldget(i) ) ), ;
			Trim( ( cBase )->( FieldGet( i ) ) ) + ;
			iif( Right( trim( ( cBase )->( FieldGet( i ) ) ), 01 ) == '.', CRLF, ' ' ) ), CRLF )
 	    */
 	  Next 
      cMemo := StrTran( cMemo, "@", CRLF )

Return cMemo := OemToAnsi( Trim( cMemo ) )
//----------

//**************************
Function FtoMemo( FieldIni, cBase )
//**************************
Local nveces     := Fcount(), i := 0, nUltField := 1, cMemo := ''
Local longField 
//MsgList( aGetWorkAreas() )
( cBase )->( DbSelectArea() )
//? cBase		// Wanalis.dbf
//return nil

DEFAULT FieldIni := 2 // Para salvar el parametro desde analisis en FWMemo
longField  := len( ( cBase )->( FieldGet( FieldIni ) ) )

	  for i := nveces to FieldIni step -1
		if !Empty( ( cBase )->( FieldGet( i ) ) )
			exit    // Se ignoran campos vacios a cola del registro
		endif
	  next
		nUltField := i

	  for i := FieldIni to nUltField
			cMemo += IIF( !Empty( ( cBase )->( FieldGet( i ) ) ), ;		
			iif( len(( cBase )->( Fieldget(i))) == len(Trim(( cBase )->( Fieldget(i)))), ;
			rCarro( ( cBase )->( Fieldget(i) ) ), ;
			Trim( ( cBase )->( FieldGet( i ) ) ) + ;
			iif( Right( trim( ( cBase )->( FieldGet( i ) ) ), 01 ) == '.', CRLF, ' ' ) ), CRLF )
 	  Next 

Return cMemo := OemToAnsi( Trim( cMemo ) )
//----------
//****************************** // Funcion Bonita / Barata ..
Function xMsgNoYes( cMsg, cTit ) // Devuelve .t. / .f.
//*****************************
Local aOpc := { '   &No   ', '   &Si   ' }
DEFAULT cTit := 'Elija, por favor ..', cMsg := 'Conforme? ..' 

Return MsgNoYes( cMsg, cTit ) //( Alert2( cMsg, aOpc, cTit ) == 2 )
//----------------------------------------

// Called from internal Alert()

//      Autor : Cesar Gimenez Gil
//   Objetivo : Simular el alert de clipper
//            : Alert (cTexto, <aOpciones>, <cTitulo>)
//
//             cTexto -> igual que en clipper, separamemos las lineas con ;
//                              y hasta 5 lineas
//             aOpciones -> igual que en clipper ( Hasta 5 opciones )
//             cTitulo -> el titulo de la ventana, por defecto sale "Atencin"

*
*************************************************
       Function Alert2( cMsg, aOpciones, cTitle, nPosy, nPosx, oDlg )
*************************************************
//   local nPosy  := 11
//   local nPosx  := 38
   local nLongY := 5          // lo minimo
   local nLongX := 20         // lo minimo
   local nLong_cad := 0       // longitud de la cadena
   local nLong_opc := 0       // longitud de las opciones
   local n, nOpc := 1
   local cOpciones := ""
   local nPosOpc   := 0
   local nPosYOpc   := 3    // por defecto
   local lCogeOpcion := .F.
   local cCad_opcion := ""
   local nLineas := 0
   local oDlAl, oFont, lCentrar := ( Empty( nPosX ) .and. Empty( nPosY ) )
   local nRet := 0
   local aBut := {}
   
   DEFAULT cTitle    := "Atencin", oDlg := Nil
   DEFAULT aOpciones := { " &OK " }     //, "&NO", "&TAMPOCO" }
   DEFAULT cMsg      := ""      //"Sale o no sale; Segun salga; Ya saldra"
   DEFAULT nPosy     := 15, nPosx  := 38
//   cMsg := ';' + cMsg // Echo yo la linea uno mas abajo ..
   cMsg    = StrTran( cMsg, ";", CRLF )
   nLineas = MlCount( cMsg, 254 )
   // vamos a ver que linea es la mas larga

   for n = 1 To nLineas
      if Len( AllTrim( Memoline( cMsg,, n ) ) ) > nLong_cad
	 nLong_cad = Len( AllTrim( Memoline( cMsg,,n ) ) )
      Endif
   Next
   nLong_Cad += 4

   // vamos a calcular si es mas largo el texto o las opciones


   for n = 1 To Len( aOpciones )
      nLong_opc += ( Len ( aOpciones[ n ] ) + 2 )
      cOpciones += " " + If( Len( aOpciones[ n ] ) < 3,;
      " " + aOpciones[ n ] + " ", aOpciones[ n ] ) + " "
   Next
   nLong_opc := Len( cOpciones ) + 1

   if nLong_cad > nLongX .or. nLong_opc > nLongX
      if nLong_cad >= nLong_opc
	 nLongX := nLong_cad
      else
	 nLongX := nLong_opc
      endif
   Endif

   // calculamos las filas que tiene que tener el ALERT

   if nLineas > 1
      nLongY += (nLineas - 1)
      nPosYOpc += (nLineas - 1)
   end
if nPosy == 11
   nPosx -= int( nLongX / 2)
Endif
If nPosx == 38
   nPosy -= int( nLongY / 2)
Endif

   DEFINE FONT oFont NAME "Arial" SIZE 6, 15 BOLD
   DEFINE DIALOG oDlAl TITLE ( cTitle ) ;
        FONT oFont ;
	FROM nPosy, nPosx TO nPosy + ((nLongY*2)-(nLongY/2)), nPosx + nLongX OF oDlg

   @ 0.2, 0.2 BITMAP FILENAME '.\bitmaps\About.Bmp' ;
	OF oDlAl SIZE 15, 15 NOBORDER ADJUST ON LEFT CLICK MsgInfo( "Seleccione una opcin..", "Informacin" ) 

   oDlAl:Cargo := 0

   for n := 1 to nLineas
      @ n*nXpR, 4 SAY Alltrim( Memoline( OemtoAnsi( cMsg ),, n ) ) OF oDlAl
//      @ n*nXpR, 1 SAY Alltrim( Memoline( OemtoAnsi( cMsg ),, n ) ) OF oDlAl
   next

   cOpciones = Padc( cOpciones, nLongX + ( nLongX / 5 ), " " )

   for n = 1 To Len( cOpciones )
      if SubStr( cOpciones, n, 1 ) == ""  // acaba una opcin
	 AAdd( aBut, NIL )
         @ nPosYOpc*( nXtR - iif( nLineas > 10, 0.05, 0.10 ) ), (nPosOpc / 2)*nXtC BUTTON aBut[ nOpc ] ;
	    PROMPT cCad_opcion SIZE Len( cCad_opcion ) * 3.5, 12 ;
	    OF oDlAl // ACTION ( oDlAl:Cargo := GetParam( 2, 1 ),;
			//     oDlAl:End() )
   /*
         @ nPosYOpc*nXtR, (nPosOpc / 2)*nXtC BUTTON aBut[ nOpc ] ;
	    PROMPT cCad_opcion SIZE Len( cCad_opcion ) * 3.5, 12 ;
	    OF oDlAl ACTION ( oDlAl:Cargo := GetParam( 2, 0 ):Cargo,;
			     oDlAl:End() )
	 aBut[ nOpc ]:Cargo = nOpc++
	 lCogeOpcion = .F.
	 cCad_opcion = ""
      endif
     */

         aBut[ nOpc ]:bAction = GenAction( nOpc, oDlAl )

         aBut[ nOpc ]:Cargo = nOpc++
	 lCogeOpcion = .F.
	 cCad_opcion = ""

      endif

      if lCogeOpcion
	 cCad_opcion += SubStr( cOpciones, n, 1 )
      endif

      if SubStr( cOpciones, n, 1 ) == ""  // empieza una opcin
	 nPosOpc = n
	 lCogeOpcion = .T.
      end
   next
   if lCentrar
   		//oDlAl:lCentered 		//:= {|| lCentrar }
   		ACTIVATE DIALOG oDlAl CENTERED ON INIT oDlAl:SetFocus()   //endif
   else
   		ACTIVATE DIALOG oDlAl ON INIT oDlAl:SetFocus()
   endif
   oFont:End()

return oDlAl:Cargo

function GenAction( n, oDlAl )

return { || oDlAl:Cargo := n, oDlAl:End() }

*-----------------
 
//*************************************************************
Function Listado( oAsc, oWn, ClDlg, ClTxt, mHis, cItem, lMail )
//*************************************************************
local oBt6, oBt7, oDlLis, oFnt
local Nombre1 := space( 30 ), Nombre2 := space( 30 ), Nom1 := '', Nom2 := ''
local Nombre3 := space( 30 ), Nombre4 := space( 30 )
local cInicio := "Ponga Desde INICIO:", cFinal := "Ponga Hasta FINAL:", ;
	cMsg1 := 'AMBITO DE LISTADO: Desde ..', ;
	cMsg2 := 'AMBITO DE LISTADO: Hasta ..'
local oG1, oG2, oG3, oG4, lSave := .f., lIsDate := .f.
local nArea   := SELECT(), cAreaUso := ALIAS( nArea )
local abases := Titulos( {} )
local nRecFin := 0, nCampo := 0, aCampos := { 'Nombre', 'Direccion', ;
		'Poblacion', 'Telefono', 'FechaNaci', 'FechaUlti', ;
				'Historia', 'OtrosDatos', 'Sexo', 'Alergias' }
local nLenGet := 240, n := 0
local aDbf, bDbf, bAsc, bBloq
local cExt     := PADL( AllTrim( str( Lis_red->( RecNo() ), 3 ) ), 3, "0" )
local cBase, cBaseMail:= iif( lMail, 'PACIE', 'BTEMP' ) + cExt //+ '.Dbf'	// 'PACIE001.DBF' ..002, 3 ..
//local cExt     := PADL( AllTrim( str( nUsuario, 3 ) ), 3, "0" ) // 001, 2, 3..
local cParMail := 'FRVMAIL.' + cExt   // parametro para llamar a mail
memvar cCampos, cIndice

DEFAULT cItem := 'Apellidos'
DEFAULT lMail := .t.
nUsuario := Lis_red->( RecNo() )

DbSelectArea( 'Paciente' )

Do Case
Case mHis == '2'
//      cItem := Verde2( aCampos, '', ClDlg, ClTxt, oWn, ;
//                      'Lista de Campos de Paciente', aCampos )
	nCampo := ASCAN( aCampos, cItem )
	lIsDate := Iif( nCampo == 5 .or. nCampo == 6, .t., .f. ) 
	Nombre1 := Iif( lIsDate, CtoD(''), ;
					space( Len( FieldGet( nCampo ) ) ) )
	Nombre2 := Iif( lIsDate, CtoD(''), ;
					space( Len( FieldGet( nCampo ) ) ) )
	cInicio := iif( lIsDate, ;
	"Ponga Fecha Inicio de ", "Ponga CADENA a Buscar en " ) + cItem
	nLenGet := iif( lIsDate, 50, nLenGet )

Case mHis == '3'
	nCampo := ASCAN( aBases, cItem )
	cMsg1  := cMsg2 := "Cadenas alfanumericas"
	cInicio:= "Ponga cadenas alfanumericas a buscar .."
	cFinal := "Hasta 4 cadenas en total"
	nLenGet:= 110
        cBase  := 'B' + AllTrim( str( nCampo ) )
        Usa_base( cBase, .f., '', 5, .t. )

EndCase

bBloq := {|| MsgAlert( 'Aqui, NO accesible !.', 'Atencin !.' ) }

DEFINE FONT oFnt SIZE 0, -8 BOLD

   DEFINE DIALOG oDlLis FROM 7, 4 TO 21, 74 TITLE ;
   'Listado de Pacientes por ' + cItem ;        //OF oWn 
        COLOR ClTxt, ClDlg  FONT oFnt

if mHis == '3'
@ 0.2*nXpR,19-6 SAY "BUSCA CADENAS ALFANUMERICAS EN TEXTOS DE EXPL." ;
        FONT oFnt  COLOR ClTxt, ClDlg
@ 01*nXpR,19-6 SAY "LISTA PACIENTES POSITIVOS EN LA BUSQUEDA." ;
        FONT oFnt  COLOR ClTxt, ClDlg
//@ 1.8*nXpR,19-6 SAY "PUEDE HABER DIFERENTES TEXTOS EN OTRAS CONSULTAS DEL PACIENTE." ;
//        FONT oFnt  COLOR ClTxt, ClDlg
endif

   @ 02*nXpR, 02*nXpC SAY cInicio OF oDlLis COLOR ClTxt, ClDlg

   @ 2.8,  02  GET oG1 VAR Nombre1 OF oDlLis SIZE nLenGet, 12 ;
	MESSAGE cMsg1
	oG1:cToolTip := cMsg1

if mHis == '3'
   @ 2.8,  19  GET oG3 VAR Nombre3 OF oDlLis SIZE nLenGet, 12 ;
	MESSAGE cMsg1
	oG3:cToolTip := cMsg1
endif

IF mHis == '1' .or. ( mHis == '2' .and. lIsDate ) .or. mHis == '3'
   @ 04*nXpR, 02*nXpC SAY cFinal OF oDlLis  COLOR ClTxt, ClDlg

   @ 4.8,  02  GET oG2 VAR Nombre2 OF oDlLis SIZE nLenGet, 12 ;
	MESSAGE cMsg2 // WHEN mHis == '1'
	oG2:cToolTip := cMsg2

if mHis == '3'
   @ 4.8,  19  GET oG4 VAR Nombre4 OF oDlLis SIZE nLenGet, 12 ;
	MESSAGE cMsg2
	oG4:cToolTip := cMsg2
endif

ENdif

   @ 7*nXtR, 12*nXtC BUTTON "&Aceptar"  OF oDlLis SIZE 50, 12 ;
		ACTION ( lSave := .t., oDlLis:End() ) ;
		MESSAGE 'Aceptar los textos actuales'

   @ 7*nXtR, 20.5*nXtC BUTTON "&Cancelar" OF oDlLis SIZE 50, 12 ;
				ACTION  oDlLis:End() ;
				MESSAGE 'Salir y abandonar ..'   

   @ 0.1*nXtR, 0.2*nXtC BUTTON obt6 PROMPT "A&yuda" OF oDlLis ;
	SIZE 25, 18                     ;
        ACTION  ;
            IIF( FILE( "WOCAYUDA.EXE" ), WAITRUN( "WOCAYUDA 4" ),;
         FwHelp( "Listados.txt" ) ) ;  //, oDlLis:SetFocus() )
	MESSAGE 'Ayuda ..'
	obt6:cToolTip := 'Ayuda ..'

   @ 0.1*nXtR, 3.8*nXtC BUTTON obt7 PROMPT "&Base" OF oDlLis ;
	SIZE 25, 18                     ;
        ACTION  ( Browse( cItem, ,bBloq, bBloq, bBloq ), ;
                                                        oDlLis:SetFocus() ) ; 
	MESSAGE 'VER datos del archivo ..'
	obt7:cToolTip := 'VER datos del archivo ..'

   ACTIVATE DIALOG oDlLis CENTERED ON INIT CursorArrow() //CENTERED

   oDlLis:Destroy()    

if Empty( Nombre1 ) .and. Empty( Nombre2 ) .and. Empty( Nombre3 ) .and. ;
							Empty( Nombre4 )
	lSave := .f.
endif

IF !lSave
	Return oAsc
endif

   CursorWait()
DbSelectArea( 'Paciente' )

if lIsDate      //nCampo == 5 .or. nCampo == 6
	Nom1    := DtoC( Nombre1 )
	Nom2    := DtoC( Nombre2 )
else 
	Nombre1 := AllTrim( Spanish( upper( AnsiToOem( Nombre1 ) ) ) )
	Nombre2 := AllTrim( Spanish( upper( AnsiToOem( Nombre2 ) ) ) )
	Nombre3 := AllTrim( Spanish( upper( AnsiToOem( Nombre3 ) ) ) )
	Nombre4 := AllTrim( Spanish( upper( AnsiToOem( Nombre4 ) ) ) )
	Nom1    := Nombre1 
	Nom2    := Nombre2
endif

//if val( mHis ) > 0 .and. val( mHis ) < 3 // No en patologias
        oAsc:Add( 'NOMBRE' + space( 24 ) + 'DIRECCION.' )
        oAsc:Add( 'FECHANACI' + Space( 15 ) + ;
                                'CIUDAD' + space( 15 ) + 'D.POSTAL' + space(10) + 'TELEFONO.' )
        oAsc:Add(OemToAnsi( replicate( chr( 220 ), 71 ) )) //Una raya
	if mHis != '3'
                oAsc:Add( OemToAnsi(cItem + ' -> ' + Nom1 + ' / ' + Nom2) )
	else
                oAsc:Add( OemToAnsi(cItem + ' -> ' + Nom1 + ' / ' + Nom2  + ;
                        ' / ' + Nombre3 + ' / ' + Nombre4 ) )
	endif
        oAsc:Add( OemToAnsi(replicate( chr( 220 ), 71 ) ) ) //Una raya
        oAsc:Add( '' )
//endif

// Preparar un dbf para provecho del mailing
IF Val( mHis ) < 3

aDbf    := Paciente->( DbStruct() )
// Valen del campo 1 al 10 a.inclusive, y el campo 16
aDel( aDbf, 11 )
aDel( aDbf, 11 )
aDel( aDbf, 11 )
aDel( aDbf, 11 )
aDel( aDbf, 11 )
aSize( aDbf, 11 )       // Quedan 11 campos a usar

if File( cBaseMail + '.Dbf' )
	if !lMail .or. ;
	     MsgYesNo( 'Fichero: ' + cBaseMail + '.Dbf ya existe' + CRLF + ;
			'Desea rehacerlo de Nuevo?.', 'Elija una opcin.' )
		Ferase( cBaseMail + '.Dbf' )
		DbCreate( cBaseMail, aDbf )
	endif
else
	DbCreate( cBaseMail, aDbf )
endif
Usa_Base( cBaseMail, .t., '', 5, .t. )
//                index on ( cBaseMail )->Nombre to ( cBaseMail )
   cCampos := 'NOMBRE'
   cIndice := cBaseMail
   INDEX ON &cCampos TO "&cIndice"

bDbf := {|| DbSelectArea( cBaseMail ), appe_reg( 5 ), ;
	Aeval( aDbf, { | c, n | ;
        ( cBaseMail )->( FieldPut( n, ;
                (Paciente->(FieldGet(iif(n>10,16,n)))) ) ) } ), ;
        DbSelectArea( 'Paciente' ) }
// fin preparar dbf ..
ENDif

// codigo de agregar lineas leidas al  fichero ascii
bAsc := {||oAsc:Add(OemToAnsi(Trim( Paciente->(FieldGet(1))) + ;
                          " - " + Paciente->(FieldGet(2)) ) +'.'),;
         oAsc:Add( OemToAnsi(Trim( DtoC(Paciente->(FieldGet(5))) + ' - ' + ;
         Paciente->(FieldGet(3)) + " - "  + AllTrim(Paciente->(FieldGet(16))) + " - " ;          
         + Paciente->(FieldGet(4)) )) + '.'),;
		oAsc:Add( '' ), Eval( bDbf ), n++ }
// Fin codigo de ascii...

DbSelectArea( 'Paciente' )

Do Case

Case mHis == '1'        // Busqueda por apellidos. Ambito.

//SET EXACT OFF
SET SOFTSEEK ON

 Paciente->( DbSeek( Nombre2 ) )
if !Eof()
	nRecFin := RecNo()
else
	nRecFin := 0    // No se interrumpe, hace aeval hasta el final
endif
Paciente->( DbSeek( Nombre1 ) )

if !Empty( Nombre1 ) .and. !Empty( Nombre2 )
  If !Eof()
	Paciente->( DbEval( {|| Eval( bAsc ) }, ;
			, {|| Paciente->(RecNo()) != nRecFin }, , , .f. ) )
	oAsc := LineaTotal( n, oAsc )
	
  else
	MsgStop(  ( Nombre1 ) + CRLF + 'NO encontrado ..', 'Aviso !.' )
  endif
else
	MsgStop( 'Hay que escribir Inicio y Final ..', 'Aviso !.' )
endif

Case mHis == '2'        // Busqueda por campos. Todo el fichero.
   If nCampo != 5 .AND. nCampo != 6
	if !Empty( Nombre1 ) 
	  Paciente->( DbEval( {|| Eval( bAsc ) }, ;
	{|| Nombre1 $ (Paciente->( FieldGet( nCampo ) )) }, , , , .f. ) )
		oAsc := LineaTotal( n, oAsc )
	else
		MsgStop( 'Hay que escribir la CADENA a buscar ..', 'Aviso !.' )
	endif
   else
	if !Empty( Nombre1 ) .and. !Empty( Nombre2 )
	  Paciente->( DbEval( {|| Eval( bAsc ) }, ;
	{|| Paciente->(FieldGet( nCampo )) >= Nombre1 .and. ;
			Paciente->(FieldGet( nCampo )) <= Nombre2 } ) )
		oAsc := LineaTotal( n, oAsc )
	else
		MsgStop( 'Hay que escribir Inicio y Final ..', 'Aviso !.' )
	endif
   endif

Case mHis == '3'        // Patologias en exploraciones

	( cBase )->( DbCloseArea() )
	oAsc := WScanFic( oAsc, Nombre1, Nombre2, Nombre3, Nombre4, ;
							nCampo, lMail )

EndCase

( cBaseMail )->( DbCloseArea() )
 SelectDb( cAreaUso )

CursorArrow()
oFnt:End()

if lMail 
	if Val( mHis ) < 3 
		MsgInfo( 'La base creada' + CRLF + 'es: ' + cBaseMail + ;
			CRLF + ; 
			'para CORREO Automtico', 'Informacin' )
		MemoWrit( cParMail, cBaseMail )
		 // se escribe para leer en WocGest
		WaitRun( 'WocGest ' + cParMail + '_' + cBaseMail )
	else
    //            Ferase( cBaseMail + '.DBF' )
      //          Ferase( cBaseMail + '.NTX' )
	endif
else
        if File( cBaseMail + '.DBF' )
//                Ferase( cBaseMail + '.DBF' )
  //              Ferase( cBaseMail + '.NTX' )

        endif
endif
DbCloseAll()
Return oAsc
//---------

//***********************************
Static Function LineaTotal( n, oAsc )
//***********************************

	oAsc:Add( 'Total:' + str( n ) + ' De:' + ;
		str( Paciente->( LastRec() ) ) + ' = ' + ;
		iif( n <= 0, '00', ;
		str( n*100 / Paciente->( LastRec() ), 5, 2 ) ) + " %" )

Return oAsc
//---------

//************************************************************
static function WScanfic( oAsc, cT1, cT2, cT3, cT4, n, lMail )
//************************************************************
   local bqtabla   := {}   // array para archivar nombres de pacientes
   local bqcolorx  := setcolor(  )
   local bqcolespec
   local bqnombre  := space( 40 )
   local bqresp    := space( 1 )
   local bqrec1    := 0
   local bqorden   := 0, nI := 0

// lleva aos soportando esta llamada a funcion no existente, era de MSDOS !!!!
//   local bqpantx   := savescreen( 08, 00, 14, 52 ) //se salva la pantalla

   local bqlinea5  := ""
   local bqhist    := ""
   local bqbase, TempBase
   local resp
   local lHay := .f., mHis := ''
   local cExt     := PADL( AllTrim( str( nUsuario, 3 ) ), 3, "0" ) // 001, 2, 3..
   local cParMail := 'FRVMAIL.' + cExt   // parametro para llamar a mail
   Field Linea1, Linea2, Linea3, Linea4, amplia, Historia
   MemVar CampoH
   MemVar Base
   MemVar cInd

   Base     := "B" + AllTrim( str( n ) )
   CampoH   := "C" + AllTrim( str( n ) )
   Ct1 := iIF( Empty( cT1 ), '$$$', cT1 )
   Ct2 := iIF( Empty( cT2 ), '$$$', cT2 )
   Ct3 := iIF( Empty( cT3 ), '$$$', cT3 )
   Ct4 := iIF( Empty( cT4 ), '$$$', cT4 )

//   resp := cT1 + " - " + cT2 + " - " + cT3 + " - " + cT4

   DbCloseAll()
   usa_base( "PACIENTE", .t., "", 5, .t. )
   bqtabla  := Paciente->( DbStruct() )  
		// Para q sea reconocida en el mail como paciente.dbf temp.
   DbCloseAll()

   TempBase := 'Temp' + cExt  //AllTrim( str( nUsuario ) ) // .dbf temporal de usuario
   cInd := ( TempBase )
/*
   bqtabla  := {                             ;
		{ "NOMBRE"     ,  "C", 30, 0 }, ;
		{ "DIRECCION"  ,  "C", 30, 0 }, ;
		{ "CIUDAD"     ,  "C", 30, 0 }, ;
		{ "TELEFONO"   ,  "C", 30, 0 } ;
	      }
*/
   DbCreate( TEMPBASE, bqtabla )
   
   dbcloseall()
   if File( "&cInd" + ".Ntx" )
	Ferase( "&cInd" + '.Ntx' )
   endif

   usa_base( TempBase, .t., '', 5, .t. )
//      index on ( Nombre ) to TempBase //"&cIndice"
//   INDEX ON "Nombre" TO "&cInd"  

//   usa_base( TempBase, .t., TempBase, 5, .t. )

( tempbase )->( DbCreateIndex( "&cInd", "nombre",   ;
			{ || ( tempbase )->nombre }, .t. ) ) // set unique

   usa_base( "PACIENTE", .t., "nomhisto", 5, .t. )

   usa_base( "&BASE", .t., "", 5, .t. )  // se abre base a indagar, por alias

   usa_base( "HISTORIC", .t., "HISTORIA", 5, .t. )

   MsgInfo( 'Se va a procesar el archivo' + CRLF + ;
		"&BASE" + CRLF + CRLF + 'Es un proceso lento ..', 'Informacin' )

   do while !( Historic->( eof() ) )        // y se buscan los datos
 
      IF Historic->( &CampoH ) > 2 
	      bqrec1 := &CampoH
		 ( "&BASE" )->( DbGoto( bqrec1 ) ) 
	      bqlinea5 := ( "&BASE" )->( FieldGet( 1 ) ) + ;
			( "&BASE" )->( FieldGet( 2 ) ) + ;
			( "&BASE" )->( FieldGet( 3 ) ) + ;
			( "&BASE" )->( FieldGet( 4 ) )

			      if ( "&BASE" )->( FieldGet( 5 ) ) > 0 // Amplia
				 ( "&BASE" )->( DbGoto( FieldGet( 5 ) ) )
					     // hay 2 registros encadenados
				bqlinea5 += ( "&BASE" )->( FieldGet( 1 ) ) + ;
				( "&BASE" )->( FieldGet( 2 ) ) + ;
				( "&BASE" )->( FieldGet( 3 ) ) + ;
				( "&BASE" )->( FieldGet( 4 ) )
				 ( "&BASE" )->( dbgoto( bqrec1 ) )
			      endif

		      bqlinea5 := upper( bqlinea5 )

		      if cT1 $ bqlinea5 .or. cT2 $ bqlinea5 .or. ;
					cT3 $ bqlinea5 .or. cT4 $ bqlinea5
			If Paciente->( Dbseek( Historic->Historia ) ) .and. ;
			       Paciente->( Historia ) == Historic->( Historia )
				lHay := .t.
				mHis := Historic->Historia

		( TempBase )->( DbAppend() )

                ( TempBase )->( FieldPut( 1, OemToAnsi(Paciente->( FieldGet( 1 ) )) ) )
		( TempBase )->( FieldPut( 2, Paciente->( FieldGet( 2 ) ) ) )
		( TempBase )->( FieldPut( 3, Paciente->( FieldGet( 3 ) ) ) )
		( TempBase )->( FieldPut( 4, Paciente->( FieldGet( 4 ) ) ) )

		( TempBase )->( FieldPut( 5, Paciente->( FieldGet( 5 ) ) ) )
		( TempBase )->( FieldPut( 6, Paciente->( FieldGet( 6 ) ) ) )
		( TempBase )->( FieldPut( 7, Paciente->( FieldGet( 7 ) ) ) )
		( TempBase )->( FieldPut( 8, Paciente->( FieldGet( 8 ) ) ) )
		( TempBase )->( FieldPut( 9, Paciente->( FieldGet( 9 ) ) ) )
		( TempBase )->( FieldPut(10, Paciente->( FieldGet(10 ) ) ) )

			   Do While Historic->( Historia ) == mHis
				Historic->( DbSkip() )
			   EndDo
				lHay := .f.
				mHis := Historic->Historia
				Historic->( DbSkip( -1 ) )
			endif
		      endif
	ENdif

      Historic->( dbskip() )

   enddo

	DbSelectArea( TempBase )
	DbEval( { || ;
		 oAsc:Add( ( ( TempBase )->( FieldGet( 1 ) ) ) + ;
			   ( ( TempBase )->( FieldGet( 2 ) ) ) ), ;
		 oAsc:Add( ( ( TempBase )->( FieldGet( 3 ) ) ) + ;
			   ( ( TempBase )->( FieldGet( 4 ) ) ) ), ;
		 oAsc:Add( '' ) } )
		// Asi aparecen ordenados por apellidos en cFileAsc
		nI   := ( TempBase )->( LastRec() )
		oAsc := LineaTotal( nI, oAsc )

if lMail 
	MsgInfo( 'La base creada' + CRLF + 'es: ' + TempBase + ;
			CRLF + ;
			'para CORREO Automtico', 'Informacin' )
//		DbCloseAll() // dA FALLO ..
		( TempBase )->( DbCloseArea() )
		MemoWrit( cParMail, TempBase )
		 // se escribe para leer en WocGest
		WaitRun( 'WocGest ' + cParMail + '_' + TempBase )
endif

//DbCloseAll() // dA FALLO ..

Return oAsc
//---------
function xMsgMeter( bAction, cMsg, cTitle )

   local oDlg, oMeter, oText, oBtn, oFont
   local lEnd := .f.  //, lCancel := .f.
   local nVal := 0

   DEFAULT bAction := { || nil },;
           cMsg := "Processing...", cTitle := "Please, wait"

   DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -8

   DEFINE DIALOG oDlg FROM 5, 5 TO 10.4, 45 TITLE cTitle FONT oFont

   @ 0.2*nXpR, 0.5*nXpC  SAY oText VAR cMsg SIZE 130, 10 OF oDlg

   @ 1,   0.5  METER oMeter VAR nVal TOTAL 10 SIZE 150, 10 OF oDlg

   @  2.8*nXtR,  18*nXtC  BUTTON oBtn PROMPT "&Cancel" OF oDlg ;
      ACTION ( lCancel:= MsgYesNo( 'Tras terminar Base actual ..' + CRLF + ;
             'Desea INTERRUMPIR?..', 'Efectuando MANTENIMIENTO' ),;
              iif( lCancel, CursorWait(), CursorArrow()) ) ;
                        SIZE 32, 11

   // This block gets evaluated only the first time the DialogBox is painted !!!
   oDlg:bStart = { || Eval( bAction, oMeter, oText, oDlg, @lEnd, oBtn ),;
                      lEnd := .t., oDlg:End() }

   ACTIVATE DIALOG oDlg CENTERED ;
      VALID lEnd
   oFont:End()

return lCancel

